package NH230;

use Digest::MD5;
use File::Find;

sub new{

	#------------------------------------
	# Declare a objetc !!!
	#------------------------------------
	$class=shift;
	%arg=@_;
	$self={};
	bless $self, $class;

	#------------------------------------
	# Who are you !!!
	#------------------------------------
	foreach $key (sort keys(%ENV)) {
		if($key eq 'LOGNAME'){
			$loginname=$ENV{$key};
		} 
	}

	#------------------------------------
	# Assign the class argument !!!
	#------------------------------------
	$self->{DIR_COMPILER} = $arg{DIR_COMPILER};
	$self->{DIR_KERNEL} = $arg{DIR_KERNEL};
	$self->{DIR_RAMDISK} = $arg{DIR_RAMDISK};
	$self->{DIR_APTOOLS} = $arg{DIR_APTOOLS};
	$self->{DIR_PPCBOOT} = $arg{DIR_PPCBOOT};
	$self->{MODEL} = $arg{MODEL};
	$self->{LOGINNAME} = $loginname;


	return $self;
}




#################################################
#	Setup model
#   Parse ./ramdisk/ramdisk.MODEL/CONFIG 
#	file and return information !
#################################################
sub setup_model{

	$class = shift;
	$class->{MODEL} = shift;
	my $ret_conf={}; # return configure hash point !!
	my @ret_AP; #store the application here !!

	print "Setup $class->{MODEL} Model \n";

#------------------------------------
# Step1: parse CONFIG file
# ./ramdisk/ramdisk.MODEL/CONFIG
#------------------------------------
	my $path= "$class->{DIR_RAMDISK}/ramdisk.$class->{MODEL}/CONFIG";
	print "Open $path ....";
	open(CONFIG, "< $path") or die "Couldn't open $filename for reading: $!";
	print "OK \n";
	@config=<CONFIG>;                         
	close(CONFIG);

# open ok ...

	foreach $i ( @config ) {               # print the file content 

		if($i=~/^#/){
			next;
		}
		#--------------------------------------------------
		if($i =~ m/BusyBox=/){
			$i =~ s/BusyBox=//;
			chop($i);
			$i =~ s/^\s+//;
			$i =~ s/\s+$//;
			#print "BusyBox configure $i \n";
			$ret_conf->{BusyBox}=$i;
		}
		#--------------------------------------------------
		if($i =~ m/Linux=/){
			$i =~ s/Linux=//;
			chop($i);
			$i =~ s/^\s+//;
			$i =~ s/\s+$//;
			#print "Linux configure $i \n";
			$ret_conf->{Linux}=$i;
		}
		#--------------------------------------------------
		if($i =~ m/ramdisk=/){
			$i =~ s/ramdisk=//;
			chop($i);
			$i =~ s/^\s+//;
			$i =~ s/\s+$//;
			#print "Ramdisk configure $i \n";
			$ret_conf->{ramdisk}=$i;
		}
		#--------------------------------------------------
		if($i =~ m/AP=/){
			$i =~ s/AP=//;
			chop($i);
			$i =~ s/^\s+//;
			$i =~ s/\s+$//;
			#print "AP configure $i \n";
			push(@ret_AP,$i);
		}
		#--------------------------------------------------

	} # end of foreach 
	
	$ret_conf->{AP}=\@ret_AP;

	#
	#	$ret_conf
	#		|----{BusyBox}
	#		|----{Linux}
	#		|----{ramdisk}
	#		|----{AP}
	#				\-[AP1][AP2][AP3]....
	#
	#

# parsing ok ...

	return $ret_conf;

}


#####################################
#	Make the Brand.mk file
#####################################
sub make_BRAND_mk{

	$class = shift;
	$arg = shift;

	$ap_array = $arg->{AP};

#--------------------------------------------------------
# Step2: Generate the BRAND.mk
# ./ramdisk/BRAND.mk
# Generator all makefile target for all applications !
#--------------------------------------------------------
#foreach $tmp (@{$ap_array}) {
#	print "make_BRAND_mk $tmp \n";
#}

	#open append, ">>$class->{DIR_RAMDISK}/../user/Rule.mk" or die $!;
	#print append "MODEL=$class->{MODEL}\n";
	#close append;
	system("sed -i /^MODEL=/s/.*/MODEL=$class->{MODEL}/ $class->{DIR_RAMDISK}/../user/Rule.mk");

	open (FILE,">$class->{DIR_RAMDISK}/BRAND.mk");

	# define the model
	print FILE "MODEL=$class->{MODEL}\n";
	print FILE "SOURCE_DIR=../$class->{DIR_APTOOLS}\n";

	# if you have special ramdisk model
	if(-e "$class->{DIR_RAMDISK}/$arg->{ramdisk}"){
		print FILE "RAMDISK=$arg->{ramdisk} \n";	
	}else{
		print "\x1b[41m Can't find the ramdisk file ./$class->{DIR_RAMDISK}/$arg->{ramdisk} (ERROR) \x1b[m \n";	
		exit(0);
	}
	
	# define your login name
	foreach $key (sort keys(%ENV)) {
		if($key eq 'LOGNAME'){
			print FILE "LOGIN_NAME=$ENV{$key}\n";
		} 
	} 

	#####################
	#	make all
	#####################
	print FILE "all: \n";
	foreach $val (@{$ap_array}) {
		print FILE "\tmake -C \$(SOURCE_DIR)/$val all; \n";
	}
	#####################
	#	make clean
	#####################
	print FILE "clean: \n";
	foreach $val (@{$ap_array}) {
		print FILE "\tmake -C \$(SOURCE_DIR)/$val clean; \n";
	}
	#####################
	#	make install
	#####################
	print FILE "install: prepare \n";
	print FILE "\tsudo rm -rf root/*; \n";
	print FILE "\tsudo rm -rf aptools/*; \n";
	foreach $val (@{$ap_array}) {
		print FILE "\tmake -C \$(SOURCE_DIR)/$val install; \n";
	}
	#########################
	#	make clean_all_user
	#########################
	print FILE "clean_all_user: \n";
	opendir(DIR,$self->{DIR_APTOOLS})||die "Could not find the $self->{DIR_APTOOLS} directory !!!";
	@dir=readdir(DIR);	
	foreach $val (@dir) {
		# The dir must include Makefile 
		if(-e "$self->{DIR_APTOOLS}/$val/Makefile"){
			print FILE "\tmake -C \$(SOURCE_DIR)/$val clean; \n";
		}
	}
	closedir DIR;


	close (FILE);


}




#####################################
#	Check all what we need !!
#	( all directory that project need !!)
#####################################
sub chk_environment{
$class=shift;

#-------------------
#  cross compiler 
#-------------------
if( -e $class->{DIR_COMPILER}){
	printf("======================================================\n");
	printf(" Cross-compiler in /opt  (OK) \n");
	printf("======================================================\n");	
}else{
	printf("======================================================\n");
	printf(" You don't install the cross-compiler in /opt  (Exit) \n");
	printf("======================================================\n");			
	return 1;
}

#-------------------
#  Kernel
#-------------------
if( -e $class->{DIR_KERNEL}){
	printf("======================================================\n");
	printf(" Check linux kernel  (OK) \n");
	printf("======================================================\n");	
}else{
	printf("======================================================\n");
	printf(" Your linux is not exist  (Exit) \n");
	printf("======================================================\n");			
	return 2;
}

#-------------------
#  Ramdisk
#-------------------
if( -e $class->{DIR_RAMDISK}){
	printf("======================================================\n");
	printf(" Check ramdisk directory  (OK) \n");
	printf("======================================================\n");	
}else{
	printf("======================================================\n");
	printf(" Your ramdisk directory is not exist  (Exit) \n");
	printf("======================================================\n");			
	return 3;
}

#-------------------
#  DIR_APTOOLS
#-------------------
if( -e $class->{DIR_APTOOLS}){
	printf("======================================================\n");
	printf(" Check application tools directory  (OK) \n");
	printf("======================================================\n");	
}else{
	printf("======================================================\n");
	printf(" Your application tools directory is not exist (Exit) \n");
	printf("======================================================\n");			
	return 4;
}

#-------------------
#  DIR_PPCBOOT
#-------------------
if( -e $class->{DIR_PPCBOOT}){
	printf("======================================================\n");
	printf(" Check ppcboot directory  (OK) \n");
	printf("======================================================\n");	
}else{
	printf("======================================================\n");
	printf(" Your ppcboot directory is not exist (Exit) \n");
	printf("======================================================\n");			
	return 5;
}

	return 0;  # every thing is OK !!!

}



#-----------------------------------------------------------------

###################
#  OK
###################
sub kernel_make_distclean{

my $class=shift;

		if( system("make -C $class->{DIR_KERNEL} distclean") != 0){
			printf("======================================================\n");
			printf("	Kernel distclean FAIL -_- !!  (Exit)              \n");
			printf("======================================================\n");				
			exit(0);	
		}else{
			printf("======================================================\n");
			printf("	Kernel distclean OK !!	                          \n");
			printf("======================================================\n");		
		}
}

#-----------------------------------------------------------------

###################
#  OK
###################
sub kernel_make_oldconfig{

		my $class=shift;
		my $arg=shift;

			if( system("cp $class->{DIR_RAMDISK}/$arg->{Linux} $class->{DIR_KERNEL}/.config") != 0){
					printf("======================================================\n");
					printf(" No model configure file in kernel source !! (Exit)   \n");
					printf("======================================================\n");		
					exit(0);	
			}else{
					printf("======================================================\n");
					printf(" Copy configure file OK !!                            \n");
					printf("======================================================\n");				
			}

			if( system("make -C $class->{DIR_KERNEL} oldconfig") != 0){
					printf("======================================================\n");
					printf(" Make kernel config fail !! (Exit)                    \n");
					printf("======================================================\n");		
					exit(0);	
			}else{
					printf("======================================================\n");
					printf(" Make kernel config OK !!                             \n");
					printf("======================================================\n");	
			}

}

#-----------------------------------------------------------------

###################
#  OK
###################
sub kernel_make_dep{

	my $class = shift;
	
	if( system("make -C $class->{DIR_KERNEL} dep") != 0){
			printf("======================================================\n");
			printf(" Make kernel dep fail !! (Exit)                    \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Make kernel dep OK !!                             \n");
			printf("======================================================\n");	
	}

}

#-----------------------------------------------------------------

###################
#  OK
###################
sub kernel_make_clean{

	my $class = shift;

	if( system("make -C $class->{DIR_KERNEL} clean") != 0){
			printf("======================================================\n");
			printf(" Make kernel clean fail !! (Exit)                    \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Make kernel clean OK !!                             \n");
			printf("======================================================\n");	
	}

}

#-----------------------------------------------------------------

###################
#  OK
###################
sub kernel_make_zImage{

	my $class = shift;

	if( system("make -C $class->{DIR_KERNEL} zImage") != 0){
			printf("======================================================\n");
			printf(" Make kernel zImage fail !! (Exit)                    \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Make kernel zImage OK !!                             \n");
			printf("======================================================\n");	
	}
}

#-----------------------------------------------------------------

###################
#  OK
###################
sub kernel_mkimg{

	my $class = shift;

	my $mkimg="./$class->{DIR_RAMDISK}/mkimage";
	my $vmlinux="./$class->{DIR_KERNEL}/arch/ppc/boot/images/vmlinux.gz";
	if( system("rm -f kernel.bin; \
				$mkimg -A ppc -C gzip -T kernel -O linux -a 00000000 -e 0000000c -n \"kernel\" -d $vmlinux ./kernel.bin; \
			") != 0){
			printf("======================================================\n");
			printf(" Create kernel image fail !! (Exit)                   \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Create kernel image OK !!                            \n");
			printf("======================================================\n");	
	}


	foreach $key (sort keys(%ENV)) {
		if($key eq 'LOGNAME'){
			$logname=$ENV{$key};
		} 
   } 
	if( system("mkdir -p /tftpboot/$logname; \
		    mv -f kernel.bin /tftpboot/$logname/linux_nh230a_$class->{MODEL}.bin; \
		    rm -rf /tftpboot/$logname/linux.bin; \
		    ln -s /tftpboot/$logname/linux_nh230a_$class->{MODEL}.bin /tftpboot/$logname/linux.bin; \
		  ") != 0 ){
			printf("======================================================\n");
			printf(" Move kernel image to /tftpboot/$logname fail!! (Exit)\n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Move kernel image to /tftpboot/$logname OK !!        \n");
			printf("======================================================\n");	
	}

}

#-----------------------------------------------------------------

###################
#  OK
###################
sub ramdisk_make_all{

	my $class = shift;

	if( system("make -C $class->{DIR_RAMDISK} all") != 0){
			printf("======================================================\n");
			printf(" Make ramdisk all fail !! (Exit)                      \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Make ramdisk all OK !!                               \n");
			printf("======================================================\n");	
	}
}

#-----------------------------------------------------------------

###################
#  OK
###################
sub ramdisk_make_install{

	my $class = shift;

	if( system("rm -r -f $class->{DIR_RAMDISK}/aptools/* ") != 0){
			printf("======================================================\n");
			printf(" Remove aptools ap fail !! (Exit)                     \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Remove aptools OK !!                                 \n");
			printf("======================================================\n");	
	}
	
	if( system("make -C $class->{DIR_RAMDISK} install") != 0){
			printf("======================================================\n");
			printf(" Make ramdisk install fail !! (Exit)                  \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Make ramdisk install OK !!                           \n");
			printf("======================================================\n");	
	}
}

#-----------------------------------------------------------------

###################
#  OK
###################
sub ramdisk_make_image{

	my $class = shift;

	if( system("make -C $class->{DIR_RAMDISK} image") != 0){
			printf("======================================================\n");
			printf(" Make ramdisk image fail !! (Exit)                    \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Make ramdisk image OK !!                             \n");
			printf("======================================================\n");	
	}
}

#-----------------------------------------------------------------

###################
#  OK
###################
sub ramdisk_make_clean{

	my $class = shift;

	if( system("make -C $class->{DIR_RAMDISK} clean") != 0){
			printf("======================================================\n");
			printf(" Make ramdisk clean fail !! (Exit)                    \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Make ramdisk clean OK !!                             \n");
			printf("======================================================\n");	
	}
}

#-----------------------------------------------------------------

###################
#  OK
###################
sub ramdisk_make_distclean{

	my $class = shift;

	if( system("make -C $class->{DIR_RAMDISK} distclean") != 0){
			printf("======================================================\n");
			printf(" Make ramdisk distclean fail !! (Exit)                \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Make ramdisk distclean OK !!                             \n");
			printf("======================================================\n");	
	}
}

#-----------------------------------------------------------------

###################
#  OK
###################
sub ramdisk_config_busybox{

	my $class = shift;
	my $arg = shift;

	system("rm -f $class->{DIR_APTOOLS}/busybox/.config");
	system("cp  $class->{DIR_RAMDISK}/$arg->{BusyBox} $class->{DIR_APTOOLS}/busybox/.config");
	if( system("make -C $class->{DIR_APTOOLS}/busybox/ oldconfig") != 0){
			printf("======================================================\n");
			printf(" Make $class->{DIR_APTOOLS}/busybox oldconfig fail !! (Exit) \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Make $class->{DIR_APTOOLS}/busybox oldconfig OK !!          \n");
			printf("======================================================\n");	
	}
}

#-----------------------------------------------------------------

sub ppcboot_clean{
	my $class = shift;
	
	if( system("make -C $class->{DIR_PPCBOOT} distclean") != 0){
			printf("======================================================\n");
			printf(" Make PPC boot clean fail !! (Exit) \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Make PPC boot clean OK !!          \n");
			printf("======================================================\n");	
	}

}

sub ppcboot_config{
	my $class = shift;
	
	if( system("make -C $class->{DIR_PPCBOOT} Sandpoint8245_config") != 0){
			printf("======================================================\n");
			printf(" Make PPC boot configure fail !! (Exit) \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Make PPC boot configure OK !!          \n");
			printf("======================================================\n");	
	}

}

sub ppcboot_dep{
	my $class = shift;
	
	if( system("make -C $class->{DIR_PPCBOOT} dep")!= 0){
			printf("======================================================\n");
			printf(" Make PPC boot dep fail !! (Exit) \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Make PPC boot dep OK !!          \n");
			printf("======================================================\n");	
	}

}

sub ppcboot_make{
	my $class = shift;
	
	if( system("make -C $class->{DIR_PPCBOOT} ") != 0){
			printf("======================================================\n");
			printf(" Make PPC boot fail !! (Exit) \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Make PPC boot OK !!          \n");
			printf("======================================================\n");	
	}
 
	if( system("cp -f $class->{DIR_PPCBOOT}/ppcboot.bin /tftpboot/$class->{LOGINNAME}/ppcboot.bin ") != 0){
			printf("======================================================\n");
			printf(" Copy ppcboot to /tftoboot/$class->{LOGINNAME} fail !! (Exit) \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Copy ppcboot to /tftpboot/$class->{LOGINNAME}  OK !!          \n");
			printf("======================================================\n");	
	}


}

#-----------------------------------------------------------------
sub flash_image_make{
	$class = shift;
	$data = shift;	
	
	# == all partation space (KB) ==
	my $spcce_ppcboot = 128*1024;
	my $space_linux = 1536*1024;
	my $space_ramdisk1 = 896*1024;
	my $space_ramdisk2 = 1472*1024;

	# == all paratatio start address ==
	my $add_ppcboot = 0x00300000;
	my $add_linux = 0x00010000;
	my $add_ramdisk1 = 0x00320000;
	my $add_ramdisk2 = 0x00190000;

	my $ver=$data->{VERSION};
	$ver =~ s/[()]/_/g;

	my $head="/tftpboot/$class->{LOGINNAME}/NH230A_$class->{MODEL}_$ver.flash";
	my $kernel="/tftpboot/$class->{LOGINNAME}/linux_nh230a_$class->{MODEL}.bin";
	my $ramdisk1="/tftpboot/$class->{LOGINNAME}/ramdisk_nh230a_$class->{MODEL}.bin";
	my $ramdisk2="/tftpboot/$class->{LOGINNAME}/ramdisk2_nh230a_$class->{MODEL}.tgz";
	my $ppcboot="/tftpboot/$class->{LOGINNAME}/ppcboot.bin";

	find( sub { $kernel_size = $filesize if ($filesize=-s $_) < $space_linux; } , "$kernel" );
	find( sub { $ramdisk_size = $filesize if ($filesize=-s $_) < $space_ramdisk1; } , "$ramdisk1" );
	find( sub { $ramdisk2_size = $filesize if ($filesize=-s $_) < $space_ramdisk2; } , "$ramdisk2" );
	find( sub { $ppcboot_size = $filesize if ($filesize=-s $_) < $spcce_ppcboot; } , "$ppcboot" );

	print "($ppcboot_size)($kernel_size)($ramdisk_size)($ramdisk2_size) \n";

	#-----------------------------------
	# Is every body here of too fat?
	#-----------------------------------
	if (!$ppcboot_size) {
		print "You lost ppcboot image or your image too fat!! (Please check)\n";
		exit(0);
	}
	if (!$kernel_size) {
		print "You lost kernel image or your image too fat!! (Please check)\n";
		exit(0);
	}
	if (!$ramdisk_size) {
		print "You lost ramdisk image or your image too fat !! (Please check)\n";
		exit(0);
	}
	if (!$ramdisk2_size) {
		print "You lost ramdisk2 image or your image too fat !! (Please check)\n";
		exit(0);
	}


	#######################
	# Make a empty image
	#######################
	if( system("dd if=/dev/zero of=$head bs=1M count=4") != 0){
			printf("======================================================\n");
			printf(" Make empty image error !! (Exit) \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Make empty image OK !!    \n");
			#printf("dd if=/dev/zero of=$head bs=1M count=4 \n");
			printf("======================================================\n");	
	}


	############################################
	# Merge ((Image - (kernel))
	############################################
	if( system("dd if=$kernel of=$head bs=1 seek=$add_linux") != 0){
			printf("======================================================\n");
			printf(" Merge ((Image - (kernel)) error !! (Exit) \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Merge ((Image - (kernel)) OK !! \n");
			#printf("dd if=$kernel of=$head bs=1 seek=$add_linux \n");
			printf("======================================================\n");	
	}


	#########################################################################
	# Merge (Image - (kernel) - (ramdisk2))
	#########################################################################
	if( system("dd if=$ramdisk2 of=$head bs=1 seek=$add_ramdisk2") != 0){
			printf("======================================================\n");	
			printf(" Merge (Image - (kernel) - (ramdisk2)) error !! (Exit) \n");
			printf("======================================================\n");	
			exit(0);	
	}else{
			printf("======================================================\n");	
			printf(" Merge (Image - (kernel) - (ramdisk2))  OK !!  \n");
			#printf("dd if=$ramdisk2 of=$head bs=1 seek=$add_ramdisk2 \n");
			printf("======================================================\n");	
	}


	###############################
	# Merge (Image - (kernel) - (ramdisk2) - (ppcboot))
	###############################
	if( system("dd if=$ppcboot of=$head bs=1 seek=$add_ppcboot") != 0){
			printf("======================================================\n");
			printf(" Merge (Image - (kernel) - (ramdisk2) - (ppcboot)) error !! (Exit) \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Merge (Image - (kernel) - (ramdisk2) - (ppcboot)) OK !!   $count \n");
			#printf("dd if=$ppcboot of=$head bs=1 seek=$add_ppcboot \n");
			printf("======================================================\n");	
	}



	###########################################################
	# Merge (Image - (kernel) - (ramdisk2) - (ppcboot) - (ramdisk1))
	###########################################################
	if( system("dd if=$ramdisk1 of=$head bs=1 seek=$add_ramdisk1") != 0){
			printf("======================================================\n");	
			printf(" Merge (Image - (kernel) - (ramdisk2) - (ppcboot) - (ramdisk1)) error !! (Exit) \n");
			printf("======================================================\n");	
			exit(0);	
	}else{
			printf("======================================================\n");	
			printf(" Merge (Image - (kernel) - (ramdisk2) - (ppcboot) - (ramdisk1)) OK !!  \n");
			#printf("dd if=$ramdisk1 of=$head bs=1 seek=$add_ramdisk1 \n");
			printf("======================================================\n");	
	}



}


#==========================================================================
#	Check the Kernel image !!
#	When make webupgrade image, we should check kernel exist or not !
#---------------------------------------------------=======================
sub kernel_file_chk{
	$claee = shift;

	if( -e "/tftpboot/$class->{LOGINNAME}/linux_nh230a_$class->{MODEL}.bin"){
		print "Check Linux kernel /tftpboot/$class->{LOGINNAME}/linux_nh230a_$class->{MODEL}.bin OK \n";
		return 0; #OK
	}else{
		print qq^\x1b[41m
No Linux kernel /tftpboot/$class->{LOGINNAME}/linux_nh230a_$class->{MODEL}.bin \n Web upgrade image will not been created !!! \x1b[m
[Perss any key to continue]
^;
		<>;
		return 1; #no kernel !!
	}

}

##############################################################################
# This method is used to parse the ramdisk/ramdisk.XX/Release.log file
##############################################################################
sub release_log_parse{
	$class = shift;
	$ret={};
	#====================================================
	# The data is from Release.log
	#====================================================
	$log_path = "ramdisk/ramdisk.$class->{MODEL}/Release.log";

	open(RELEASE_LOG,"< $log_path") or die "The $log_path open fail !!!";
	print "Open ramdisk/ramdisk.$class->{MODEL}/Release.log OK !! \n";
	@release_log=<RELEASE_LOG>;
	close(RELEASE_LOG);
	foreach $tmp (@release_log) {
		if($tmp =~ /^#/){
			next;
		}
		if($tmp =~ /PRODUCT_ID/){
			$tmp =~ s/PRODUCT_ID=//;
			$tmp =~ s/^\s+//;
			$tmp =~ s/\s+$//;
			$ret->{PRODUCT_ID}=$tmp;
#			print "PRODUCT_ID=($tmp) \n";
		}
		if($tmp =~ /CUSTOMER/){
			$tmp =~ s/CUSTOMER=//;
			$tmp =~ s/^\s+//;
			$tmp =~ s/\s+$//;
			$ret->{CUSTOMER}=$tmp;
#			print "CUSTOMER=($tmp) \n";
		}		
		if($tmp =~ /MAGICSUM/){
			$tmp =~ s/MAGICSUM=//;
			$tmp =~ s/^\s+//;
			$tmp =~ s/\s+$//;
			#+++++++++++++++
			# MD5 encoding
			#+++++++++++++++
			    $md5 = Digest::MD5->new;
				$md5->add($tmp);
				$md5_code = $md5->hexdigest;

			$ret->{MAGICSUM}=$md5_code;
#			print "MAGICSUM=($md5_code) \n";
		}	
		if($tmp =~ /VERSION/){
			$tmp =~ s/VERSION=//;
			$tmp =~ s/^\s+//;
			$tmp =~ s/\s+$//;
			$ret->{VERSION}=$tmp;
#			print "VERSION=($tmp) \n";
			last; # I just need the first VERSION !!
		}			

	}
	return $ret;

}

##############################################################################
# This method is used to make the /etc/version file in the root file system
##############################################################################
# Format: (/etc/version)
#	MAGICNUM='md5_encoding(MAGICSUM)'
#	PRODUCT_ID='NHxxx'
#	CUSTOMER='NONBRAND'
#	VERSION='V1.01(01-21-2005)'
#
sub make_etc_version{
	$class = shift;
	$data = shift;

	###------------------------
	# Check the ramdisk.model 
	###------------------------
	if( system("mkdir -p $class->{DIR_RAMDISK}/ramdisk.$class->{MODEL}/etc") != 0){
			printf("======================================================\n");
			printf(" mkdir -p $class->{DIR_RAMDISK}/ramdisk.$class->{MODEL}/etc !! (Exit) \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" mkdir -p $class->{DIR_RAMDISK}/ramdisk.$class->{MODEL}/etc  OK !!    \n");
			printf("======================================================\n");	
	}

	my $path = "$class->{DIR_RAMDISK}/ramdisk.$class->{MODEL}/etc/version";
	print "$path OK !! \n";
	open(VER,"+> $path") or die "Open file error !!";
	print "Open $path OK !! \n";
	print VER "MAGICNUM="."\'"."$data->{MAGICSUM}"."\'"."\n";
	print VER "PRODUCT_ID="."\'"."$data->{PRODUCT_ID}"."\'"."\n";
	print VER "CUSTOMER="."\'"."$data->{CUSTOMER}"."\'"."\n";
	print VER "VERSION="."\'"."$data->{VERSION}"."\'"."\n";
	close(VER);

}

    
##############################################################################
# This method is used to make the webupgrade image header
##############################################################################
# Format: ( header 512 bytes )
#	MAGICNUM=md5_encoding(MAGICSUM)
#	PRODUCT_ID=NHxxx
#	CUSTOMER=NONBRAND
#	VERSION=V1.01(01-21-2005)
#	Linux=Kernel_size
#	root=Ramdisk.bin_size
#	ramdisk2=Ramdisk2.tgz_size
#
sub make_webupgrade_header{
	$class = shift;
	$data = shift;

	##+++++++++++++++++++++++++++
	# I need every size first !!
	##+++++++++++++++++++++++++++
	find( sub {$kernel_size=-s $_;},"/tftpboot/$class->{LOGINNAME}/linux_nh230a_$class->{MODEL}.bin" );
	find( sub {$ramdisk_size=-s $_;},"/tftpboot/$class->{LOGINNAME}/ramdisk_nh230a_$class->{MODEL}.bin" );
	find( sub {$ramdisk2_size=-s $_;},"/tftpboot/$class->{LOGINNAME}/ramdisk2_nh230a_$class->{MODEL}.tgz" );

	print "($kernel_size)($ramdisk_size)($ramdisk2_size) \n";

	if($kernel_size > 1572864){
		print " Your kernel too big !! ";
		exit(0);
	}
	if($ramdisk_size > 917504){
		print " Your root file system too big !! ";
		exit(0);
	}	
	if($ramdisk2_size > 1507328){
		print " Your ramdisk2.tgz too big !! ";
		exit(0);
	}
	if(!(($kernel_size)&&($ramdisk_size)&&($ramdisk2_size)))
	{
		print "File Error kernel or ramdisk or ramdisk2 not exist !! (Please check)\n";
		exit(0);
	}
	# OK all files ready !!

	my $path = "$class->{DIR_RAMDISK}/ramdisk.$class->{MODEL}/Image_header";
	print "$path OK !! \n";
	open(HEADER,"+> $path") or die "Open file error !!";
	print "Open $path OK !! \n";
	print HEADER "MAGICNUM=$data->{MAGICSUM}\n";
	print HEADER "PRODUCT_ID=$data->{PRODUCT_ID}\n";
	print HEADER "CUSTOMER=$data->{CUSTOMER}\n";
	print HEADER "VERSION=$data->{VERSION}\n";
	print HEADER "LINUX=$kernel_size\n";
	print HEADER "ROOT=$ramdisk_size\n";
	print HEADER "RAMDISK2=$ramdisk2_size\n";
	close(HEADER);

}



##############################################################################
# Make web upgrade image
##############################################################################
sub make_webupgrade_image{
	$class = shift;
	$data = shift;	

	my $ver=$data->{VERSION};
	$ver =~ s/[()]/_/g;

	my $head="/tftpboot/$class->{LOGINNAME}/NH230A_$class->{MODEL}_$ver.web";
	my $kernel="/tftpboot/$class->{LOGINNAME}/linux_nh230a_$class->{MODEL}.bin";
	my $ramdisk1="/tftpboot/$class->{LOGINNAME}/ramdisk_nh230a_$class->{MODEL}.bin";
	my $ramdisk2="/tftpboot/$class->{LOGINNAME}/ramdisk2_nh230a_$class->{MODEL}.tgz";

	find( sub {$kernel_size=-s $_;},"/tftpboot/$class->{LOGINNAME}/linux_nh230a_$class->{MODEL}.bin" );
	find( sub {$ramdisk_size=-s $_;},"/tftpboot/$class->{LOGINNAME}/ramdisk_nh230a_$class->{MODEL}.bin" );
	find( sub {$ramdisk2_size=-s $_;},"/tftpboot/$class->{LOGINNAME}/ramdisk2_nh230a_$class->{MODEL}.tgz" );
	print "($kernel_size)($ramdisk_size)($ramdisk2_size) \n";


	if( system("cp -f $class->{DIR_RAMDISK}/ramdisk.$class->{MODEL}/Image_header $head") != 0){
			printf("======================================================\n");
			printf(" Create $head error !! (Exit) \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" create $head  OK !!    \n");
			printf("======================================================\n");	
	}

	#######################
	# Merge (head)-(kernel)
	#######################
	$count = 512;
	if( system("dd if=$kernel of=$head bs=1 seek=$count") != 0){
			printf("======================================================\n");
			printf(" Merge (head)-(kernel) error !! (Exit) \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Merge (head)-(kernel) $path  OK !!   $count \n");
			printf("======================================================\n");	
	}

	#######################
	# Merge (head-kernel)-(ramdisk1)
	#######################
	$count = 512 + $kernel_size;
	if( system("dd if=$ramdisk1 of=$head bs=1 seek=$count") != 0){
			printf("======================================================\n");
			printf(" Merge (head-kernel)-(ramdisk1) error !! (Exit) \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Merge (head-kernel)-(ramdisk1) $path  OK !!  $count   \n");
			printf("======================================================\n");	
	}

	#######################
	# Merge (head-kernel-ramdisk1)-(ramdisk2)
	#######################
	$count = 512 + $kernel_size + $ramdisk_size;
	if( system("dd if=$ramdisk2 of=$head bs=1 seek=$count") != 0){
			printf("======================================================\n");
			printf(" Merge (head-kernel-ramdisk1)-(ramdisk2) error !! (Exit) \n");
			printf("======================================================\n");		
			exit(0);	
	}else{
			printf("======================================================\n");
			printf(" Merge (head-kernel-ramdisk1)-(ramdisk2) $path  OK !!  $count  \n");
			printf("======================================================\n");	
	}


}








1;


