/* Original file for gcc.3.0.2: built/mips-elf/lib/ldscripts/elf32ebmip.x */
/* If OUTPUT_FORMAT is not set, it uses the default compiled in. */
OUTPUT_ARCH(ppc)
ENTRY(_start)
/* Do we need any of these for elf?
   __DYNAMIC = 0;    */
SECTIONS
{
/* Read-only sections, merged into text segment: */
  . = 0x0;	/* start at memory location 0 */
  .interp : { *(.interp) }
/* ------------------------------------------------------------------------ */
  .reginfo : { *(.reginfo) }
/* ------------------------------------------------------------------------ */
  .hash : { *(.hash) }
  .dynsym : { *(.dynsym) }
  .dynstr : { *(.dynstr) }
  .gnu.version : { *(.gnu.version) }
  .gnu.version_d : { *(.gnu.version_d) }
  .gnu.version_r : { *(.gnu.version_r) }
/* ------------------------------------------------------------------------ */
  .init : {
    KEEP (*(.init))
  } =0
  .plt : { *(.plt) }
/* ------------------------------------------------------------------------ */
  .text : {
    _ftext = . ;
    *(.text)
    *(.text.*)
    *(.stub)
  /* .gnu.warning sections are handled specially by elf32.em.  */
    *(.gnu.warning)
    *(.gnu.linkonce.t.*)
    *(.mips16.fn.*) *(.mips16.call.*)
  } =0
  .fini : {
    KEEP (*(.fini))
  } =0
/* ------------------------------------------------------------------------ */
  _etext = .;
  PROVIDE(__etext = .);
  PROVIDE(etext = .);
/* Adjust the address for the data segment.  We want to adjust up to
   the same address within the page on the next page up.  */
/* ------------------------------------------------------------------------ */
  .eh_frame : { KEEP (*(.eh_frame)) }
  .gcc_except_table : { *(.gcc_except_table) }
/* ------------------------------------------------------------------------ */
  .ctors : {
/* gcc uses crtbegin.o to find the start of the constructors, so we make sure
   it is first.  Because this is a wildcard, it doesn't matter if the user
   does not actually link against crtbegin.o; the linker won't look for a
   file to match a wildcard.  The wildcard also means that it doesn't matter
   which directory crtbegin.o is in.  */
    KEEP (*crtbegin.o(.ctors))
/* We don't want to include the .ctor section from from the crtend.o file
   until after the sorted ctors.  The .ctor section from the crtend file
   contains the end of ctors marker and it must be last */
    KEEP (*(EXCLUDE_FILE (*crtend.o ) .ctors))
    KEEP (*(SORT(.ctors.*)))
    KEEP (*(.ctors))
  }
  .dtors : {
    KEEP (*crtbegin.o(.dtors))
    KEEP (*(EXCLUDE_FILE (*crtend.o ) .dtors))
    KEEP (*(SORT(.dtors.*)))
    KEEP (*(.dtors))
  }
/* ------------------------------------------------------------------------ */
  .rodata : { *(.rodata) *(.rodata.*) *(.gnu.linkonce.r.*) }
  .rodata1 : { *(.rodata1) }
/* ------------------------------------------------------------------------ */
/* Put data right after text, no gap. */
  _fdata = . ;
  .data : {
    *(.data)
    *(.data.*)
    *(.gnu.linkonce.d.*)
    SORT(CONSTRUCTORS)
  }
  .data1 : { *(.data1) }
/* ------------------------------------------------------------------------ */
  _gp = ALIGN(16) + 0x7ff0;
  PROVIDE(_gp_disp = .);
  PROVIDE(__global_pointer = .);
  PROVIDE(_DYNAMIC = 0);
  PROVIDE(DYNAMIC = 0);

  .got : { *(.got.plt) *(.got) }
  .dynamic : { *(.dynamic) }	/* small data, used by GP */
/* We want the small data sections together, so single-instruction offsets
   can access them all, and initialized data all before uninitialized, so we
   can shorten the on-disk segment size.  */
  .sdata : {
    *(.sdata)
    *(.sdata.*)
    *(.gnu.linkonce.s.*)
  }
  .lit8 : { *(.lit8) }
  .lit4 : { *(.lit4) }
  .sdata2 : {
    *(.sdata2)
    *(.sdata2.*)
    *(.gnu.linkonce.s2.*)
  }
/* ------------------------------------------------------------------------ */
  _edata = .;
  PROVIDE(edata = .);
/* ------------------------------------------------------------------------ */
  __bss_start = .;
  _fbss = .;
  .sbss : {
    PROVIDE(__sbss_start = .);
    PROVIDE(___sbss_start = .);
    *(.dynsbss)
    *(.sbss)
    *(.sbss.*)
    *(.gnu.linkonce.sb.*)
    *(.scommon)
    PROVIDE(__sbss_end = .);
    PROVIDE(___sbss_end = .);
  }
  .sbss2 : {
    *(.sbss2)
    *(.sbss2.*)
    *(.gnu.linkonce.sb2.*)
  }
  .bss : {
    *(.dynbss)
    *(.bss)
    *(.bss.*)
    *(.gnu.linkonce.b.*)
    *(COMMON)
/* Align here to ensure that the .bss section occupies space up to _end.
   Align after .bss to ensure correct alignment even if the .bss section
   disappears because there are no input sections.  */
    . = ALIGN(32 / 8);
  }
  . = ALIGN(32 / 8);
  _end = .;
  PROVIDE(end = .);
/* ------------------------------------------------------------------------ */
  .shstrtab 0 : { *(.shstrtab) }
/* ------------------------------------------------------------------------ */
  /DISCARD/ : {
    *(.rela)
    *(.rela.*)
    *(.symtab)
    *(.pdr)
    *(.comment)
    *(.mdebug)
    *(.mdebug.*)
    *(.strtab)
  }
/* ------------------------------------------------------------------------ */
/* Put the value _fdata into a section, so that loader can find it easily. */
/* _fdata is changeable data, used by fork. */
/*   . = ALIGN(0x4); */
/*   ._fdata 0 (NOLOAD) : { LONG(_fdata) } */
/* ------------------------------------------------------------------------ */
  .symtab 0 (NOLOAD) : { *(.symtab) }
  .strtab 0 (NOLOAD) : { *(.strtab) }
/* ------------------------------------------------------------------------ */
  .rel.init 0 : { *(.rel.init) }
  .rel.text 0 : {
    *(.rel.text)
    *(.rel.text.*)
    *(.rel.gnu.linkonce.t.*)
  }
  .rel.rodata 0 : {
    *(.rel.rodata)
    *(.rel.rodata.*)
    *(.rel.gnu.linkonce.r.*)
  }
  .rel.data 0 : {
    *(.rel.data)
    *(.rel.data.*)
    *(.rel.gnu.linkonce.d.*)
  }
  .rel.fini 0 : { *(.rel.fini) }
  .rel.ctors 0 : { *(.rel.ctors) }
  .rel.dtors 0 : { *(.rel.dtors) }
  .rel.got 0 : { *(.rel.got) }
  .rel.sdata 0 : {
    *(.rel.sdata)
    *(.rel.sdata.*)
    *(.rel.gnu.linkonce.s.*)
  }
  .rel.sbss 0 : {
    *(.rel.sbss)
    *(.rel.sbss.*)
    *(.rel.gnu.linkonce.sb.*)
  }
  .rel.sdata2 0 : {
    *(.rel.sdata2)
    *(.rel.sdata2.*)
    *(.rel.gnu.linkonce.s2.*)
  }
  .rel.sbss2 0 : {
    *(.rel.sbss2)
    *(.rel.sbss2.*)
    *(.rel.gnu.linkonce.sb2.*)
  }
  .rel.bss 0 : {
    *(.rel.bss)
    *(.rel.bss.*)
    *(.rel.gnu.linkonce.b.*)
  }
  .rel.plt 0 : { *(.rel.plt) }
/* ------------------------------------------------------------------------ */
/*
  .rela.init 0 : { *(.rela.init) }
  .rela.text 0 : {
    *(.rela.text)
    *(.rela.text.*)
    *(.rela.gnu.linkonce.t.*)
  }
  .rela.fini 0 : { *(.rela.fini) }
  .rela.rodata 0 : {
    *(.rela.rodata)
    *(.rela.rodata.*)
    *(.rela.gnu.linkonce.r.*)
  }
  .rela.data 0 : {
    *(.rela.data)
    *(.rela.data.*)
    *(.rela.gnu.linkonce.d.*)
  }
  .rela.ctors 0 : { *(.rela.ctors) }
  .rela.dtors 0 : { *(.rela.dtors) }
  .rela.got 0 : { *(.rela.got) }
  .rela.sdata 0 : {
    *(.rela.sdata)
    *(.rela.sdata.*)
    *(.rela.gnu.linkonce.s.*)
  }
  .rela.sbss 0 : {
    *(.rela.sbss)
    *(.rela.sbss.*)
    *(.rel.gnu.linkonce.sb.*)
  }
  .rela.sdata2 0 : {
    *(.rela.sdata2)
    *(.rela.sdata2.*)
    *(.rela.gnu.linkonce.s2.*)
  }
  .rela.sbss2 0 : {
    *(.rela.sbss2)
    *(.rela.sbss2.*)
    *(.rela.gnu.linkonce.sb2.*)
  }
  .rela.bss 0 : {
    *(.rela.bss)
    *(.rela.bss.*)
    *(.rela.gnu.linkonce.b.*)
  }
  .rela.plt 0 : { *(.rela.plt) }
 */
/* ------------------------------------------------------------------------ */
/* Stabs debugging sections.  */
  .toss 0 : {
    *(.stab)
    *(.stabstr)
    *(.stab.excl)
    *(.stab.exclstr)
    *(.stab.index)
    *(.stab.indexstr)
   }
/*   .stab 0 : { *(.stab) } */
/*   .stabstr 0 : { *(.stabstr) } */
/*   .stab.excl 0 : { *(.stab.excl) } */
/*   .stab.exclstr 0 : { *(.stab.exclstr) } */
/*   .stab.index 0 : { *(.stab.index) } */
/*   .stab.indexstr 0 : { *(.stab.indexstr) } */
  .comment 0 : { *(.comment) }
  .pdr 0 : { *(.pdr) }
  .compact_rel 0 : { *(.compact_rel) }
  .mdebug 0 : { *(.mdebug) }
  .mdebug.abi32 0 : { *(.mdebug.abi32) }
/* DWARF debug sections.  Symbols in the DWARF debugging sections are relative
   to the beginning of the section so we begin them at 0.  */
/* DWARF 1 */
  .debug 0 : { *(.debug) }
  .line 0 : { *(.line) }
/* GNU DWARF 1 extensions */
  .debug_srcinfo 0 : { *(.debug_srcinfo) }
  .debug_sfnames 0 : { *(.debug_sfnames) }
/* DWARF 1.1 and DWARF 2 */
  .debug_aranges 0 : { *(.debug_aranges) }
  .debug_pubnames 0 : { *(.debug_pubnames) }
/* DWARF 2 */
  .debug_info 0 : { *(.debug_info) *(.gnu.linkonce.wi.*) }
  .debug_abbrev 0 : { *(.debug_abbrev) }
  .debug_line 0 : { *(.debug_line) }
  .debug_frame 0 : { *(.debug_frame) }
  .debug_str 0 : { *(.debug_str) }
  .debug_loc 0 : { *(.debug_loc) }
  .debug_macinfo 0 : { *(.debug_macinfo) }
/* SGI/MIPS DWARF 2 extensions */
  .debug_weaknames 0 : { *(.debug_weaknames) }
  .debug_funcnames 0 : { *(.debug_funcnames) }
  .debug_typenames 0 : { *(.debug_typenames) }
  .debug_varnames  0 : { *(.debug_varnames) }
/* These must appear regardless of  .  */
  .gptab.sdata 0 : { *(.gptab.data) *(.gptab.sdata) }
  .gptab.sbss 0 : { *(.gptab.bss) *(.gptab.sbss) }
}
