#!/usr/bin/perl

use NH230;

my $sel_model;
my $sel_action;

my @model;


###############################
# Declare a new object
###############################
$lib = new NH230( 
		DIR_COMPILER=>"/opt/mpc8241",
		DIR_KERNEL=>"linux-2.4.21",
		DIR_RAMDISK=>"ramdisk",
		DIR_APTOOLS=>"user",
		DIR_PPCBOOT=>"ppcboot"
	);

###############################
# check environment  !!!
###############################
if( $lib->chk_environment() > 0 ){
	print "\x1b[41m Environment check fail -_-!! \x1b[m \n";
	exit(0);
}
# ..... pass



####################################
# Get all type of model
#-----------------------------------
# Open the ramdisk directory and -
#  get all MODEL from ramdisk.MODEL
####################################
push(@model,"NULL"); 
opendir(DIR,"$lib->{DIR_RAMDISK}"); 
my @dirList = readdir DIR; 
foreach my $dir (@dirList) 
{ 
	#if( $dir =~ /tgz/ ){
	#	next;
	#}

	if( $dir =~ /ramdisk./ ){
		$dir =~ s/ramdisk.//;
		print "Model === >> $dir \n";
		push(@model,$dir); 
	}
} 




##################################
# Select your model first !!
##################################
while(1){

print qq^ \x1b[2J \x1b[1m \x1b[36m
============================================================
  Please select your model.        
============================================================ \x1b[m \x1b[m
^;
#---------------------------------------------------
for($tmp=1;$tmp < $#model+1;$tmp++) {
print "\x1b[1m \x1b[37m ($tmp) $model[$tmp] \x1b[m \x1b[m \n";
}
#---------------------------------------------------
print "\x1b[1m\x1b[36m************************************************************ \x1b[m \x1b[m \n";

print "Enter the Model :";
$sel_model=<>;

if( $sel_model > 0 && $sel_model <= $#model){
	last;
}

} # end of while



##################################
# What will you like to do ??
##################################
while(1){
print qq^

\x1b[2J
\x1b[1m
\x1b[35m
============================================================
  What will you like to do?
  Please select ...              MODEL=$model[$sel_model]
============================================================

(1) Only distclean all

(2) Disclean and Compiler new $model[$sel_model] project.

(3) Recompiler $model[$sel_model] kernel. (make clean)
(4) Recompiler $model[$sel_model] kernel. (Don't make clean)

(5) Recompiler $model[$sel_model] filesystem. (make clean)
(6) Recompiler $model[$sel_model] filesystem. (Don't make clean)

(7) Compiler ppcboot (make clean)
(8) Compiler ppcboot (Don't make clean)

(9) Make flash image

************************************************************
\x1b[m
\x1b[m
^;
print "Enter the Model :";
$sel_action=<>;

if($sel_action > 0 && $sel_action <=9){
		last;
}

} # end of while

#print "Your model $model[$sel_model] \n";
#print "Your action $sel_action \n";

printf("======================================================\n");
printf(" Parsing the CONFIG !!                                \n");
printf("======================================================\n");	
$ret1 = $lib->setup_model($model[$sel_model]);

#print "$ret1->{BusyBox} \n";
#print "$ret1->{Linux} \n";
#print "$ret1->{ramdisk} \n";
#foreach $tmp (@{$ret1->{AP}}) {
#	print "$tmp \n";
#}

printf("======================================================\n");
printf(" Generate BRAND.mk !!                                 \n");
printf("======================================================\n");	
$ret2 = $lib->make_BRAND_mk($ret1); # pass the AP array point!!


if($sel_action >= 2 && $sel_action <=9){
	system("rm Make.*");	
	system("touch Make.$model[$sel_model]");
}


#===========================================
#(1) Distclean all and compiler new $model[$sel_model] project.
#===========================================
if($sel_action == 1){
		system("rm Make.*");		
		$lib->kernel_make_distclean($ret1);
		$lib->ramdisk_make_clean($ret1);
}



#===========================================
#(2) Only configure and setup for $model[$sel_model] project.
#===========================================
if($sel_action == 2){	
		$lib->kernel_make_distclean($ret1);
		$lib->kernel_make_oldconfig($ret1);
		$lib->kernel_make_dep($ret1);
		$lib->kernel_make_clean($ret1);
		$lib->kernel_make_zImage($ret1);
		$lib->kernel_mkimg($ret1);

		$lib->ramdisk_make_clean($ret1);
		$lib->ramdisk_config_busybox($ret1);
		$lib->ramdisk_make_all($ret1);
		$lib->ramdisk_make_install($ret1);
		#-------------------------------------
		# build web-upgrade image
		#-------------------------------------
		if(!$lib->kernel_file_chk($ret1)) #kernel exist
		{
			$image_info=$lib->release_log_parse();
			$lib->make_etc_version($image_info);
			#-------------------------------------
			$lib->ramdisk_make_image($ret1);
			#-------------------------------------
			$lib->make_webupgrade_header($image_info);
			$lib->make_webupgrade_image($image_info);

		}else{ # no kernel, no web upgrade image !!
			$lib->ramdisk_make_image($ret1);
		}	
}




#===========================================
#(3) Recompiler $model[$sel_model] kernel. (make clean)
#===========================================
if($sel_action == 3){
		$lib->kernel_make_distclean($ret1);
		$lib->kernel_make_oldconfig($ret1);
		$lib->kernel_make_dep($ret1);
		$lib->kernel_make_clean($ret1);
		$lib->kernel_make_zImage($ret1);
		$lib->kernel_mkimg($ret1);

}



#===========================================
#(4) Recompiler $model[$sel_model] kernel. (Don't make clean)
#===========================================
if($sel_action == 4){
		$lib->kernel_make_zImage($ret1);
		$lib->kernel_mkimg($ret1);
}



#===========================================
#(5) Recompiler $model[$sel_model] filesystem. (make clean)
#===========================================
if($sel_action == 5){
		$lib->ramdisk_make_clean($ret1);
		$lib->ramdisk_config_busybox($ret1);
		$lib->ramdisk_make_all($ret1);
		$lib->ramdisk_make_install($ret1);
		#-------------------------------------
		# build web-upgrade image
		#-------------------------------------
		if(!$lib->kernel_file_chk($ret1)) #kernel exist
		{
			$image_info=$lib->release_log_parse();
			$lib->make_etc_version($image_info);
			#-------------------------------------
			$lib->ramdisk_make_image($ret1);
			#-------------------------------------
			$lib->make_webupgrade_header($image_info);
			$lib->make_webupgrade_image($image_info);

		}else{ # no kernel, no web upgrade image !!
			$lib->ramdisk_make_image($ret1);
		}
}



#===========================================
#(6) Recompiler $model[$sel_model] filesystem. (Don't make clean)
#===========================================
if($sel_action == 6){
		$lib->ramdisk_make_all($ret1);
		$lib->ramdisk_make_install($ret1);
		#-------------------------------------
		# build web-upgrade image
		#-------------------------------------
		if(!$lib->kernel_file_chk($ret1)) #kernel exist
		{
			$image_info=$lib->release_log_parse();
			$lib->make_etc_version($image_info);
			#-------------------------------------
			$lib->ramdisk_make_image($ret1);
			#-------------------------------------
			$lib->make_webupgrade_header($image_info);
			$lib->make_webupgrade_image($image_info);

		}else{ # no kernel, no web upgrade image !!
			$lib->ramdisk_make_image($ret1);
		}
}



#===========================================
#(7) Compiler ppcboot (make clean)
#===========================================
if($sel_action == 7){
		$lib->ppcboot_clean($ret1);
		$lib->ppcboot_config($ret1);
		$lib->ppcboot_dep($ret1);
		$lib->ppcboot_make($ret1);
}


#===========================================
#(8) Compiler ppcboot (Don't make clean)
#===========================================
if($sel_action == 8){
		$lib->ppcboot_make($ret1);
}



#===========================================
#(9) Make flash image
#===========================================
if($sel_action == 9){
		$image_info=$lib->release_log_parse();
		$lib->flash_image_make($image_info);
}
