#ifndef R8169_IOCTL_H
#define R8169_IOCTL_H


#include <linux/if.h>	//struct ifreq{}


#define RTL8169_IOCTL_RESET			SIOCDEVPRIVATE
#define RTL8169_IOCTL_GET_VER		SIOCDEVPRIVATE+1
#define RTL8169_IOCTL_GET_LINK		SIOCDEVPRIVATE+2
#define RTL8169_IOCTL_GET_MII_REG	SIOCDEVPRIVATE+3
#define RTL8169_IOCTL_SET_MII_REG	SIOCDEVPRIVATE+4
#define RTL8169_IOCTL_GET_MTU		SIOCDEVPRIVATE+5


# ifdef M_NH230

#define RTL8169_IOCTL_NWAY			(SIOCDEVPRIVATE+8)
#define RTL8169_IOCTL_10F			(SIOCDEVPRIVATE+9)
#define RTL8169_IOCTL_100F			(SIOCDEVPRIVATE+10)
#define RTL8169_IOCTL_1000F			(SIOCDEVPRIVATE+11)

# endif//# ifdef M_NH230

struct ver_t
{
	char mac_version;
	char phy_version;
	char drv_version[IFNAMSIZ-2];
};

struct link_t
{
	int speed;   //{10,100,1000}
	int duplex;  //{0,1} := {half,full}
};

struct mii_t
{
	int get_reg;
	int get_val;
	int set_reg;
	int set_val;
};

#endif //end #ifndef R8169_IOCTL_H
