//
// History :
//   V1.00  01/21/2005  Hank Chu
//   1) Create to support RTC for Motorola PowerPC platform with (M_NH230}.
//
//
//

#ifdef __KERNEL__
  #ifndef __NTX_RTC_H__
  #define __NTX_RTC_H__

#include <linux/rtc.h>


#ifdef CONFIG_SANDPOINT_I2C_RTC_PCF8563

  #define ntx_time_init               pcf8563_rtc_init
  #define ntx_set_rtc_time            pcf8563_set_rtc_time
  #define ntx_set_rtc_time_struct     pcf8563_set_rtc_time_struct
  #define ntx_get_rtc_time            pcf8563_get_rtc_time
  #define ntx_get_rtc_time_struct     pcf8563_get_rtc_time_struct
  #define ntx_calibrate_decr          pcf8563_calibrate_decr

  long pcf8563_rtc_init(void);
  
  int pcf8563_set_rtc_time(unsigned long nowtime);
  int pcf8563_set_rtc_time_struct(struct rtc_time *lpst_time);
  
  unsigned long pcf8563_get_rtc_time(void);
  int pcf8563_get_rtc_time_struct(struct rtc_time *lpst_time);
  
  void pcf8563_calibrate_decr(void);
  
  int is_pcf8563_low_voltage(void);
  int pcf8563_reset_low_voltage(void);
  
#endif



  #endif  // end of #ifdef {__NTX_RTC_H__}
#endif    // end of #ifdef {__KERNEL__}

