#!/bin/sh
#
# script file to start dhcp client (udhcpc)
#


if [ $# -lt 2 ]; then echo "Usage: $0 interface {wait|no]";  exit 1 ; fi

SCRIPTFILE_PATH=/etc/dhcpc
PIDFILE=/etc/dhcpc/udhcpc-$1.pid
CMD="-i $1 -p $PIDFILE -s $SCRIPTFILE_PATH/$1.sh"
UDHCPC="/sbin/udhcpc"

if [ $2 = 'no' ]; then
    echo "You must using "wait" parameter!!"
else
	# Generate deconfig script
	echo "#!/bin/sh" > $SCRIPTFILE_PATH/$1.deconfig
	echo "ifconfig $1 0.0.0.0" >> $SCRIPTFILE_PATH/$1.deconfig
	chmod 755 $SCRIPTFILE_PATH/$1.deconfig
fi

if [ -f $PIDFILE ] ; then
	PID=`cat $PIDFILE`
	if [ $PID != 0 ]; then
		kill -9 $PID
       	fi
	rm -f $PIDFILE
fi

$UDHCPC $CMD
