#!/bin/sh

/etc/rc.d/usb_info.sh > /tmp/usbboot.log

for i in `cat /etc/config | grep USB_MOUNT | cut -d= -f1`
do
	MOUNT_SET=`cat /etc/config | grep $i | cut -d"'" -f2`
	if [ -z "$MOUNT_SET" ] ; then
		break;
	else	
		MOUNT_DEV=`echo $MOUNT_SET | cut -d, -f1`
		MOUNT_FOLDER=`echo $MOUNT_SET | cut -d, -f2`
		MOUNT_TYPE=`echo $MOUNT_SET | cut -d, -f3`
				
		case `cat /tmp/usbboot.log | grep $MOUNT_DEV | cut -d: -f2 | cut -d= -f2` in
			Linux)
				  NOW_USB_TYPE="ext3" ;;
			FAT32|FAT16) 
				  NOW_USB_TYPE="vfat" ;;
			HPFS/NTFS)
				  NOW_USB_TYPE="ntfs" ;;	
			*)
				  NOW_USB_TYPE="NON_EXIST" ;;
				
		esac
			
		[ "$MOUNT_TYPE" = "$NOW_USB_TYPE" ] && {
			mkdir -p /mnt/$MOUNT_FOLDER
		
			if [ "$MOUNT_TYPE" = "ntfs" ] ; then
				 mount -t ntfs $MOUNT_DEV /mnt/$MOUNT_FOLDER -r || echo " Can't mount $MOUNT_DEV device !!"
			elif [ "$MOUNT_TYPE" = "ext3" ] ; then
				 mount -t ext3 $MOUNT_DEV /mnt/$MOUNT_FOLDER || echo " Can't mount $MOUNT_DEV device !!"
			elif [ "$MOUNT_TYPE" = "vfat" ] ; then				
			    /bin/mount -t vfat -o iocharset=utf8 $MOUNT_DEV /mnt/$MOUNT_FOLDER || echo " Can't mount $MOUNT_DEV device !!"							
			else
				echo "Cant recognize file type";			
			fi
			
						
		} || {
				echo "Different USB storage!!"
								
				# take off the config value from /etc/config
				CONFIG_VALUE=$(echo $i | cut -d= -f1)
				
				sed -i "/$CONFIG_VALUE/s/.*/$CONFIG_VALUE=\'\'/" /etc/config
				# delete folder before checksmb
				[ -n "$MOUNT_FOLDER" ] && rmdir /mnt/$MOUNT_FOLDER
			  }
				
	fi
done