#!/bin/sh
#

. /etc/rc.d/options
#. /etc/init.d/netdevconf

# Declarations

UPNP_ENABLE=1
#LIF=$realdev_int
LIF=eth0
UPNPPORT="8091" 

start() {
     [ ${UPNP_ENABLE} -eq "1" ] && [ -f /mnt/upnp_soho ] &&	{
     if [ ! -f /sbin/upnp_soho ] ; then
      	( cd /mnt ; tar cf - upnp_soho watch_prog ) | ( cd /sbin ; tar xf - )
     fi
      route add -net 239.0.0.0 netmask 255.0.0.0 ${LIF}
      #cd /upnp_soho
      cd /etc/xml
      watch_prog upnp_soho 15 10 "upnp_soho -p 8091 &"&
      echo $! > /var/run/watch_upnp.pid
      #$LOG "upnp: upnp_soho started."
    }
}

stop() {
	kill -9 `pidof watch_prog` >/dev/null 2>&1
    killall -9 upnp_soho >/dev/null 2>&1
    rm /var/run/upnp_soho.pid >/dev/null 2>&1
    rm /var/run/watch_upnp.pid >/dev/null 2>&1
    #$LOG "upnp: upnp_soho stop."
}

restart() {
    stop 
    while pidof upnp_soho;do sleep 1;done
    start
}


case "$1" in
  start)
	start
    ;;		
  stop)
    stop
    ;;
  restart)
    restart
    ;;
  *) 
    echo "Usage: $0 {start|stop|restart}"
    ;;        
esac
