#!/bin/sh

ONLY_SHOW_ONE_PARTITION='0'

HAVE_DISK='0'

if grep UHCI /proc/bus/usb/devices ; then
	USB11=UHCI
else
	USB11=OHCI
fi

LIST=`ls /proc/scsi | grep -v "scsi\|sg"`
for j in $LIST
do
 num=`echo $j | cut -d- -f3`
 ATTACH=`grep Attached /proc/scsi/$j/$num | cut -d: -f2`
 [ "$ATTACH" = " Yes" ] && [ "$HAVE_DISK" -eq "0" ] && {
 
 if [ "$USB11" = "UHCI" ] ; then
 	grep "^T\|SerialNumber" /proc/bus/usb/devices | grep -v "Prnt=00\|bfffe0\|00:0e.3" > /tmp/storage.log
 else
 	grep "^T\|SerialNumber" /proc/bus/usb/devices | grep -v "Prnt=00\|c5006000\|00:0e.2\|c5008000" > /tmp/storage.log
 fi 	
 	
 #HAVE_DISK=1
 #disk=`grep "Host scsi" /proc/scsi/$j/$num | tr '0-9' 'a-j' | sed -n 's/scsi/sd/p' | cut -b9-11`
 case "$num" in 
  0) disk=sda;; 1) disk=sdb;; 2) disk=sdc;; 3) disk=sdd;; 4) disk=sde;; 5) disk=sdf;; 6) disk=sdg;;
  7) disk=sdh;; 8) disk=sdi;; 9) disk=sdj;; 10) disk=sdk;; 11) disk=sdl;; 12) disk=sdm;; 13) disk=sdn;;
  14) disk=sdo;; 15) disk=sdp;; 16) disk=sdq;; 17) disk=sdr;; 18) disk=sds;; 19) disk=sdt;; 20) disk=sdu;;
  21) disk=sdv;; 22) disk=sdw;; 23) disk=sdx;; 24) disk=sdy;; 25) disk=sdz;;
 esac
 
 
 serial=`grep "Serial Number" /proc/scsi/$j/$num | cut -d' ' -f3`
 [ "${serial}" = "None" -o `echo "${serial}" | cut -b1-10` = "NTXPRIVATE" ] && {
 	
 	if [ "$USB11" = "UHCI" ] ; then
 		grep "^T\|Product" /proc/bus/usb/devices | grep -v "Prnt=00\|PCI device 17a0:8084\|USB UHCI Root Hub" > /tmp/storage.log
 	else
 		grep "^T\|Product" /proc/bus/usb/devices | grep -v "Prnt=00\|NEC Corporation\|USB OHCI Root Hub" > /tmp/storage.log
 	fi
 	
 	product=`grep "Product" /proc/scsi/$j/$num | cut -c16- | head -n 1`  #only suport one storage
 	product_line=`grep -in "${product}" /tmp/storage.log | cut -d: -f1`
	t_line=`expr $product_line - 1`
  } || {
 	serial_line=`grep -in "SerialNumber=${serial}" /tmp/storage.log | cut -d: -f1`
 	t_line=`expr $serial_line - 1`
 }
 
 PORT=`head -n $t_line /tmp/storage.log | tail -n 1 | sed -n 's/ \{1,\}/+/pg' | cut -d+ -f5 | cut -b7`
 #echo "$PORT"
 
 disk="/dev/$disk"
 		TEST=`fdisk -l $disk | grep Disk | cut -b1-4`
	    [ -n "${TEST}" ] &&
	 	{       
	       capacity=`fdisk -l $disk | head -n 2 | tail -n 1 | cut -d: -f2 \
	                     | cut -d, -f1 | cut -d' ' -f2`
	            
	       capacity_unit=`fdisk -l $disk | head -n 2 | tail -n 1 | cut -d: -f2 \
	                     | cut -d, -f1 | cut -d' ' -f3`
	                                          
	       PARTS_NUM=`fdisk -l $disk | grep -c $disk`
	       PARTS_NUM=$(($PARTS_NUM-1))      	       	       

	       PARTS_NUM1=`fdisk -l $disk | grep -v "Win95 Ext\|Extended\|Linux extended" | grep -c $disk`
	       PARTS_NUM1=$(($PARTS_NUM1-1))
	       
	       dd if=$disk of=/tmp/usb.mbr.$$ bs=512 count=1 > /dev/null
	       
	       if grep -i "press" /tmp/usb.mbr.$$ > /dev/null ; then
	        	   # special usb disk	        	   	       	 	   
	        	   echo "$disk:partitions=1:total=${capacity}${capacity_unit}"
	        	   echo "${disk}:filetype=FAT16:total=${capacity}${capacity_unit}:PORT${PORT}1"		       		
	       else
	       		   # normal usb disk
	       		   
			       [ "$ONLY_SHOW_ONE_PARTITION" -eq "0" ] && {
			       	echo "$disk:partitions=${PARTS_NUM1}:total=${capacity}${capacity_unit}"
			       } || {
			       	echo "$disk:partitions=1:total=${capacity}${capacity_unit}"
			       	PARTS_NUM='1'
			       }
		       
		          x=1
			      while [ "$x" -le "$PARTS_NUM" ]		      
				  do
				  	DEV_PART=`fdisk -l $disk | grep $disk | head -n $(($x+1)) | tail -n 1 | cut -b1-9`
				  	{
					  GUESS_FS=`fdisk -l $disk | grep $disk | head -n $(($x+1)) | tail -n 1 | cut -b54`
					  case "$GUESS_FS" in
					  f|5|85) x=$(($x+1))
					     continue ;;
					  b|c) DEV_FS="FAT32" ;;
					  e|4|6) DEV_FS="FAT16" ;;
					  *)				 			  
					     DEV_FS=`fdisk -l $disk | grep $disk | head -n $(($x+1)) | tail -n 1 | tr ' ' '\n' | tail -n 1`
					     ;;
					  esac			
					}				
					
					BOOT_MARK=`fdisk -l $disk | grep $disk | head -n $(($x+1)) | tail -n 1 | grep \* | cut -d' ' -f1` 
					[ -n "$BOOT_MARK" ] && BOOTABLE="1" || BOOTABLE="0"
					
					[ "$BOOTABLE" -eq 0 ] && \
					DEV_BLOCK=`fdisk -l $disk | grep $disk | head -n $(($x+1)) | tail -n 1 | tr ' ' '\n' | grep -v ^$ | head -n 4 | tail -n 1 | cut -d+ -f1` || \
					DEV_BLOCK=`fdisk -l $disk | grep $disk | head -n $(($x+1)) | tail -n 1 | tr ' ' '\n' | grep -v ^$ | head -n 5 | tail -n 1 | cut -d+ -f1`
					
					
					
					DEV_CAP="$(($DEV_BLOCK/1000))"
					PART=`echo "${DEV_PART}" | cut -b9`
					echo "${DEV_PART}:filetype=${DEV_FS}:total=${DEV_CAP}MB:PORT${PORT}${PART}"
					    
				    x=$(($x+1))
				  done
			fi
			rm /tmp/usb.mbr.$$
	       	    	
	    } 
 
 
 }
done


