/* httpd.c:  A very simple http server
 *
 * Copyright (c) 1997-1999 D. Jeff Dionne <jeff@rt-control.com>
 * Copyright (c) 1998      Kenneth Albanowski <kjahds@kjahds.com>
 * Copyright (c) 1999      Nick Brok <nick@nbrok.iaehv.nl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <dirent.h>
#include <sys/stat.h>
#include <fcntl.h>

#define MNT_DIR  	"/mnt"
#define FTP_SHARE 	"ftpshare"
#define SMB_SHARE	"Share"
#if defined(PCI)
#define PHOTO_SHARE "photo"
#endif
#define WEB_SHARE   "WEB"
#define PRINTER_SHARE   "printers"
#define MAX_USER	50
#define MAX_FOLDER	50
#define READ_LONG	1024

typedef struct{
    char foldername[80];
}FOLDER_VALUE;

typedef struct{
	char username[48];
	char user_kind[2];
}USER_VALUE;


int  find_mntfolder_m( char *count, FOLDER_VALUE *del_folder, char *add_count, FOLDER_VALUE *add_folder );
void Get_allfolder_m( char *count, FOLDER_VALUE *folder_name );
int  Set_delfolder_m( char count, FOLDER_VALUE *delfolder );
int  Set_addfolder_m( char add_count, FOLDER_VALUE *addfolder );
void get_allothers( char * allothers );
void Get_alluserlist( USER_VALUE *invalid );

int main(int argc, char *argv[])
{	
	char tmp[80];//default 50
	int fdd;
	struct stat buf;
	FILE *fp;
	char Line_b[256];
	FOLDER_VALUE del_folder[MAX_FOLDER];
	FOLDER_VALUE add_folder[MAX_FOLDER];
	char del_count = 0;
	char add_count = 0;
	char result = 0;
	char hdcapacity = 0;

#ifdef NH230
// andy add for judge to mkdir the share and web folder
	FILE *fip,*fip1;
    char LineBuf[256];
    char *ptr, *end;
    int initboot=0;

	if((fip = fopen("/etc/config","r")) == NULL){
        return 0;
    }else{
        while(fgets(LineBuf,255,fip) != NULL){
            if((ptr = strstr(LineBuf,"INITBOOT='")) != NULL){
	             ptr+= strlen("INITBOOT='");	             
	             end = strchr(ptr,'\'');	            
	             *end = '\0';
	             initboot = atoi(ptr);
	             //printf("%s: %s..:INITBOOT=%d ptr=%s\n", __FILE__, __func__, initboot, ptr);	
	             break;
            }           
        }
     }
     fclose(fip);
// end 
#endif

	memset( del_folder, 0, sizeof(del_folder) );
	memset( add_folder, 0, sizeof(add_folder) );
	memset( tmp, 0, sizeof(tmp) );
                                                  																																							
	system("cat /proc/ide/hda/model > /etc/hdmodel1");																																							
	system("cat /proc/mounts > /etc/hdcapacity1");    																																							
	                                                  																																							
	fdd = open("/etc/hdmodel1", O_RDONLY);            																																							
	fstat(fdd,&buf);                                  																																							
	                                                  																																							
	if((fp = fopen("/etc/hdcapacity1","r")) == NULL){ 																																							
		printf("Couldn't open /etc/hdcapacity1\n");   																																							
		return 1;                                     																																							
	}                                                 																																							                                                  																																							
	while(fgets( Line_b, 255, fp )){                  																																							
		if(strstr( Line_b, "/dev/hda" ) != NULL ){ 
			   																																							
		    hdcapacity = 2;                           																																							
		    break;                                    																																							
		}else{                                        																																							
		    if ( buf.st_size == 0 )                   																																							
	            hdcapacity = 0;                       																																							
			else                                      																																							
				hdcapacity = 1;                       																																							
	    }                                             																																							
	}	                                                  																																							
	system("rm -f /etc/hdmodel1");                    																																							
	system("rm -f /etc/hdcapacity1");                 																																							
	                                                  																																							
	if (hdcapacity != 2){                             																																							
		printf("hdcapacity != 2\n");                  																																							
		return 1;                                     																																							
	}                                                 																																							

	chdir(MNT_DIR);
	
#ifndef LOBOS
    #ifndef NH220
		if ( opendir(FTP_SHARE) == NULL ){
			sprintf( tmp, "/bin/mkdir /mnt/%s", FTP_SHARE );
			system( tmp );
		}
	#endif

#ifdef NH230
if(initboot)
{	
	printf("initboot=1\n");
	if ( opendir(SMB_SHARE) == NULL ){
		sprintf( tmp, "/bin/mkdir /mnt/%s", SMB_SHARE );
		system( tmp );
	}
#if defined(PCI)	
	if ( opendir(PHOTO_SHARE) == NULL ){
		sprintf( tmp, "/bin/mkdir /mnt/%s", PHOTO_SHARE );
		system( tmp );
	}
#endif
	#ifdef NH220
		if ( opendir(WEB_SHARE) == NULL ){
			sprintf( tmp, "/bin/mkdir /mnt/%s", WEB_SHARE );
			system( tmp );
		}
    #endif
    
// write back to the /etc/config with INITBOOT=0 
		if((fip = fopen("/etc/config","r")) == NULL) 	return 0;	
		if((fip1 = fopen("/etc/config1","w+")) == NULL) 	return 0;	
		while(fgets(LineBuf, 255, fip) != NULL)
		{	
			if((ptr = strstr(LineBuf,"INITBOOT='")) != NULL)
				fputs("INITBOOT='0'\n",fip1);
			else
				fputs(LineBuf, fip1);			
		}
    	fclose(fip);		
    	fclose(fip1);
    	system("mv /etc/config1 /etc/config");
//end
#else
	if ( opendir(SMB_SHARE) == NULL ){
		sprintf( tmp, "/bin/mkdir /mnt/%s", SMB_SHARE );
		system( tmp );
	}
	#ifdef NH220
		if ( opendir(WEB_SHARE) == NULL ){
			sprintf( tmp, "/bin/mkdir /mnt/%s", WEB_SHARE );
			system( tmp );
		}
    #endif
#endif   //end of #ifdef NH230


}    
#endif

	result = find_mntfolder_m( &del_count, del_folder, &add_count, add_folder );
	result = Set_delfolder_m( del_count, del_folder);
	result = Set_addfolder_m( add_count, add_folder);
	
	if (!result)
	{
		printf("smb1 fail!!!\n");	
		return 1;
	}
	else
	{
		system("/bin/mv /etc/smb2.conf /etc/smb.conf");
		system("/bin/rm -f /etc/smb1.conf");
#ifdef NOVAC	
		system("/etc/rc.d/save_config_for_checksmb.sh");	
#else		
		system("/etc/rc.d/save_config.sh"); 
#endif  
		system("killall -SIGHUP smbd");
		printf(" *** smb.conf success checked!!! ***>>\n");
		return 0;		
	}	

}


int  find_mntfolder_m( char *count, FOLDER_VALUE *del_folder, char *add_count, FOLDER_VALUE *add_folder ){
	
	char *ptr,*end;
	char LineBuf[1024];
	FILE *alldir;	
	FOLDER_VALUE *p;
	FOLDER_VALUE *a;
	FOLDER_VALUE smb_folder[MAX_FOLDER];
	FOLDER_VALUE hd_folder[MAX_FOLDER];
	char smb_count = 0;
	char flag = 0;
	unsigned char ls_count = 0;
	int i,j,w;
	char tmp[256];
	char buf[200];

	memset( smb_folder, 0, sizeof(smb_folder) );
	memset( hd_folder, 0, sizeof(hd_folder) );

	#if defined(PCI) || defined(ENCORE)
		system("/bin/ls -F -w 1 /mnt/ | grep -v spool | grep -v mldonkey > /etc/allfile");
	
	#else	
		system("/bin/ls -F -w 1 /mnt/ | grep -v spool > /etc/allfile");
	
	#endif
	
	if(( alldir = fopen( "/etc/allfile", "r")) == NULL )  
	    return 0;  

	p = del_folder;
	a = add_folder;
	
	Get_allfolder_m( &smb_count , smb_folder );
	while(fgets(LineBuf, 1000, alldir) != NULL){

		ptr = LineBuf;	
		w+=1;
		//printf("%d. ptr=%s\n",w,ptr);	
		end = strchr( ptr, '/');
	
		if ( end != NULL ){
			*end = '\0';
#ifndef LOBOS
    #ifndef NH220
			if ( !memcmp( ptr, FTP_SHARE,strlen(FTP_SHARE) ) )  
			    continue;
	#endif
	#ifdef NH220
	        if ( !memcmp( ptr, WEB_SHARE ,strlen(WEB_SHARE)) )  
			    continue;
	#endif
			if ( !memcmp( ptr, SMB_SHARE ,strlen(SMB_SHARE)) )  
			    continue;			    			    
			else{
#endif
				if( strlen(ptr) > 48 ){		
					memset(tmp, 0, sizeof(tmp) );
					memcpy( tmp, ptr,strlen(ptr));
	                //printf("1. tmp=%s\n", tmp);
					tmp[48] = '\0';
	               // printf("2. tmp=%s\n", tmp);
					//sprintf(buf, "mv /mnt/%s /mnt/%s", ptr, tmp);
					sprintf(buf, "mv /mnt/\"%s\" /mnt/\"%s\"", ptr, tmp);
					system(buf);
					memcpy(ptr, tmp,strlen(tmp));
					ptr[48] = '\0';
				}
	            //printf("now ptr=%s\n", ptr);				
				memcpy( &(hd_folder[ls_count].foldername[0]), ptr ,strlen(ptr));
	            //printf("strlen(ptr)=%d\n", strlen(ptr));					
				hd_folder[ls_count].foldername[strlen(ptr)] = '\0';
	            //printf("hd_folder add is:%s, lscount=%d\n", &(hd_folder[ls_count].foldername[0]), ls_count );										
				ls_count+= 1;
#ifndef LOBOS
			}
#endif			
		}
	}

	for(i=0; i<smb_count; i++){
		for(j=0; j<ls_count; j++){        
		    if( !memcmp( &(smb_folder[i].foldername[0]) , &(hd_folder[j].foldername[0]),strlen(&(hd_folder[j].foldername[0])))){									
				flag = 1;
				break;
			}
		}	
			
		if (!flag){
            //printf("--> from samba %s\n", &(smb_folder[i].foldername[0]));
			memcpy( &(p->foldername[0]), &(smb_folder[i].foldername[0]),strlen(&(smb_folder[i].foldername[0])) );
            //printf("###now p_folder=%s, i=%d\n", &(p->foldername[0]), i);			
			p++;
			*count += 1;
		}else
			flag = 0;
	}

	for(i=0; i<ls_count; i++){
		for(j=0; j<smb_count; j++){            
			if ( !memcmp( &(hd_folder[i].foldername[0]), &(smb_folder[j].foldername[0]),strlen(&(smb_folder[j].foldername[0])))){								
				flag = 1;
				break;
			}
		}	
			
		if (!flag){
            //printf("-->add to smb %s\n", &(hd_folder[i].foldername[0]));
			memcpy( &(a->foldername[0]), &(hd_folder[i].foldername[0]),strlen(&(hd_folder[i].foldername[0])) );
			a++;
			*add_count += 1;
		}else
			flag = 0;
	}
  //printf("a_foldername=%s\n",&(a->foldername[0]));
	fclose(alldir);
	system("rm -f /etc/allfile");
	return 1;
}

void Get_allfolder_m( char *count, FOLDER_VALUE *folder_name ){
	
    FILE *fd;
    char Line_b[1024];
    char *ptr,*end;

    if((fd = fopen("/etc/smb.conf","r")) == NULL) 	
        return ;

    while(fgets(Line_b, 1000, fd) != NULL){   
        if (Line_b[0] == '#' || Line_b[0] == '\r' || Line_b[0] == '\n')  
            continue;

        if( Line_b[0] == '[' ){
            ptr = Line_b;
            end = strchr(ptr,'[');
            ptr = ++end;
            end = strrchr(ptr,']');               
            if(end != NULL) 
                *end = '\0';
#ifdef LOBOS
            if( memcmp( ptr, "global",6) == 0 )  
#else 
    #ifndef NH220
            if( memcmp( ptr, "global",6) == 0 || memcmp( ptr, FTP_SHARE,strlen(FTP_SHARE)) == 0 || memcmp( ptr, SMB_SHARE,strlen(SMB_SHARE)) == 0) 
    #else	          
            if( memcmp( ptr, "global",6) == 0 || memcmp( ptr, SMB_SHARE,strlen(SMB_SHARE)) == 0 || memcmp( ptr, WEB_SHARE,strlen(WEB_SHARE)) == 0 || memcmp(ptr,PRINTER_SHARE,strlen(PRINTER_SHARE)) == 0)
    #endif
#endif            
                continue; 
                //printf("Get_allfolder=%s",ptr);                            
            memcpy( &(folder_name->foldername[0]), ptr,strlen(ptr));
            //printf("now smbfolder_name=%s\n",&(folder_name->foldername[0]));                
		    folder_name ++;                
		    *count += 1;  
        }
    }
    //printf("smb_folder_name=%s\n",&(folder_name->foldername[0]));
    fclose(fd);
}


int  Set_delfolder_m( char count, FOLDER_VALUE *delfolder ){
	
	FILE *fd,*n_fd;	
	char Line_b[1024];
	FOLDER_VALUE *p;
	char *ptr, *end;
	int i;
	char f=0;

	if((fd = fopen("/etc/smb.conf","r")) == NULL) 	
	    return 0;	
	if((n_fd = fopen("/etc/smb1.conf","w+")) == NULL) 	
	    return 0;	

	while(fgets(Line_b, 1000-1, fd) != NULL){
        //if ( Line_b[0] == '\r' || Line_b[0] == '\n')  continue;

        if( strchr(Line_b, '[') != NULL){
            ptr = Line_b;
            end = strchr(ptr,'[');
            if (end != NULL) *end = '\0';
            ptr = ++end;
            end = strrchr(ptr,']');               
            if (end != NULL) 
                *end = '\0';
#ifdef LOBOS
            if ( memcmp( ptr, "global",6) == 0 ){
#else
    #ifndef NH220
            if ( memcmp( ptr, "global",6) == 0 || memcmp( ptr, FTP_SHARE,strlen(FTP_SHARE)) ==0 || memcmp( ptr, SMB_SHARE,strlen(SMB_SHARE)) ==0){
    #else
            if ( memcmp( ptr, "global",6) == 0 || memcmp( ptr, SMB_SHARE,strlen(SMB_SHARE)) ==0 || memcmp( ptr, WEB_SHARE,strlen(WEB_SHARE)) ==0 || memcmp(ptr,PRINTER_SHARE,strlen(PRINTER_SHARE)) == 0){
    #endif
#endif            	            	
            	fprintf(n_fd, "[%s]\n", ptr);
            	continue;
			}
            p = delfolder;
            for( i=0; i<count; i++){
            	if(memcmp( ptr, &(p->foldername[0]),strlen(&(p->foldername[0])) ) == 0){
            		f = 1;
            		break;
            	}
            	p++;
    		}

    		if(f){
			    while(fgets(Line_b, 1000, fd) != NULL){
					if(strstr(Line_b, "create mask =") != NULL){
						//fgets(Line_b, 1000, fd);
            			f = 0;
						break;
					}
				}    			
    		}else   
    		    fprintf(n_fd, "[%s]\n", ptr);
		}else   
		    fputs(Line_b, n_fd); 	
	}	
	fclose(fd);
    fclose(n_fd);      	
	return 1;
}

int  Set_addfolder_m( char add_count, FOLDER_VALUE *addfolder )
{
	FILE *fd,*n_fd;	
	char Line_b[READ_LONG];
	FOLDER_VALUE *p;
	char allothers[READ_LONG+1];
	int i;

	if((fd = fopen("/etc/smb1.conf","r")) == NULL) 	return 0;	
	if((n_fd = fopen("/etc/smb2.conf","w+")) == NULL) 	return 0;	


    memset( allothers, 0, READ_LONG );
    
    get_allothers( allothers );
    
	p = addfolder;

	while(fgets(Line_b, READ_LONG-1, fd) != NULL)
		fputs(Line_b, n_fd);

    fclose(fd);
    
    for ( i=0; i<add_count; i++ )
    {
	    fprintf(n_fd, "[%s]\n", &(p->foldername[0]) );    
    	fprintf(n_fd, "   comment = %s\n", &(p->foldername[0]));
    	fprintf(n_fd, "   path = /mnt/%s\n", &(p->foldername[0]));
    	fprintf(n_fd, "   browseable = yes\n");
    	fprintf(n_fd, "   public = no\n");
		fprintf(n_fd, "   Invalid users = %s\n", allothers );
		fprintf(n_fd, "   readlist = \n");
#ifdef LOBOS
        fprintf(n_fd, "   writelist = \n");
#else
		fprintf(n_fd, "   writelist = all,\n");
#endif
	    fprintf(n_fd, "   directory mode = 0777\n");   
	    fprintf(n_fd, "   create mask = 0777\n");
	    fprintf(n_fd, "\n");
	    
	    p++;
	}
	    
    fclose(n_fd);

	return 1;
}


void get_allothers( char * allothers ){
	USER_VALUE invalid[MAX_USER];
	int i;
	
	memset( invalid, 0, sizeof(invalid) );

	Get_alluserlist( invalid );
	
	for (i=0; i<MAX_USER; i++){
		if ( !strlen( &(invalid[i].username[0]) ) )  break;
		if ( !memcmp( &(invalid[i].username[0]), "all",3) ) continue;
		//if(i==1)
		    //sprintf( &allothers[strlen(allothers)]," %s,",&(invalid[i].username[0] ));
		//else
		    sprintf( &allothers[strlen(allothers)],"%s,",&(invalid[i].username[0] ));
	}
//printf("allothers=%s\n", allothers);
	return ;

}


void Get_alluserlist( USER_VALUE *invalid )
{
    FILE *fp;
    char Line_b[READ_LONG];
    USER_VALUE *p;
    int i;
    char *ptr;

    p = invalid;

    if((fp = fopen("/etc/smbpasswd","r")) == NULL) 	return ;	
    
    while(fgets(Line_b, READ_LONG-1, fp) != NULL)
    {   
        if (Line_b[0] == '#' || Line_b[0] == '\r' || Line_b[0] == '\n')   continue;

        for(i=0;i<READ_LONG-1;i++)
        {
            //if( (Line_b[i] == ':') || (Line_b[i] == ' ') || (Line_b[i] == '\n') || (Line_b[i] == '\r'))
              if( (Line_b[i] == ':') || (Line_b[i] == '\n') || (Line_b[i] == '\r'))
            {
                Line_b[i] = '\0';
                i=READ_LONG;
            }
        }       
        ptr = Line_b;
        if (ptr != NULL)
        {
        	memcpy( &(p->username[0]), ptr,strlen(ptr));
        	p++;
		}
	}
	fclose(fp);
}	
	

