/*
	Auther: Hiram
	Propose:   The ftpdconf function was used to generate the ftpd.conf
	
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   The ftpd.conf format 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	n/s stand for "normal file" or "shared file"
	n => 0x10
	s => 0x11
~~~~~~~~~~~~~~~~~~~
	Invalid user flag => 0x20
	read list flag => 0x21
	write list => 0x22
	
			 --------------------------------------------
folder name	| n/s | ..00 (17 bytes)  |
			 --------------------------------------------
Invalid user|flag| user1(17 bytes) |flag| user2 | ...
			 --------------------------------------------
read list	|flag| user1(17 bytes) |flag| user2 | ......	
			 --------------------------------------------
write list  |flag| user1(17 bytes) |flag| user2 | .....
			 --------------------------------------------

+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "extern.h"
#define NAME_LIMIT 17

#define TRUE 1
#define FALSE 0

void wirite_to_file(FILE *file, char *buff, int sec);

int ftpdconf()
{
	int i = 0,  sflag = 0, nsteel = 0;
	char *ptr, LineBuf[256];
	FILE *f_ftpd, *f_smb; 

	f_ftpd = fopen("/mnt/.ftpd.conf","wb");
	f_smb = fopen("/etc/smb.conf","r");
//=====================================================	
	while( fgets(LineBuf, 255, f_smb) != NULL ){
		// pass the breakline and comment line !!
		if(LineBuf[0] == 0x0A || LineBuf[0] == '#')
			continue;
		//Get the section name !!
		if(LineBuf[0] == '[') {
			// pass the [global] section
			if((ptr = strstr(LineBuf, "[global]")) != NULL)
				continue;
			//Get the section name !!
			sflag = 0;
			nsteel = ftell(f_ftpd);
			fputc(ns_NORMAL,f_ftpd);
			for(i=1; i<NAME_LIMIT+1; i++)
			{
				if(LineBuf[i] == ']')
					sflag = 1;

				if (sflag == 0)	
					fputc(LineBuf[i], f_ftpd);
				else 
					fputc(0x00, f_ftpd);
			}
		}
		// admin users = nobody
		if((ptr = strstr(LineBuf, "admin users = ")) != NULL){
			int temptell;
			
			temptell = ftell(f_ftpd);		//replace the N/S flag
			fseek(f_ftpd, nsteel, SEEK_SET);
			fputc(ns_SHARE, f_ftpd);
			fseek(f_ftpd, temptell, SEEK_SET);
		}
		// Invalid users = XXXX
		if((ptr = strstr(LineBuf, "Invalid users = ")) != NULL){
			if(ptr[16] != 0x0A){			//Get the Invalid users value
				ptr += 16;
				wirite_to_file(f_ftpd, ptr, INV);
			}
		}
		// readlist = XXXX
		if((ptr = strstr(LineBuf, "readlist = ")) != NULL){
			if(ptr[11] != 0x0A){			//Get the readlist users value
				ptr += 11;
				wirite_to_file(f_ftpd, ptr, RO);
			}
		}
		// writelist = XXXX
		if((ptr = strstr(LineBuf, "writelist = ")) != NULL){
			if(ptr[12] != 0x0A){			//Get the writelist users value
				ptr += 12;
				wirite_to_file(f_ftpd, ptr, RW);
			}
		}
	}
	fclose(f_smb);
	fclose(f_ftpd);

//	printf("ftpd.conf created .. OK !!\n");
	return 0;
}


void wirite_to_file(FILE *file, char *buff, int sec)
{
	int i = 0, k = 0, sflag = 0;
	
	if(buff[strlen(buff)-2] != 0x2C){
		buff[strlen(buff)-1] = 0x2C;
//		buff[strlen(buff)] = 0x0A;
//		buff[strlen(buff)+1] = 0x00;
	}

	while(*buff != 0x0A && *buff != '\0'){
		if (sflag == 0)
			fputc(sec, file);
		if (*buff != ','){
			fputc(*buff, file);
			k++;  buff++;  sflag = 1;
		}
		else {
			for(i=0; i<(NAME_LIMIT-k); i++)
				fputc(0x00, file);
			k=0;  buff++;  sflag = 0;
		}	
	}
}

