/* httpd.c:  A very simple http server
 *
 * Copyright (c) 1997-1999 D. Jeff Dionne <jeff@rt-control.com>
 * Copyright (c) 1998      Kenneth Albanowski <kjahds@kjahds.com>
 * Copyright (c) 1999      Nick Brok <nick@nbrok.iaehv.nl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>
#include <sys/stat.h>
#include <dirent.h>
#include <signal.h>
#include <unistd.h>
#include <ctype.h>
#include "include/httpd.h"
#include "include/httpd_sysconf.h"
//#include "include/httpd_config.h"

#define SP_OPTIONS

#ifndef SOCK_STREAM
#define SOCK_STREAM       2
#endif

#define LONG_LEN			 30

#define DEBUG
#define SHOW_CONSOLE

#undef DEBUG
#undef SHOW_CONSOLE

#ifndef O_BINARY
#define O_BINARY 0
#endif

#define MIN(a,b) ((a) < (b) ? (a) : (b))
#define FIRMWARE_BUF_SIZE	1024*80
#define FIRMWARE_4M		    1000*950*4    // 4M + 512 bytes, 4M for image, 512 bytes for version header
#define LOGOUT_TIME         180

#define HTTPD_DOCUMENT_ROOT "/htdoc"
extern char uptime[LONG_LEN+1];

extern int copy(FILE *, FILE *);
extern int handle_get(FILE *, FILE *);
extern void DoCGI(FILE *out, char *filename, char *query);
extern void Init_Http_Var(void);
extern void get_uptime( void );
extern void get_time(void);
char *strastr(char *a, char *b);
void add_to_firmware( char *bufP, long *buflenP, char *str, int len);
extern void show_directory(char *field_name);

//add by snop to get the method
char method[5];
int auth=0, time=1;

#if defined(LOBOS) || defined(NOVAC)
    int nReady=1;
#endif

char postdata[2048];
char fmversion[10];
char hdcapacity[20];
char os[6];

char *firmware;
long firmware_len = 0;
int TIMEOUT=30;

void decodebase64(char *);
int base64val(char);

char referrer[128];
char content_type[128];
int real_length;




struct{
    char DHCP_ENABLE[2];
    char IP[20];
    char GATEWAY[20];
    char NETMASK[20];
    char HOSTNAME[17];
    char WORKGROUP[17];
    char HOSTNAME_FULL[51];
    char USERNAME[20];
    char PASSWORD[20];
    char FTP_MAX_UNIT[3];
	char FTP_PORT_NUMBER[6];
	char FTP_TIMEOUT[4];
	char FTP_ANONYMITY[2];
	char FTP_ENABLE[2];
	char LEGAL_IP[10][20];
	char IP_SECURITY_MODE[2];
	char LEGAL_MAC[10][30];
	char MAC_SECURITY_MODE[2];
	char TIME_MODE[2];
	char TIME_SERVER[40];
	char TIME_ZONE[25];
	char TIME_DIFFER[10];
	char TIME_VALUE[30];
	char DNS_SERVER[20];
	char CODE_SET[20];
	char TCONFIG_FOLDER[17];
	char TCONFIG_FILENAME[17];
	char TORRENT_USER[10];
	char TORRENT_ENABLE[2];
	char WEB_ENABLE[2];
	char WEB_PORT[6];
	char WEB_FOLDER[17];
	char CRON_ENABLE[2];
	char CRON_START_DAY[2];
	char CRON_START_HOUR[3];
	char CRON_START_MIN[3];
	char CRON_END_DAY[2];
	char CRON_END_HOUR[3];
	char CRON_END_MIN[3];
	char ADMIN_PORT[6];
	char USB_SHARE[2];
	char USB_RECYCLE[2];
//=======================allen adds to declaration USB saveconfiguration=======================
  char SERVER[2];
  //char SERVER2[2];
//=============================================================================================	
//=======================allen adds to declaration JUMBO saveconfiguration=======================
	char JUMBO[2];
//===============================================================================================
//========== allen adds to svae PORT series	===========
  char USB_PORT01[60];
  char USB_PORT02[60];
  char USB_PORT03[60];
  char USB_PORT04[60];
  char USB_PORT11[60];
  char USB_PORT12[60];
  char USB_PORT13[60];
  char USB_PORT14[60];
  char USB_PORT21[60];
  char USB_PORT22[60];
  char USB_PORT23[60];
  char USB_PORT24[60];
  char USB_PORT31[60];
  char USB_PORT32[60];
  char USB_PORT33[60];
  char USB_PORT34[60];
	char SWAP_ENABLE[5];
//===================================================================================================
//======================= allen adds to saving checksmb parameter =======================
	char INITBOOT[2];
  char SLEEPMODE[2];	
//===============================================================================================
#if defined(PCI)	
	char INTERFACE_SET[20]; //UI Language
#endif
#if defined(ENCORE) || defined(NONBRAND)
	char ITUNES_ENABLE[2];
	char ITUNES_FOLDER[32];
	char UPNP_ENABLE[2];
	char UPNP_FOLDER[32];
#endif
}CONFIG;

//#define SERVER_PORT 80
char SERVER_PORT[6];
//sp
#ifdef HTTPD_MAX_ACCEPT
# include <stdarg.h>
# include "include/sp_cservice_dbg.h"
# define STR_NUM_CITICAL    	"/var/run/num_critical" 
# define STR_NUM_ACCEPT    		"/var/run/num_accept" 
# define WATCHDOG_PID_FILE		"/var/run/watchdog.pid"
# define CHECK_ACCEPT_MARGIN	7500
# define WATCHDOG_NAME			"watchdog"
# define SIGWATCHDOG			101
int accept_count=0;
int current_accept_count=0;
int current_num_crt=0;
#endif//#ifdef HTTPD_MAX_ACCEPT

int PrintHeader(FILE *f, int contenttype){
  
    alarm(TIMEOUT);
    fprintf(f,"HTTP/1.0 200 OK\n");
    switch (contenttype){ 
        case 't':
            fprintf(f,"Content-type: text/plain\n");
            break;
        case 'g':
            fprintf(f,"Content-type: image/gif\n");
            break;
        case 'j':
            fprintf(f,"Content-type: image/jpeg\n");
            break;
        case 'h':
            fprintf(f,"Content-type: text/html\n");
            break;
    }
    fprintf(f,"Server: uClinux-httpd 0.2.2\n");
    fprintf(f,"Expires: 0\n");
    fprintf(f,"\n");
    alarm(0);
    return(0);
}

int DoTgz(FILE *f, char *name){
  
    FILE * infile;
 
    //printf("DoTgz.cgi name=%s!!\n", name);
    
    if(strstr(name,"config.tgz")){
    	system("/etc/rc.d/save_config.sh");
    	system("/bin/dd if=/dev/mtd_linux_cfg of=/tmp/config.tgz bs=1k count=32 >/dev/null 2>&1");
      printf("refresh the config.tgz to reflash memory!!\n");
    }
    if(!(infile = fopen(name, "r"))){
        alarm(TIMEOUT);
        fprintf(stderr, "Unable to open TGZ file %s, %d\n", name, errno);
        fflush(f);
        alarm(0);
        //return -1;
        return 0;
    }

    PrintHeader(f,'t');
 
    copy(infile,f); /* prints the page */
 
    alarm(TIMEOUT);
    fclose(infile);
    alarm(0);
 
    return 0;
}

int DoJpeg(FILE *f, char *name){
  
    FILE * infile;
 
    if(!(infile = fopen(name, "r"))){
        alarm(TIMEOUT);
        fprintf(stderr, "Unable to open JPEG file %s, %d\n", name, errno);
        fflush(f);
        alarm(0);
        //return -1;
        return 0;
    }

    PrintHeader(f,'j');
 
    copy(infile,f); /* prints the page */
 
    alarm(TIMEOUT);
    fclose(infile);
    alarm(0);
 
    return 0;
}

int DoBmp(FILE *f, char *name){
  
    FILE * infile;
 
    if(!(infile = fopen(name, "r"))){
        alarm(TIMEOUT);
        fprintf(stderr, "Unable to open BMP file %s, %d\n", name, errno);
        fflush(f);
        alarm(0);
        //return -1;
        return 0;
    }

    PrintHeader(f,'j');
 
    copy(infile,f); /* prints the page */
 
    alarm(TIMEOUT);
    fclose(infile);
    alarm(0);
 
    return 0;
}

int DoGif(FILE *f, char *name){

    FILE * infile;

    if(!(infile = fopen(name, "r"))){
        alarm(TIMEOUT);
        fprintf(stderr, "Unable to open GIF file %s, %d\n", name, errno);
        fflush(f);
        alarm(0);
        //return -1;
        return 0;
    }

    PrintHeader(f,'g');

    copy(infile,f); /* prints the page */  

    alarm(TIMEOUT);
    fclose(infile);
    alarm(0);
  
    return 0;
}

int DoDir(FILE *f, char *name){
	
    DIR * dir;
    struct dirent * dirent;

    if((dir = opendir(name))== 0){
        fprintf(stderr, "Unable to open directory %s, %d\n", name, errno);
        fflush(f);
        //return -1;
        return 0;
    }
  
    PrintHeader(f,'h');
  
    alarm(TIMEOUT);
    fprintf(f, "<H1>Index of %s</H1>\n\n",name);
    alarm(0);

    if(name[strlen(name)-1] != '/'){
	    strcat(name, "/");
    }
  
    while((dirent = readdir(dir)) != NULL){
	    alarm(TIMEOUT); 
	    fprintf(f, "<p><a href=\"/%s%s\">%s</a></p>\n", name, dirent->d_name, dirent->d_name);
	    alarm(0);
    }
  
    closedir(dir);
    return 0;
}

int DoHTML(FILE *f, char *name){
  
    FILE *infile;
  
    if(!strcmp(name,"network-ip.htm"))
        Init_Http_Var();
    if(!strcmp(name,"admin-time.htm"))
        get_time();
    if(!strcmp(name,"user_add.htm"))
        show_directory("sel_dir");
    if(!strcmp(name,"torrent_basic.htm"))
        show_directory("torrent_dir");
    if(!strcmp(name,"web-server.htm"))
        show_directory("web_dir"); 
    if(!strcmp(name,"admin-codeset.htm"))
        show_directory("code_dir");   
#if defined(PCI)
    if(!strcmp(name,"big5_network-ip.htm"))
        Init_Http_Var();
    if(!strcmp(name,"big5_admin-time.htm"))
        get_time();
    if(!strcmp(name,"big5_user_add.htm"))
        show_directory("sel_dir");
    if(!strcmp(name,"big5_torrent_basic.htm"))
        show_directory("torrent_dir");
    if(!strcmp(name,"big5_web-server.htm"))
        show_directory("web_dir"); 
    if(!strcmp(name,"big5_admin-codeset.htm"))
        show_directory("code_dir");   
#endif
        
#ifdef NOVAC
    if(!strcmp(name,"close.htm")){
        incoming_ip[0] = '\0';
        check_ip[0] = '\0';
        release = 1;
    }
#endif
#if defined(LOBOS) || defined(NOVAC)
    if(strcmp(check_ip,incoming_ip))
        strcpy(name,"limit-warn.htm");
#endif
    if(!(infile = fopen(name,"r"))) {
        alarm(TIMEOUT);
        fprintf(stderr, "Unable to open HTML file %s, %d\n", name, errno);
        fflush(f);
        alarm(0);
        //return -1;
        return 0;
    }

    PrintHeader(f,'h');
    //copy(infile,f); /* prints the page */  
    handle_get(infile,f);

    alarm(TIMEOUT);
    fclose(infile);
    alarm(0);

    return 0;
}

int DoText(FILE *f, char *name)
{
/*   char *buf; */
  FILE *infile;
/*   int count; */

  if (!(infile = fopen(name,"r"))) {
    alarm(TIMEOUT);
    fprintf(stderr, "Unable to open text file %s, %d\n", name, errno);
    fflush(f);
    alarm(0);
    //return -1;
    return 0;
  }

  PrintHeader(f,'t');
  copy(infile,f); /* prints the page */  

  alarm(TIMEOUT);
  fclose(infile);
  alarm(0);

  return 0;
}

//snop adds to decode base64-coded username-password
void decodebase64(char *string){
	                                                            
    char *src = string, *dest = string;
    unsigned long val;
    while (src[0] != '\0' && src[1] != '\0' && src[2] != '\0'&& src[3] != '\0'){
        val = base64val(src[3])
            + ( base64val(src[2]) << 6)
            + ( base64val(src[1]) << 12)
            + ( base64val(src[0]) << 18);
        if (src[3] == '=') val &= 0xffff00;
        if (src[2] == '=') val &= 0xff0000;
        dest[2] = val & 0xff;
        dest[1] = (val >> 8) & 0xff;
        dest[0] = (val >> 16) & 0xff;
        src += 4;
        dest += 3;
    }
    *dest = '\0';
}

int base64val(char c){

    int n;
    if (c >= 'A' && c <= 'Z') n = c - 'A';
    else if (c >= 'a' && c <= 'z') n = 26 + c - 'a';
    else if (c >= '0' && c <= '9') n = 52 + c - '0';
    else if (c == '+') n = 62;
    else if (c == '/') n = 63;
    else n = 0;
    return n;
}
#if defined(PCI)
int getLangConfig(){
    FILE *fip;
    char LineBuf[256], TagName[15];
    char *ptr, *end;
    int i=0;
    int language;
      
    if((fip = fopen("/etc/config","r")) == NULL)  
        return 0;

    while(fgets(LineBuf,255,fip) != NULL){
        for(i=0;i<255;i++){
            if((LineBuf[i] == ' ') || (LineBuf[i] == '\n') || (LineBuf[i] == '\r')){
	            LineBuf[i] = '\0';
	            i=256;
	        }
	    }
	    if((ptr = strstr(LineBuf,"INTERFACE_SET='")) != NULL){
	        ptr+=15;
	        end = strchr(ptr,'\'');
	    	  *end = '\0';
	                
	        if(strstr(ptr,"950")!=NULL){
	          language=CHINESE;
	          break;
	        }
	        else{
	        	 language=ENGLISH;
	        	 break;
	        }
	    }
	}
	fclose(fip);
	return language;
}
#endif

int ParseReq(FILE *f, char *r){
	
    char *bp;
    struct stat stbuf;
    char * arg;
    char * c;
    char *ptr, *line;
    char *url, *head;
    char *dir_ptr, *end_dir;
#if defined(PCI)	
	LANG = getLangConfig();
#endif
#ifdef DEBUG
    printf("req is '%s'\n", r);
#endif

    //snop adds to get the method
    if(!strncmp(r,"GET",3)) 
        strcpy(method,"GET");
    if(!strncmp(r,"POST",4)) 
        strcpy(method,"POST");
    
    while(*(++r) != ' ');  /*skip non-white space*/
    while(isspace(*r))
  	    r++;
  	//========== let CGI knows '/' without decoding for P2P directory ======================
  	if(strstr(r,"list_torrent_file.cgi") || strstr(r,"show_download_folder.cgi")){
  		dir_ptr = strchr(r,'?');
  		dir_ptr++;
  		if((end_dir = strchr(dir_ptr,' ')) != NULL)
  	        *end_dir = '\0';
  		list_torrent_file(dir_ptr,f);
  		return 0;
  	}

  	if(strstr(r,"Show_download_status.cgi")){
  		dir_ptr = strchr(r,'?');
  		dir_ptr++;
  		if((end_dir = strchr(dir_ptr,' ')) != NULL)
  	        *end_dir = '\0';
  	    Show_download_status(dir_ptr,f);
  	    return 0;
  	}
  	if(strstr(r,"Show_queue_config.cgi")){
  		dir_ptr = strchr(r,'?');
  		dir_ptr++;
  		if((end_dir = strchr(dir_ptr,' ')) != NULL)
  	        *end_dir = '\0';
  	    Show_queue_config(dir_ptr,f);
  	    return 0;
  	}
  	if(strstr(r,"change_queue_config.cgi")){
  		dir_ptr = strchr(r,'?');
  		dir_ptr++;
  		if((end_dir = strchr(dir_ptr,' ')) != NULL)
  	        *end_dir = '\0';
  	    change_queue_config(dir_ptr,f);
  	    return 0;
  	}
  	//======================================================================================
    if(!strstr(r,"dir.js"))  //snop adds for showing FTP folder
    while (*r == '/')
  	    r++;
  	
#ifdef DEBUG
    printf("r: %s\n",r);
#endif

    if(strcmp(method, "POST") == 0){
        real_length = strlen(postdata);
        if((postdata[real_length-2] == '\r') && (postdata[real_length-1] == '\n'))  
            real_length -= 2;
	}
	
    //snop adds to get the CGI function name
    bp = line = r;
    ptr = strchr(line,' ');
    *(ptr+1) = '\0';
    while(((ptr=strchr(line,'/')) != NULL) && !strstr(line,"dir.js"))  //snop adds for showing FTP folder
        line = ptr+1;
        
#ifdef DEBUG
    printf("line: %s\n",line);
#endif

    while(*r && (*(r) != ' ') && (*(r) != '?'))
  	    r++;
  	
#ifdef DEBUG
    printf("bp='%s', r='%s'\n", bp, r);
    printf("method is %s\n",method);
#endif
  		
    if(*r == '?'){
        char * e;
  	    *r = 0;
  	    arg = r+1;
  	    if((e = strchr(arg,' ')) != NULL){
  	        *e = '\0';
            //snop adds to handle CGI
            ptr = line;
            DoCGI(f,ptr,arg);
            return 0;
#ifdef DEBUG
            printf("arg is %s\n",arg);
#endif
  	    }
    }else{
  	    arg = 0;
  	    *r = 0;
    }
  
    c = bp;
    
	// andy add for unescape 
	unescape(c);
	//printf("c=%s, r-1=%s\n",c,r-1);
	
    if (c[0] == '\0') 
        strcat(c,".");

    if(c && !stat(c, &stbuf)){
        if(S_ISDIR(stbuf.st_mode)){ 
      	    char * end = c + strlen(c);
      	    #if defined(LOBOS) || defined(NOVAC)
      	        if(strcmp(check_ip,incoming_ip))
      	            strcat(c, "/limit-warn.htm");
      	        else
      	    #endif
#if defined(PCI)
	if (getLangConfig()==CHINESE)
   	strcat(c, "/big5_index.htm");
   else
   	strcat(c, "/index.htm");
#else
	strcat(c, "/index.htm");
#endif
    	        if(!stat(c, &stbuf)){
    		  	    DoHTML(f, c);
    		    }else{
  				    *end = '\0';
				    //DoDir(f,c);
			    }
        }else if (!strcasecmp(r - 4, ".gif"))
   	 	    DoGif(f,c);
        else if (!strcasecmp(r - 4, ".bmp"))
   	 	    DoBmp(f,c);   	 	    
  	    else if (!strcasecmp(r - 4, ".jpg") || !strcmp(r - 5, ".jpeg") || stristr(c,".jpg") || strstr(c,".jpeg"))
  	    //else if (!strcasecmp(r - 4, ".jpg") || !strcmp(r - 5, ".jpeg"))
   	  	    DoJpeg(f,c);
  	    else if (!strcmp(r - 4, ".htm") || !strcmp(r - 5, ".html") || stristr(c,".htm") || stristr(c,".html"))
		//else if (!strcmp(r - 4, ".htm") || !strcmp(r - 5, ".html"))  	    
   	  	    DoHTML(f,c);
  	    else if(!strcmp(r-3,".js") || !strcmp(r-4,".css"))  //snop modifies so that other kind of files will not be get
      	    DoText(f,c);
      	else if(!strcmp(r - 4,".tgz"))  //allen adds to parser the *.tgz file
      	    DoTgz(f,c);    
    }else{
        //snop adds to handle CGI function 
        if(!strcmp(r-4,".cgi")){
            url = c;
            while((head=strchr(url,'/'))!=NULL)
                url = head + 1;
#if defined(LOBOS) || defined(NOVAC)
            if(strcmp(check_ip,incoming_ip))
                DoHTML(f,"limit-warn.htm");
            else
#endif
                DoCGI(f,url,arg);
#ifdef DEBUG
	        printf("CGI c:%s url:%s\n",c,url);
#endif
            return 0;
        }
        PrintHeader(f,'h');
        alarm(TIMEOUT);
        fprintf(f, "<html><head><title>404 File Not Found</title></head>\n");
        fprintf(f, "<body>The requested URL was not found on this server</body></html>\n");
        alarm(0);
    }
    return 0;
}

void sighup(int signo){
	ReadConfiguration();
}

void sigalrm(int signo){
    /* got an alarm, exit & recycle */
	exit(0);
}

//char firm_buf[FIRMWARE_BUF_SIZE];

int HandleConnect(fd){
	
    FILE *f;
    
    //Extend the buffer size(160->1024) by snop
    //extend the buffer size (1024->2048) by dean
    //this accomodates Wget.cgi (extra long GET request)
    char buf[2048];
    char buf1[2048];
    char *auth_hdr, *password;
    char *end, *ptr, *over;
    ptr = NULL;

    f = fdopen(fd,"r+");    //FILE *out, LATER
    if(!f){
        fprintf(stderr, "httpd: Unable to open httpd input fd, error %d\n", errno);
        alarm(TIMEOUT);
        close(fd);
        alarm(0);
        return 0;
    }
    setbuf(f, 0);

    alarm(TIMEOUT);

    if(!fgets(buf, 2048, f)){
        fprintf(stderr, "httpd: Error reading connection, error %d\n", errno);
        fclose(f);
        alarm(0);
        return 0;
    }
    
    
	if(strstr(buf," /photo/")){
		//printf("here is URI: /photo\n");
		while(fgets(buf1, 2048, f) && (strlen(buf1) > 2))
				;
		ParseReq(f, buf);		
	}
    else{
#ifdef DEBUG
  printf("buf = '%s'\n", buf);
#endif

#ifdef SP_OPTIONS
	{
		char *find_options;
		if( (find_options=strstr(buf,"OPTIONS "))!=NULL)	{
			fprintf(f,"HTTP/1.1 501 Not Implemented\r\n"
						  "Server: thttpd/2.25b 29dec2003\r\n"
						  "Content-Type: text/html; charset=\r\n"
						  "Accept-Ranges: bytes\r\n"
						  "Connection: close\r\n"
						  "Cache-Control: no-cache,no-store\r\n"
						  "<HTML>\r\n"
						  "<HEAD><TITLE>501 Not Implemented</TITLE></HEAD>\r\n"
						  "BODY BGCOLOR=\"#cc9999\" TEXT=\"#000000\" LINK=\"#2020ff\" VLINK=\"#4040cc\"\r\n"
						  "<H2>501 Not Implemented</H2>\r\n"
						  "The requested method 'OPTIONS' is not Implemented be this server\r\n"
						  "<HR>\r\n"
						  "<ADDRESS><A HREF=\"http://www.acme.com/software/thttpd/\">thttpd/2.25b 29dec2003</A></ADDRESS>\r\n"
						  "</BODY>"
						  "</HTML>\r\n"
						  );
			
			fflush(f);
		    fclose(f);
		    close(fd);    //To solve error-24
		    alarm(0);
		    return 1;
		}
    }	
#endif//#ifdef SP_OPTIONS
    
    alarm(0);
    referrer[0] = '\0';
    content_type[0] = '\0';
    content_length = -1;
    
    alarm(TIMEOUT);

    while(fgets(buf1, 2048, f) && (strlen(buf1) > 2)){

        alarm(TIMEOUT);
        
#ifdef DEBUG
    printf("Got buf1 '%s'\n", buf1);
#endif

        //snop adds for authentication
        //printf("auth = %d, time = %d\n",auth,time);
        //printf("CONFIG.USERNAME: %s,CONFIG.PASSWORD: %s\n",CONFIG.USERNAME,CONFIG.PASSWORD);
        auth_hdr = strstr(buf1,"Authorization: Basic ");
        if(auth_hdr != NULL){
            auth_hdr += strlen("Authorization: Basic ");
            if((end = strchr(auth_hdr, '\r')) != NULL) *end = '\0';
            if((end = strchr(auth_hdr, '\n')) != NULL) *end = '\0';
            decodebase64(auth_hdr);
            ptr = auth_hdr;
            password = strchr(ptr,':');
            password++;
            over = strchr(ptr,':');
            *over = '\0';
            //printf("auth_hdr = %s, password = %s\n",auth_hdr,password);
            if( strlen(CONFIG.USERNAME) == strlen(ptr) )
            if(!strncmp(auth_hdr,CONFIG.USERNAME,strlen(CONFIG.USERNAME))){
                if(strcmp( password, CONFIG.PASSWORD )==0){
                    auth=1;
                    time++;
                }
            }
        }
        //end

        if(!strncasecmp(buf1, "Referer:", 8)){
            char * c = buf1+8;
            while (isspace(*c))
	        c++;
            strcpy(referrer, c);
        }else if(!strncasecmp(buf1, "Referrer:", 9)){
            char *c = buf1+9;
            while (isspace(*c))
	        c++;
            strcpy(referrer, c);
        }else if(!strncasecmp(buf1, "Content-length:", 15)){
            content_length = atoi(buf1+15);          
        }else if ( strncasecmp( buf1, "Content-Type:", 13 ) == 0 ){
	  		char *c = buf1+13;
	  		c += strspn( c, " \t" );
	  		strcpy( content_type, c );
		}else if( strncasecmp( buf1, "User-Agent:", 11 ) == 0 ){    //To identify the OS
			char *c = buf1+11;
			if(strstr(c,"Linux"))
			    strcpy(os,"LINUX");
			else
			    strcpy(os,"WIN");
		}
    }

    if(content_length > 1){    //To accept the data delivered by post
        if( buf1[0] == '\r' || buf1[0] == '\n' ){
		    if( strstr(content_type, "boundary") != NULL ){
		    }else{
	       	    memset( postdata, 2048, 0);        	
		        if(!strcmp(os,"LINUX"))
		            fread(postdata,content_length,1,f);
		        else
	    	        fgets( postdata, 2000, f) ;
		    }

        }
    }
    strcpy(wget_postdata, postdata);
    memset( postdata, 2048, 0);
#ifdef DEBUG
    printf("%s: Line%d - postdata = %s\n",__func__,__LINE__,postdata);
#endif
    alarm(0);
  
    if(ferror(f)){
        fprintf(stderr, "http: Error continuing reading connection, error %d\n", errno);
        fclose(f);
        return 0;
    }
    
    //snop adds for Authentication
#ifdef DEBUG
    printf("auth = %d, time = %d\n",auth,time);
#endif

#if defined(LOBOS)
    if(((auth==0) && (time==1)) || (nReady==0)){
    	//if(ban == 0)
		    fprintf(f,"HTTP/1.0 401 Unauthorized\r\n"
					  "WWW-Authenticate: Basic realm=\"LB-SS01 TXI\" \r\n\r\n"
					  "<html>\r\n"
					  "<head><title>401 Unauthorized</title></head>\r\n"
					  "<body><h1>401 Unauthorized</h1>\r\n"
					  "<p>Access to this resource is denied; your client has not supplied"
					  " the correct authentication.</p></body>\r\n</html>\r\n");
    }
    if(nReady==0){
    	auth = 0;
    	time = 1;
    }
#elif defined(NOVAC)
    if(((auth==0) && (time==1)) ){
			fprintf(f,"HTTP/1.0 401 Unauthorized\r\n"
					  "WWW-Authenticate: Basic realm=\"NV-NAS390\" \r\n\r\n"
					  "<html>\r\n"
					  "<head><title>401 Unauthorized</title></head>\r\n"
					  "<body><h1>401 Unauthorized</h1>\r\n"
					  "<p>Access to this resource is denied; your client has not supplied"
					  " the correct authentication.</p></body>\r\n</html>\r\n");
    }
#elif defined(CENTURY)
    if(((auth==0) && (time==1)) ){
			fprintf(f,"HTTP/1.0 401 Unauthorized\r\n"
					  "WWW-Authenticate: Basic realm=\"LANDISK\" \r\n\r\n"
					  "<html>\r\n"
					  "<head><title>401 Unauthorized</title></head>\r\n"
					  "<body><h1>401 Unauthorized</h1>\r\n"
					  "<p>Access to this resource is denied; your client has not supplied"
					  " the correct authentication.</p></body>\r\n</html>\r\n");
    }   
#elif defined(PCI) || defined(PCIJ)
    //printf("auth = %d, time = %d\n",auth,time);
	if(((auth==0) && (time==1)) ){
			fprintf(f,"HTTP/1.0 401 Unauthorized\r\n"			
					  "WWW-Authenticate: Basic realm=\"NAS-01G\" \r\n\r\n"
					  "<html>\r\n"
					  "<head><title>401 Unauthorized</title></head>\r\n"
					  "<body><h1>401 Unauthorized</h1>\r\n"
					  "<p>Access to this resource is denied; your client has not supplied"
					  " the correct authentication.</p></body>\r\n</html>\r\n");
    }
#else
    //printf("auth = %d, time = %d\n",auth,time);
	if(((auth==0) && (time==1)) ){
			fprintf(f,"HTTP/1.0 401 Unauthorized\r\n"			
					  "WWW-Authenticate: Basic realm=\"Network HardDisk\" \r\n\r\n"
					  "<html>\r\n"
					  "<head><title>401 Unauthorized</title></head>\r\n"
					  "<body><h1>401 Unauthorized</h1>\r\n"
					  "<p>Access to this resource is denied; your client has not supplied"
					  " the correct authentication.</p></body>\r\n</html>\r\n");
					
    }
    
#endif      

#ifdef DEBUG
    printf("come in ParseReq\n");
#endif
    //printf("auth = %d, time = %d\n",auth, time);
#if defined(LOBOS) || defined(NOVAC)
    if((auth !=0 && time !=1) || strcmp(check_ip,incoming_ip))
#else
    if(auth != 0 && time != 1)
#endif
        ParseReq(f, buf);
	}  // end of else in if(strstr(buf," /photo/"))
    alarm(TIMEOUT);
    fflush(f);
    fclose(f);
    close(fd);    //To solve error-24
    alarm(0);

    return 1;
}

int main(int argc, char *argv[]){	
	
    int s;
    int len;
    int true = 1;
    struct sockaddr_in ec;
    struct sockaddr_in server_sockaddr;
    int watchdog_pid;
    int opt;
    //snop adds for timeout
#if defined(LOBOS) || defined(NOVAC)
    int sockfd;
    struct timeval timeout;
    fd_set readfds, rset;
    FILE *fout;
#endif

    printf("Starting main()!!\n");

    signal(SIGCHLD, SIG_IGN);
    signal(SIGPIPE, SIG_IGN);
    signal(SIGALRM, sigalrm);
//andy
    signal(SIGHUP, sighup);
//end
  ReadConfiguration();
#ifdef HTTPD_MAX_ACCEPT
	watchdog_pid=get_pid_from_file(WATCHDOG_PID_FILE);
#endif//#ifdef HTTPD_MAX_ACCEPT

    chdir("/htdocs");
    
    Init_Http_Var();
  
    if(argc > 1 && !strcmp(argv[1], "-i")){
        /* I'm running from inetd, handle the request on stdin */
        fclose(stderr);
        HandleConnect(0);
        exit(0);
    }
    while((opt = getopt(argc,argv,"p:")) != -1){
	    switch(opt){
		    case 'p':
				strcpy(SERVER_PORT,optarg);
				printf("SERVER_PORT = %s(%d)\n",SERVER_PORT,atoi(SERVER_PORT));
			    break;
		}
	}

    if((s = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == -1){
        perror("Unable to obtain network");
        exit(1);
    }
  
    if((setsockopt(s, SOL_SOCKET, SO_REUSEADDR, (void *)&true, sizeof(true))) == -1){
        perror("setsockopt failed");
        exit(1);
    }

    server_sockaddr.sin_family = AF_INET;
    //server_sockaddr.sin_port = htons(SERVER_PORT);
    server_sockaddr.sin_port = htons(atoi(SERVER_PORT));
    server_sockaddr.sin_addr.s_addr = htonl(INADDR_ANY);
  
    if(bind(s, (struct sockaddr *)&server_sockaddr, sizeof(server_sockaddr)) == -1){
        perror("Unable to bind socket");
        printf("Unable to bind socket\n");
        exit(1);
    }

    if(listen(s, 8*3) == -1){ 		/* Arbitrary, 8 files/page, 3 clients */
        perror("Unable to listen");
        exit(4);
    }

#if defined(LOBOS) || defined(NOVAC)
    incoming_ip[0] = '\0';
    check_ip[0] = '\0';
#endif

//sp
#ifdef HTTPD_MAX_ACCEPT          
	sp_httpdTrace("%s: %s..:STR_NUM_CITICAL=%s\n", __FILE__, __func__, STR_NUM_CITICAL);
	sp_system("echo 0 > %s", STR_NUM_CITICAL);   
	sp_system("echo 0 > %s", STR_NUM_ACCEPT);   
#endif//#ifdef HTTPD_MAX_ACCEPT          



    while(1){  	
  	    len = sizeof(ec);
#if defined(LOBOS) || defined(NOVAC)
  	    sockfd = s;
#endif

#ifdef HTTPD_MAX_ACCEPT        
	    if(current_accept_count >= CHECK_ACCEPT_MARGIN){
            sp_httpdTrace("%s: %s..:if(current_accept_count >= CHECK_ACCEPT_MARGIN)	\n", __FILE__, __func__);
    	    if( (current_num_crt == 0 ) ){
    	        close(fd);
    		    kill(watchdog_pid, SIGWATCHDOG);
    		    sp_httpdTrace("%s:  %s..:before  exit\n",  __FILE__,  __func__);
    		    //printf("%s:  %s..:before reload httpd\n",  __FILE__,  __func__);
    		    exit(0); 
    	    }    	
	    }
#endif//#ifdef HTTPD_MAX_ACCEPT          
		
        if((fd = accept(s, (void *)&ec, &len)) == -1){
            close(s);
            exit(5);
        }else{
#if defined(LOBOS) || defined(NOVAC)
            if(release != 1){
	            if(incoming_ip[0] == '\0'){
	                strcpy(incoming_ip,(char *)inet_ntoa(ec.sin_addr));
	                strcpy(check_ip,(char *)inet_ntoa(ec.sin_addr));
	                //printf("Line 731: incoming_ip = %s, check_ip = %s\n",incoming_ip,check_ip);
	            }else{
	                strcpy(check_ip,(char *)inet_ntoa(ec.sin_addr));
	                //printf("Line 734: incoming_ip = %s, check_ip = %s\n",incoming_ip,check_ip);
	            }
	        }else{
	            release = 0;
	        #ifdef NOVAC
	            incoming_ip[0] = '\0';
	        #endif
	        }
#endif        
            auth = 0;
            time = 1;
#ifdef HTTPD_MAX_ACCEPT          
            accept_count++;
            sp_httpdTrace("%s: %s..:accept_count=%d\n", __FILE__, __func__, accept_count);
            if(accept_count >= CHECK_ACCEPT_MARGIN){	
                current_accept_count = accept_count;
                set_num_accept(accept_count);
            }
#endif//#ifdef HTTPD_MAX_ACCEPT          
        }

        HandleConnect(fd);
          
#if defined(LOBOS) || defined(NOVAC)
        //snop adds for timeout
        FD_ZERO(&readfds);
        FD_SET(s, &readfds);
        timeout.tv_sec = LOGOUT_TIME;
        timeout.tv_usec = 0;
        rset = readfds;
        nReady = select(sockfd+1, &rset, NULL, NULL, &timeout);
        if(nReady == 0){
            incoming_ip[0] = '\0';
        #ifdef DEBUG
            printf("nReady = 0\n");
        #endif
        }
#endif      
    }  
}

char *strastr(char *a, char *b){
	
    char *c;
    char *d;

    while(*a){
        c = (char *)b;
        d = (char *)a;

        while(*c){
            if(tolower(*c) != tolower(*d)){
                break;
            }
            if(!(*d)){
                return NULL;   /* a is too short */
            }
            c++;
            d++;
        }

        if(!(*c)){
            return (char *)a;
        }
        a++;
    }
    return NULL;
}

int Get_Security(char *test_ip){
	
	FILE *f1, *f2;
	char LineBuf[256], TagName[15], command[80], test_mac[30];
    char *ptr, *end;
    int i=0;
    char IP_SECURITY_MODE[2], LEGAL_IP[10][20], MAC_SECURITY_MODE[2], LEGAL_MAC[10][30];
    
    if((f1 = fopen("/etc/config","r")) == NULL)  
        return 0;
    //First, read the latest configuration
    while(fgets(LineBuf,255,f1) != NULL){
        for(i=0;i<255;i++){
            if((LineBuf[i] == ' ') || (LineBuf[i] == '\n') || (LineBuf[i] == '\r')){
	            LineBuf[i] = '\0';
	            i=256;
	        }
	    }
	    if((ptr = strstr(LineBuf,"IP_SECURITY_MODE='")) != NULL){
	        ptr+=18;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(IP_SECURITY_MODE, ptr);
	    }
	    for(i=0;i<10;i++){
	    	sprintf(TagName,"LEGAL_IP%d='",i+1);
	        if((ptr = strstr(LineBuf,TagName)) != NULL){
	        	if(i<9)
	                ptr+=11;
	            else
	                ptr+=12;
	            end = strchr(ptr,'\'');
	    	    *end = '\0';
	            strcpy(LEGAL_IP[i], ptr);
	        }
	    }
	    if((ptr = strstr(LineBuf,"MAC_SECURITY_MODE='")) != NULL){
	        ptr+=19;
	        end = strchr(ptr,'\'');
	    	*end = '\0';
	        strcpy(MAC_SECURITY_MODE, ptr);
	    }
	    for(i=0;i<10;i++){
	    	sprintf(TagName,"LEGAL_MAC%d='",i+1);
	        if((ptr = strstr(LineBuf,TagName)) != NULL){
	        	if(i<9)
	                ptr+=12;
	            else
	                ptr+=13;
	            end = strchr(ptr,'\'');
	    	    *end = '\0';
	            strcpy(LEGAL_MAC[i], ptr);
	        }
	    }
	}
	//printf("Line 869\n");
	fclose(f1);
    //printf("Line 871\n");
	//IP and MAC security are both disabled
	if(atoi(IP_SECURITY_MODE) == 0 && atoi(MAC_SECURITY_MODE) == 0)
	    return 0;
	//Check the IP
	//printf("IP_SECURITY_MODE = %d\n",atoi(IP_SECURITY_MODE));
	if(atoi(IP_SECURITY_MODE) == 1){
		for(i=0;i<10;i++){
			if(!strncmp(test_ip,LEGAL_IP[i],strlen(test_ip))){
				//printf("mode = 1: test_ip = %s and LEGAL_IP[i] = %s\n",test_ip,LEGAL_IP[i]);
			    return 0;    //PERMITTED!!
			}
		}
		return 1;
	}
	if(atoi(IP_SECURITY_MODE) == 2){
		for(i=0;i<10;i++){
			if(!strncmp(test_ip,LEGAL_IP[i],strlen(test_ip))){
				//printf("mode = 2: test_ip = %s and LEGAL_IP[i] = %s\n",test_ip,LEGAL_IP[i]);
			    return 1;    //NOT ALLOWED!!
			}
		}
		return 0;    //PERMITTED!!
	}
	//Get the access MAC
	if(atoi(MAC_SECURITY_MODE) == 1 || atoi(MAC_SECURITY_MODE) == 2){
		sprintf(command,"arp %s > /var/run/mac",test_ip);
		system(command);
		if((f2 = fopen("/var/run/mac","r")) == NULL)
		    return 0;
		else{
		    while(fgets(LineBuf,255,f2) != NULL){
		    	if((ptr = strstr(LineBuf,test_ip)) != NULL){
		    		ptr = strchr(LineBuf,'*');
		    		ptr++;
		    		end = strchr(ptr,' ');
		    		*end = '\0';
		    		strcpy(test_mac,ptr);
		    	}
		    }
	    }
	}
	fclose(f2);
	//printf("Line 915: test_mac = %s\n",test_mac);
	//printf("MAC_SECURITY_MODE = %d\n",atoi(MAC_SECURITY_MODE));
	//Check the MAC
	if(atoi(MAC_SECURITY_MODE) == 1){
		for(i=0;i<10;i++){
			if(!strncmp(test_mac,LEGAL_MAC[i],strlen(test_mac))){
				//printf("mode = 1: test_mac = %s, LEGAL_MAC[i] = %s\n",test_mac,LEGAL_MAC);
			    return 0;    //PERMITTED!!
			}
		}
		//printf("Line 925: return 1\n");
		return 1;    //NOT ALLOWED!!
	}
	if(atoi(MAC_SECURITY_MODE) == 2){
		for(i=0;i<10;i++){
			if(!strncmp(test_mac,LEGAL_MAC[i],strlen(test_mac))){
				//printf("mode = 2: test_mac = %s, LEGAL_MAC[i] = %s\n",test_mac,LEGAL_MAC);
			    return 1;    //NOT ALLOWED!!
			}
		}
		//printf("Line 935: return 0\n");
		return 0;    //PERMITTED!!
	}
	//printf("Line 938\n");
	return 0;
}
