#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>
#include <sys/stat.h>
#include <dirent.h>
#include <signal.h>
#include <unistd.h>
#include <ctype.h>
#include <stdarg.h>

//=========== Define Customer Name ===========
//#define NH230
//#undef NH230  //define NH221 nonbrand model
//============================================

/* The logo file size in pixel is "136*61*24b(true color)"
*/
#define ALLNET_COLOR_OVERALL_BG    	"FFFFFF"	  // white (for the background) - get_overall_bg()
#define ALLNET_COLOR_BANNER_BG    	"0050a0"	  // dark blue (background of the title bar) - get_banner_bg()
#define ALLNET_COLOR_BG    	        "D6EFFF"		// light blue (column of the table) - get_column_bg()
#define ALLNET_BAR_FONT_COLOR    	  "FFFFFF"		// write ( text of title bar) - get_bar_font_color()

#define CENTURY_COLOR_OVERALL_BG    "FFFFFF"    // white for NH220 Century (as LOBOS NH200)

#define NH230_COLOR_OVERALL_BG      "333399"    // dark blue for EXT3 nonbrand base on NH230(background)
#define NH230_COLOR_BANNER_BG       "AAE0FA"    // yellow for EXT3 base on NH230(title bar)

#define NH221_COLOR_OVERALL_BG  	  "020759"    // dark blue for EXT3 nonbrand baso on NH221 (background)
#define NH221_COLOR_BANNER_BG   	  "6266AF"    // light blue for EXT3 base on NH221(title bar)

//#define F6200_COLOR_OVERALL_BG    "FFBEBB"	  // light red (for the background)
//#define F6200_COLOR_BANNER_BG    	"FF1001"	  // dark red (background of the title bar)
#define F6200_COLOR_OVERALL_BG    	"D6EFFF"	  // light red (for the background)
#define F6200_COLOR_BANNER_BG      	"0050a0"	  // dark red (background of the title bar)
#define HAWKING_COLOR_BG            "D6EFFF"
#define EXT3_COLOR_BG               "D8D8D8"
#define CENTURY_COLOR_BG            "98FB98"
#define DEFAULT_COLOR_BG            "FFCCFF"
#define HAWKING_FONT                ""
#define DEFAULT_FONT                "<font size=\"3\">"
#define EXT3_BAR_FONT_COLOR         "000000"
#define DEFAULT_BAR_FONT_COLOR      "FFFFFF"
#define EXT3_FONT_COLOR             "FFFFFF"
#define CENTURY_FONT_COLOR          "000000"
#define DEFAULT_FONT_COLOR          "000000"

char* get_overall_bg(){

#if defined(F6200)
	return F6200_COLOR_OVERALL_BG;
#elif defined(ALLNET)
	return ALLNET_COLOR_OVERALL_BG;
#elif defined(NH230)
	return NH230_COLOR_OVERALL_BG;
#elif defined(NH221)
	return NH221_COLOR_OVERALL_BG;			
#elif defined(EXT3) && defined(NONBRAND)
    return EXT3_COLOR_OVERALL_BG;
#elif defined(EXT3) && defined(CENTURY)
    return CENTURY_COLOR_OVERALL_BG;
#else
	return ALLNET_COLOR_OVERALL_BG;
#endif
	
}

char* get_banner_bg(){

#if defined(F6200)
	return F6200_COLOR_BANNER_BG;	
#elif defined(ALLNET)
	return ALLNET_COLOR_BANNER_BG;	
#elif defined(NH230)
	return NH230_COLOR_BANNER_BG;
#elif defined(NH221)
	return NH221_COLOR_BANNER_BG;		
#elif defined(EXT3) && defined(NONBRAND)
    return EXT3_COLOR_BANNER_BG;
#elif defined(EXT3) && defined(CENTURY)
    return EXT3_COLOR_BANNER_BG;
#else
	return ALLNET_COLOR_BANNER_BG;	
#endif
	
}

char* get_column_bg(void){

#if defined(ALLNET)
    return ALLNET_COLOR_BG;
#elif defined(EXT3) && defined(NONBRAND)
    return EXT3_COLOR_BG;
#elif defined(EXT3) && defined(CENTURY)
    return CENTURY_COLOR_BG;
#elif defined(HAWKING)
    return HAWKING_COLOR_BG;
#else
    return DEFAULT_COLOR_BG;
#endif
}

char* get_font_size(void){
	
#if defined(HAWKING)
    return HAWKING_FONT;
#else
    return DEFAULT_FONT;
#endif
}

char* get_bar_font_color(void){
	
#if defined(ALLNET)
    return ALLNET_BAR_FONT_COLOR;
#elif defined(EXT3) && defined(NONBRAND)
    return EXT3_BAR_FONT_COLOR;
#elif defined(EXT3) && defined(CENTURY)
    return EXT3_BAR_FONT_COLOR;
#else
    return DEFAULT_BAR_FONT_COLOR;
#endif
}

char* get_font_color(void){
	
#if defined(EXT3) && defined(CENTURY)
    return CENTURY_FONT_COLOR;
#else
    return DEFAULT_FONT_COLOR;
#endif
}
