
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#define M_HDIO_IDE_SLEEP_ENABLE    0x0ff0
#define M_HDIO_IDE_SLEEP_DISABLE   0x0ff1



void usage(void)
{
  printf("IDE_IOCTL  v1.00 (08/03/2005)\n");
  printf("   <file name> [device] [flag]\n");
  printf("\n");
  printf("       device :    /dev/hda or ....\n");
  printf("       flag   :    1     , enable sleep mode. \n");
  printf("                   0     , disable sleep mode.\n");
  printf("\n");
}

int main(int argc, char *argv[])
{
  int fd, w_enable_flag = 0, w_cmd = 0;
  char devname[20] = "/dev/hda";
  int  open_flags = O_RDONLY|O_NONBLOCK;  

  if (argc != 3) {
    usage();
    return (-1);
  }

  // Duplicate the command line parameters
  strcpy(devname, argv[1]);
  w_enable_flag = atoi(argv[2]);
  w_cmd = w_enable_flag ? M_HDIO_IDE_SLEEP_ENABLE : M_HDIO_IDE_SLEEP_DISABLE;

  // Open device file
  fd = open (devname, open_flags);
  if (fd < 0) {
    printf("IDE_IOCTL: cannot open %s to issue command.\n", devname);
    return (0);
  }

  // Issue command
  if (ioctl(fd, w_cmd, 0))
    printf("IDE_IOCTL: ioctl with command 0x%X failed.\n", w_cmd);

  close(fd);
  return (0);
}

