#define PROGNAME "pnmd"
#define VERSION "2.00"
#define DATE "20051026"
//============================================================
//0330: ansel: add httpd stop and start command for network setup
//20051026: ansel: if no HD installed, model = " " and capacity = 0
//20060517: ansel: clear username and password b4 getting info
//============================================================

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <arpa/inet.h>

#include "include/httpd_sysconf.h"

struct{
    char DHCP_ENABLE[2];
    char IP[20];
    char GATEWAY[20];
    char NETMASK[20];
    char HOSTNAME[17];
    char WORKGROUP[17];
    char HOSTNAME_FULL[51];
    char USERNAME[20];
    char PASSWORD[20];
    char FTP_MAX_UNIT[3];
	char FTP_PORT_NUMBER[6];
	char FTP_TIMEOUT[4];
	char FTP_ANONYMITY[2];
	char FTP_ENABLE[2];
	char LEGAL_IP[10][20];
	char IP_SECURITY_MODE[2];
	char LEGAL_MAC[10][30];
	char MAC_SECURITY_MODE[2];
	char TIME_MODE[2];
	char TIME_SERVER[40];
	char TIME_ZONE[25];
	char TIME_DIFFER[10];
	char TIME_VALUE[30];
	char DNS_SERVER[20];
	char CODE_SET[20];
	char TCONFIG_FOLDER[17];
	char TCONFIG_FILENAME[17];
	char TORRENT_USER[3];
	char TORRENT_ENABLE[2];
	char WEB_ENABLE[2];
	char WEB_PORT[6];
	char WEB_FOLDER[17];
	char CRON_ENABLE[2];
	char CRON_START_DAY[2];
	char CRON_START_HOUR[3];
	char CRON_START_MIN[3];
	char CRON_END_DAY[2];
	char CRON_END_HOUR[3];
	char CRON_END_MIN[3];
	char ADMIN_PORT[6];
	char USB_SHARE[2];
	char USB_RECYCLE[2];
//======allen adds to declare saving USB variable======
  char SERVER[2];
  //char SERVER2[2];
//=====================================================	
//======allen adds to declare saving Jumbo variable======
  char JUMBO[2];   
//=======================================================
//========== allen adds to svae PORT series	===========
  char USB_PORT01[60];
  char USB_PORT02[60];
  char USB_PORT03[60];
  char USB_PORT04[60];
  char USB_PORT11[60];
  char USB_PORT12[60];
  char USB_PORT13[60];
  char USB_PORT14[60];
  char USB_PORT21[60];
  char USB_PORT22[60];
  char USB_PORT23[60];
  char USB_PORT24[60];
  char USB_PORT31[60];
  char USB_PORT32[60];
  char USB_PORT33[60];
  char USB_PORT34[60];
	char SWAP_ENABLE[5];
//===================================================================================================
//======================= allen adds to saving checksmb parameter =======================
	char INITBOOT[2];
//=======================================================
}CONFIG;

//===============================

//===============================

#undef DEBUG
//#define DEBUG

#ifdef DEBUG
#define MSG(string,args...) fprintf(stderr,string,##args)
#else
#define MSG(string,args...)
#endif
//===============================

#define MYPORT  12310 /* the port NH-200 will broadcast to */
#define LOCAL_SERVER_PORT 12311
#define MAXBUFLEN 700

char mac_addr[18];
char ip_addr[16];
char subnet_mask[16];
char gateway[16];
char host_name[256];
char workgroup[256];
char description[256];

char username_a[256];
char password_a[256];

char username_o[256];
char password_o[256];

char buf[MAXBUFLEN];
char info[MAXBUFLEN];

char hd_info[256];
char total_size[10], avail_size[10];
char hd_capacity[10];
char hd_model[50];

#if defined(CENTURY)
char dhcp_enable[2];
#endif


void send_pnmd_info(void);
void get_info(void);
void set_network(void);
void split_info_buf(void);
void get_hd_info(void);
void send_setup_success_info(void);
void send_auth_fail_info(void);

int main(int argc, char *argv[])
{
	int sockfd;
	int ret, i;
	struct sockaddr_in my_addr; /* my address information */
	struct sockaddr_in their_addr; /* connector's address information */
	int addr_len, numbytes;
	int yes = 1;
	
	
	FILE *fp;
	char input_buf[255];
	char command_mac[22];
	
#if defined(CENTURY)
	strcat(command_mac, "0C04S");
#else
	strcat(command_mac, "0C02S");
#endif
//	strcat(command_mac, mac_addr);
	
	memset(ip_addr, '\0', 16);
    memset(subnet_mask, '\0', 16);
    memset(gateway, '\0', 16);
    memset(host_name, '\0', 256);
    memset(workgroup, '\0', 256);
    memset(description, '\0', 256);

// ansel 0406 add, to validate user
    memset(username_a, '\0', 256);
    memset(password_a, '\0', 256);

	
	
	
// here I get MAC address
	ret = system("ifconfig eth0 > /etc/temp");
	
	fp = fopen("/etc/temp", "r");
	if(fp != NULL){
    	if(fgets(input_buf, 255, fp) != NULL){
        	input_buf[254] = '\0';
        	for(i = 0;i <= 16;i++){
        	    mac_addr[i] = input_buf[38 + i];
        	}
        	mac_addr[17] = '\0';
        	printf("MAC address = %s\n", mac_addr);
        }
    }
    else{
        printf("Can't open file /etc/temp\n");
        exit(1);
    }
	fclose(fp);
	ret = system("rm /etc/temp");
	
	strcat(command_mac, mac_addr);
	
// here we request this program to run in the background
	if (daemon(0, 0)) {
        (void) fprintf(stderr, "portmap: fork: %s", strerror(errno));
        exit(1);
    }


// start to create socket for bind    
	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}

// set properties for my socket	
	my_addr.sin_family = AF_INET; /* host byte order */
	my_addr.sin_port = htons(LOCAL_SERVER_PORT); /* short, network byte order */
	my_addr.sin_addr.s_addr = INADDR_ANY; /* auto-fill with my IP */
	bzero(&(my_addr.sin_zero), 8); /* zero the rest of the struct */
	
// lose the pesky "Address alresdy in use" error message
	if (setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, &yes, sizeof(int)) == -1){
	    perror("setsockopt");
	    exit(1);
	}

// bind to the port	I listen to
	if (bind(sockfd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr))== -1) {
		perror("bind");
		exit(1);
	}
	
	addr_len = sizeof(struct sockaddr);
	

// server infinite loop
    while(1) {
// receive message, this is a block process, which means while loop stops here 
// and will keep going till I receive packets from the port I want
        if ((numbytes=recvfrom(sockfd, buf, MAXBUFLEN, 0, (struct sockaddr *)&their_addr, &addr_len)) == -1) {
		    perror("recvfrom");
		    exit(1);
            continue;
        }
          
// print received message, debug use
    	buf[numbytes] = '\0';
    	printf("packet contains \"%s\"\n",buf);
    	
// Start to tell what command we get, basically we receive command only
// First byte is reserved and set to 0
// The commands for the present time are:
// C01S: Sent from PC and request for my network and HD information
// C02S: Sent from PC and request to set my network configuration, so I do as I told
        //printf("command_mac = %s\n", command_mac);
        
// 20050117 ansel: for Century, I decide to give her a differnet command code
// C03S: Sent from PC and request for my network and HD information
// C04S: Sent from PC and request to set my network configuration, so I do as I told

#if defined(CENTURY)
        if (strncasecmp(buf, "0C03S", 5) == 0){
#else
	if (strncasecmp(buf, "0C01S", 5) == 0){
#endif
            send_pnmd_info();
        }
#if defined(CENTURY)
        else if((strncasecmp(buf, "0C04S", 5) == 0) && (strncasecmp(buf + 5, mac_addr, 17) == 0)){
#else
	else if((strncasecmp(buf, "0C02S", 5) == 0) && (strncasecmp(buf + 5, mac_addr, 17) == 0)){
#endif
            split_info_buf();
            if(strcmp(username_a, username_o) != 0 || strcmp(password_a, password_o) != 0){
                send_auth_fail_info();
                printf("PNMD: main: username and/or password don't match.\n");
                printf("username_a = %s\nusername_o = %s\n", username_a, username_o);
                printf("password_a = %s\npassword_o = %s\n", password_a, password_o);
            }
            else{
// add domain check                
                if(check_same_domain(ip_addr, subnet_mask, gateway, subnet_mask, NULL) == 0){
                    printf("PNMD: main: Request IP and Gateway do not have the same network address.\n");
                    send_auth_fail_info();
                }
                else{
//end add                
                    printf("PNMD: main: start to set network configuration.\n");
                    set_network();
#if ! defined(CENTURY)
                    send_setup_success_info();
#endif
                }
            }
        }
        else{
            do{
                int fd_console;
                fd_console = fopen( "/dev/console", "w" );
                fprintf(fd_console, "PNMD: main: unknown packet.\n");
                fprintf(fd_console, "PNMD: main: command_mac = %s\n", command_mac);
                fprintf(fd_console, "PNMD: main: mac_addr = %s\n", mac_addr);
                fflush(fd_console);
            }while(0);
            
            printf("PNMD: main: unknown packet.\n");
            printf("PNMD: main: command_mac = %s\n", command_mac);
            
        }
    }
// end of server infinite loop

	close(sockfd);
	return 0;
}



// send out info as requested (broadcast)
void send_pnmd_info(void){
    int sockfd;
	struct sockaddr_in their_addr; /* connector's address information */
	int numbytes;
	
	
	const int on=1;
//	strcpy(info, "Test info from NH-200");
    get_info();

	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}

	their_addr.sin_family = AF_INET; /* host byte order */
	their_addr.sin_port = htons(MYPORT); /* short, network byte order */
    their_addr.sin_addr.s_addr = htonl(INADDR_BROADCAST);  /* this is broadcast address*/
	bzero(&(their_addr.sin_zero), 8); /* zero the rest of the struct */

// in order to send broadcast packet, we need to set the sockt option first
    if ( setsockopt(sockfd, SOL_SOCKET, SO_BROADCAST, &on, sizeof(on)) != 0 ){
    	perror("set SO_BROADCAST failed");
    	exit(1);
    }

// send out the broadcast packet
	if ((numbytes=sendto(sockfd, info, strlen(info), 0, (struct sockaddr *)&their_addr, sizeof(struct sockaddr))) == -1) {
		perror("sendto");
		exit(1);
	}

// Successful send
	printf("sent %d bytes to %s\n",numbytes,inet_ntoa(their_addr.sin_addr));
	close(sockfd);    
}







// send out authentication failed info (broadcast)
void send_auth_fail_info(void){
    int sockfd;
	struct sockaddr_in their_addr; /* connector's address information */
	int numbytes;
	
	
	const int on=1;
//	prepare info
    memset(info, '\0', MAXBUFLEN);  /* Set it to all null chars to be sure */
#if defined(CENTURY)
	strcpy(info, "0C04R");          /* 0: reserved, C02: Command number 02, R: Reply */
#else
	strcpy(info, "0C02R");          /* 0: reserved, C02: Command number 02, R: Reply */
#endif
	strcat(info, mac_addr);         /* We send our MAC address for recognition */
	strcat(info, "1");              /* 1 means fail in authentication */
	

	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}

	their_addr.sin_family = AF_INET; /* host byte order */
	their_addr.sin_port = htons(MYPORT); /* short, network byte order */
    their_addr.sin_addr.s_addr = htonl(INADDR_BROADCAST);  /* this is broadcast address*/
	bzero(&(their_addr.sin_zero), 8); /* zero the rest of the struct */

// in order to send broadcast packet, we need to set the sockt option first
    if ( setsockopt(sockfd, SOL_SOCKET, SO_BROADCAST, &on, sizeof(on)) != 0 ){
    	perror("set SO_BROADCAST failed");
    	exit(1);
    }

//20051027: ansel: we wait b4 we send
    sleep(1);

// send out the broadcast packet
	if ((numbytes=sendto(sockfd, info, strlen(info), 0, (struct sockaddr *)&their_addr, sizeof(struct sockaddr))) == -1) {
		perror("sendto");
		exit(1);
	}

// Successful send
	printf("send_auth_fail_info: sent %d bytes to %s\n",numbytes,inet_ntoa(their_addr.sin_addr));
	close(sockfd);    
}





// send out setup success info (broadcast)
void send_setup_success_info(void){
    int sockfd;
	struct sockaddr_in their_addr; /* connector's address information */
	int numbytes;
	
	
	const int on=1;
//	prepare info
    memset(info, '\0', MAXBUFLEN);  /* Set it to all null chars to be sure */
#if defined(CENTURY)
	strcpy(info, "0C04R");          /* 0: reserved, C04: Command number 04, R: Reply */
#else
	strcpy(info, "0C02R");          /* 0: reserved, C02: Command number 02, R: Reply */
#endif
	strcat(info, mac_addr);         /* We send our MAC address for recognition */
	strcat(info, "2");              /* 2 means setup success */
	

	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}

	their_addr.sin_family = AF_INET; /* host byte order */
	their_addr.sin_port = htons(MYPORT); /* short, network byte order */
    their_addr.sin_addr.s_addr = htonl(INADDR_BROADCAST);  /* this is broadcast address*/
	bzero(&(their_addr.sin_zero), 8); /* zero the rest of the struct */

// in order to send broadcast packet, we need to set the sockt option first
    if ( setsockopt(sockfd, SOL_SOCKET, SO_BROADCAST, &on, sizeof(on)) != 0 ){
    	perror("set SO_BROADCAST failed");
    	exit(1);
    }

// send out the broadcast packet
	if ((numbytes=sendto(sockfd, info, strlen(info), 0, (struct sockaddr *)&their_addr, sizeof(struct sockaddr))) == -1) {
		perror("sendto");
		exit(1);
	}

// Successful send
	printf("send_setup_success_info: sent %d bytes to %s\n",numbytes,inet_ntoa(their_addr.sin_addr));
	close(sockfd);    
}





// prepare information to send out, prepare the string: info
// get from file \etc\config except for username and password
void get_info(void){
//  FILE *fp;
//	char input_buf[255];
//	char username[8] = "USERNAME";
//	char password[8] = "PASSWORD";
//	
//	int found, offset;
//  char *needle = NULL;
	
	memset(info, '\0', MAXBUFLEN);  /* Set it to all null chars to be sure */
#if defined(CENTURY)
	strcpy(info, "0C03R");          /* 0: reserved, C01: Command number 01, R: Reply*/
#else
	strcpy(info, "0C01R");          /* 0: reserved, C03: Command number 03, R: Reply*/
#endif
	strcat(info, mac_addr);         /* We send our MAC address for recognition*/

// get whole config except for username and password
// 0406: still have to extract username and password to validate
// 0406: this might be a good place to get them
    
//	fp = fopen("/etc/config", "r");
//	if(fp != NULL){
//    	while(fgets(input_buf, 255, fp) != NULL){
//        	if(strncasecmp(input_buf, username, 8) != 0 && strncasecmp(input_buf, password, 8) != 0){
//        	    strcat(info, input_buf);
//        	}
//        	else if(strncasecmp(input_buf, username, 8) == 0){
//                found = 0;
//                offset = 11;
//                needle = strchr((input_buf + offset), '\'');
//                if (needle){
//                    found = (int)((needle - input_buf)) - offset;
//                    strncpy(username_o, (input_buf + offset - 1), found + 1);
//                }
//        	}
//        	else if(strncasecmp(input_buf, password, 8) == 0){
//        	    found = 0;
//                offset = 11;
//                needle = strchr((input_buf + offset), '\'');
//                if (needle){
//                    found = (int)((needle - input_buf)) - offset;
//                    strncpy(password_o, (input_buf + offset - 1), found + 1);
//                }
//        	}
//        	
//        }
//    }
//    else{
//        printf("Can't open file /etc/config\n");
//        exit(1);
//    }
//	fclose(fp);

// 0603: ansel: change the way we get info from /etc/config
//       using new parser.c
    ReadConfiguration();
    
    strcpy(ip_addr, CONFIG.IP);
    strcpy(subnet_mask, CONFIG.NETMASK);
    strcpy(gateway, CONFIG.GATEWAY);
    strcpy(host_name, CONFIG.HOSTNAME);
    strcpy(workgroup, CONFIG.WORKGROUP);
    strcpy(description, CONFIG.HOSTNAME_FULL);
    strcpy(username_o, CONFIG.USERNAME);
    strcpy(password_o, CONFIG.PASSWORD);
    
    strcat(info, "IP='");
    strcat(info, ip_addr);
    strcat(info, "'\n");
    
    strcat(info, "NETMASK='");
    strcat(info, subnet_mask);
    strcat(info, "'\n");
    
    strcat(info, "GATEWAY='");
    strcat(info, gateway);
    strcat(info, "'\n");
    
    strcat(info, "HOSTNAME='");
    strcat(info, host_name);
    strcat(info, "'\n");
    
    strcat(info, "WORKGROUP='");
    strcat(info, workgroup);
    strcat(info, "'\n");
    
    strcat(info, "HOSTNAME_FULL='1234");
    strcat(info, description);
    strcat(info, "'");


// now we add HD info
    get_hd_info();
    
    strcat(info, "HDMODEL='");
    strcat(info, hd_model);
    strcat(info, "'");
    
    strcat(info, "HDCAPACITY='");
    strcat(info, hd_capacity);
    strcat(info, "'");
    
    strcat(info, "HDTOTAL='");
    strcat(info, total_size);
    strcat(info, "'");
    
    strcat(info, "HDAVAIL='");
    strcat(info, avail_size);
    strcat(info, "'");

#if defined(CENTURY)
    strcat(info, "DHCP_ENABLE='");
    strcat(info, CONFIG.DHCP_ENABLE);
    strcat(info, "'");
#endif
}




// here I set the network configuration
// In fact, I rewrite file /etc/config and restart network and services
void set_network(void){
    FILE *fp;
    char info_t[255];
    char read_buf[255];

	char ip_head[3] = "IP";
	char netmask_head[8] = "NETMASK";
	char gateway_head[8] = "GATEWAY";
	char hostname_head[9] = "HOSTNAME";
	char workgroup_head[10] = "WORKGROUP";
	char description_head[14] = "HOSTNAME_FULL";
	
	char username_head[14] = "USERNAME";
	char password_head[14] = "PASSWORD";
	
	char username_read[255];
	char password_read[255];
	
	int ret;
	int s;
    char *needle = NULL;
                
	
// Set it to all null chars to be sure
	memset(username_read, '\0', 255);
	memset(password_read, '\0', 255);
	memset(read_buf, '\0', 255);
	
	memset(info_t, '\0', 255);
	
// first we read username and password for later usage
// 0324: why not copy whole line instead if just username or password
// 0324: if so, need to modify the joining in the code following

//	fp = fopen("/etc/config", "r");
//	if(fp != NULL){
//    	while(fgets(read_buf, 255, fp) != NULL){
//        	if(strncasecmp(read_buf, username_head, 8) == 0){
//                strcpy(username_read, read_buf);
//        	}
//        	else if(strncasecmp(read_buf, password_head, 8) == 0){
//                needle = strchr((read_buf), '\n');
//                strcpy(password_read, read_buf);
//                if (!needle){
//                    s = sizeof(password_read);
//                    password_read[s] = '\n';
//                }
//        	}
//        }
//    }
//    else{
//        printf("Can't open file /etc/config\n");
//        exit(1);
//    }
//	fclose(fp);
//	
//	printf("Username read from file config = %s\n", username_read);
//	printf("Password read from file config = %s\n", password_read);
	
// "w+" means replace with new content, "r+" means replace partial content
//	fp = fopen("/etc/config", "w+");
//	if(fp != NULL){
//        sprintf(info_t, "%s='%s'\n", ip_head, ip_addr);
//        fputs(info_t, fp);
//        
//        sprintf(info_t, "%s='%s'\n", netmask_head, subnet_mask);
//        fputs(info_t, fp);
//        
//        sprintf(info_t, "%s='%s'\n", gateway_head, gateway);
//        fputs(info_t, fp);
//        
//        sprintf(info_t, "%s='%s'\n", hostname_head, host_name);
//        fputs(info_t, fp);
//        
//        sprintf(info_t, "%s='%s'\n", workgroup_head, workgroup);
//        fputs(info_t, fp);
//        
//        sprintf(info_t, "%s='%s'\n", description_head, description);
//        fputs(info_t, fp);

// 0324: we change the way to get username and password, follow them        
//        sprintf(info_t, "%s='%s'\n", username_head, username_read);
//        fputs(info_t, fp);
//        sprintf(info_t, "%s='%s'\n", password_head, password_read);
//        fputs(info_t, fp);
        
//        fputs(username_read, fp);
//        fputs(password_read, fp);
//        
//    }
//    else{
//        printf("Can't open file /etc/config\n");
//        exit(1);
//    }
//	fclose(fp);

// 0603: ansel: we now use parser.c help us to save configuration
//       first we get original configuration first
//       then modify items in the structure
//       last, 
    ReadConfiguration();

#if defined(CENTURY)
    if(strncmp(dhcp_enable, "1", 1) == 0){
        printf("set_network: set dhcp enable.\n");
        memset(CONFIG.DHCP_ENABLE, 0, sizeof(CONFIG.DHCP_ENABLE));
        strcpy(CONFIG.DHCP_ENABLE, "1");
        
        SaveConfiguration();
        
        // here we send response packets first, in case dhcp client failed
	    send_setup_success_info();
	    
        //	now we call the shell script to make the configuration work
        //sp/  stopping all the app. before do the save_config.sh
    	ret = system("/etc/rc.d/network restart");
    }
    else{
        printf("set_network: set dhcp disable.\n");
        memset(CONFIG.IP, 0, sizeof(CONFIG.IP));
        memset(CONFIG.GATEWAY, 0, sizeof(CONFIG.GATEWAY));
        memset(CONFIG.NETMASK, 0, sizeof(CONFIG.NETMASK));
        memset(CONFIG.HOSTNAME, 0, sizeof(CONFIG.HOSTNAME));
        memset(CONFIG.WORKGROUP, 0, sizeof(CONFIG.WORKGROUP));
        memset(CONFIG.DHCP_ENABLE, 0, sizeof(CONFIG.DHCP_ENABLE));
        
        strcpy(CONFIG.IP, ip_addr);
        strcpy(CONFIG.GATEWAY, gateway);
        strcpy(CONFIG.NETMASK, subnet_mask);
        strcpy(CONFIG.HOSTNAME, host_name);
        strcpy(CONFIG.WORKGROUP, workgroup);
        strcpy(CONFIG.DHCP_ENABLE, "0");
        
        SaveConfiguration();
        
        //	now we call the shell script to make the configuration work
        //sp/  stopping all the app. before do the save_config.sh
    	ret = system("/etc/rc.d/network restart");
    	
    	send_setup_success_info();
    }
#else
    memset(CONFIG.IP, 0, sizeof(CONFIG.IP));
    memset(CONFIG.GATEWAY, 0, sizeof(CONFIG.GATEWAY));
    memset(CONFIG.NETMASK, 0, sizeof(CONFIG.NETMASK));
    memset(CONFIG.HOSTNAME, 0, sizeof(CONFIG.HOSTNAME));
    memset(CONFIG.WORKGROUP, 0, sizeof(CONFIG.WORKGROUP));
    memset(CONFIG.DHCP_ENABLE, 0, sizeof(CONFIG.DHCP_ENABLE));
    
    strcpy(CONFIG.IP, ip_addr);
    strcpy(CONFIG.GATEWAY, gateway);
    strcpy(CONFIG.NETMASK, subnet_mask);
    strcpy(CONFIG.HOSTNAME, host_name);
    strcpy(CONFIG.WORKGROUP, workgroup);
    strcpy(CONFIG.DHCP_ENABLE, "0");
    
    SaveConfiguration();
	
//	now we call the shell script to make the configuration work
//sp/  stopping all the app. before do the save_config.sh
	ret = system("/etc/rc.d/network restart");
#endif
    
}

// split the buf received into 6 different variables, like IP...
void split_info_buf(void){
    int found, offset;
    char *needle = NULL;
    
    memset(ip_addr, '\0', 16);
    memset(subnet_mask, '\0', 16);
    memset(gateway, '\0', 16);
    memset(host_name, '\0', 256);
    memset(workgroup, '\0', 256);
    memset(username_a, '\0', 256);
    memset(password_a, '\0', 256);
    memset(description, '\0', 256);
#if defined(CENTURY)
    memset(dhcp_enable, '\0', 2);
#endif    
    
    
    
    found = 0;
    offset = 22;
    needle = strchr((buf + offset), ';');
    if (needle){
        found = (int)((needle - buf)) - offset;
        printf("Locate first delima at %d\n", found);
        strncpy(ip_addr, (buf + offset), found);
        printf("IP address = %s\n", ip_addr);
    }
    
    offset = offset + found;
    needle = strchr((buf + offset + 1), ';');
    if (needle){
        found = (int)((needle - buf)) - offset;
        printf("Locate second delima at %d\n", found);
        strncpy(subnet_mask, (buf + offset + 1), found - 1);
        printf("Subnet Mask = %s\n", subnet_mask);
    }
    
    offset = offset + found;
    needle = strchr((buf + offset + 1), ';');
    if (needle){
        found = (int)((needle - buf)) - offset;
        printf("Locate 3rd delima at %d\n", found);
        strncpy(gateway, (buf + offset + 1), found - 1);
        printf("gateway = %s\n", gateway);
    }
    
    offset = offset + found;
    needle = strchr((buf + offset + 1), ';');
    if (needle){
        found = (int)((needle - buf)) - offset;
        printf("Locate 4th delima at %d\n", found);
        strncpy(host_name, (buf + offset + 1), found - 1);
        printf("host_name = %s\n", host_name);
    }
    
    offset = offset + found;
    needle = strchr((buf + offset + 1), ';');
    if (needle){
        found = (int)((needle - buf)) - offset;
        printf("Locate 5th delima at %d\n", found);
        strncpy(workgroup, (buf + offset + 1), found - 1);
        printf("workgroup = %s\n", workgroup);
    }
    
    offset = offset + found;
    needle = strchr((buf + offset + 1), ';');
    if (needle){
        found = (int)((needle - buf)) - offset;
        printf("Locate 6th delima at %d\n", found);
        strncpy(description, (buf + offset + 1), found - 1);
        printf("description = %s\n", workgroup);
    }
    
    offset = offset + found;
    needle = strchr((buf + offset + 1), ';');
    if (needle){
        found = (int)((needle - buf)) - offset;
        printf("Locate 7th delima at %d\n", found);
        strncpy(username_a, (buf + offset + 1), found - 1);
        printf("username_a = %s\n", username_a);
    }
    
#if defined(CENTURY)
    offset = offset + found;
    needle = strchr((buf + offset + 1), ';');
    if (needle){
        found = (int)((needle - buf)) - offset;
        printf("Locate 8th delima at %d\n", found);
        strncpy(password_a, (buf + offset + 1), found - 1);
        printf("password_a = %s\n", password_a);
    }
    
    offset = offset + found;
    strncpy(dhcp_enable, (buf + offset + 1), (strlen(buf) - offset - 1));
    printf("dhcp_enable = %s\n", dhcp_enable);
#else
    offset = offset + found;
    strncpy(password_a, (buf + offset + 1), (strlen(buf) - offset - 1));
    printf("password_a = %s\n", password_a);
#endif
    
}

// here we get information about HD
void get_hd_info(void){
    FILE *fp;
	char input_buf[255];
	int ret;
	
	memset(total_size, '\0', 10);
	memset(avail_size, '\0', 10);
	memset(hd_model, '\0', 50);
	memset(hd_capacity, '\0', 10);
	

// here I get HD capacity information from command DF
// unit is kbyte. if no HD, this would be about (3565 0), not (0 0)
//ansel: 20050726 modify df command for NH230
	ret = system("df /mnt > /etc/temp1");
	fp = fopen("/etc/temp1", "r");
	if(fp != NULL){
    	if(fgets(input_buf, 255, fp) != NULL){
        	if (strncasecmp(input_buf, "Filesystem", 10) == 0){     //means we are running NH230
        	    fclose(fp);
        	    ret = system("rm /etc/temp1");
        	    ret = system("/bin/df /mnt | grep mnt | cut -b22-31,42-50 > /etc/temp1");
        	    fp = fopen("/etc/temp1", "r");
        	}
        }
        else{
            printf("Can't get lines from file /etc/temp1\n");
        }
    }
    else{
        printf("Can't open file /etc/temp1\n");
    }

	if(fp != NULL){
    	if(fgets(input_buf, 255, fp) != NULL){
        	strncpy(total_size, input_buf, 9);
        	strncpy(avail_size, input_buf + 10, 9);
        }
        else{
            printf("Can't get lines from file /etc/temp1\n");
        }
    }
    else{
        printf("Can't open file /etc/temp1\n");
//ansel: 20051026: set to 0 if no info get
        strcpy(total_size, "0");
        strcpy(avail_size, "0");
    }
	fclose(fp);
	printf("input_buf = \n", input_buf);
	printf("total_size = \n", total_size);
    printf("avail_size = \n", avail_size);

	ret = system("rm /etc/temp1");
	

// if no HD, open fail. return HD brand and model name
    fp = fopen("/proc/ide/hda/model", "r");
    if(fp != NULL){
    	fgets(hd_model, 50, fp);
    	fclose(fp);
    }
    else{
//ansel: 20051026: set to space if no HD
        strcpy(hd_model, " ");
    }

// if no HD, open fail. return total capacity for HD
    fp = fopen("/proc/ide/hda/capacity", "r");
    if(fp != NULL){
    	fgets(hd_capacity, 10, fp);
    	fclose(fp);
    }
    else{
//ansel: 20051026: set to 0 if no HD
        strcpy(hd_capacity, "0");
    }
}

//s_ip:source IP address, s_mask: source IP mask
//t_ip:destination IP address, t_mask:destination IP mask, o_wan_type: NULL means force to check
//return 0: not in the same domain, 1: in the same domain
int check_same_domain(char* s_ip, char* s_mask, char* t_ip, char* t_mask, char* o_wan_type){

    const char delimiter1[] = ".";
    int s_range_mask;
    int min_range_mask;
    char *s[4],*t[4],ss1[20], ss2[20];
    int i;
    char s_mm[20],*sm[4],t_mm[20],*tm[4];

    MSG("s_ip = %s ,t_ip = %s\n",s_ip,t_ip);
    MSG("s_mask = %s ,t_mask = %s\n",s_mask,t_mask);

    if(o_wan_type != NULL)
        if(atoi(o_wan_type) != 1) 
            return 0;

    if(s_ip == NULL || s_mask == NULL || t_ip == NULL || s_mask == NULL ) 
        return 0;

    s_range_mask=netmask_check(s_mask);
    if(s_range_mask < 0) 
        return 0;
    min_range_mask=netmask_check(t_mask);
    if(min_range_mask > s_range_mask)
        min_range_mask=s_range_mask;
    if(min_range_mask < 0) 
        return 0;

    (void) strcpy(ss1, s_ip);    
    s[0] = strtok(ss1, delimiter1);
    s[1] = strtok(NULL, delimiter1);
    s[2] = strtok(NULL, delimiter1);
    s[3] = strtok(NULL, delimiter1);
    (void) strcpy(ss2, t_ip);
    t[0] = strtok(ss2, delimiter1);
    t[1] = strtok(NULL, delimiter1);
    t[2] = strtok(NULL, delimiter1);
    t[3] = strtok(NULL, delimiter1);
    
    (void) strcpy(s_mm, s_mask);
    sm[0] = strtok(s_mm, delimiter1);
    sm[1] = strtok(NULL, delimiter1);
    sm[2] = strtok(NULL, delimiter1);
    sm[3] = strtok(NULL, delimiter1);
    (void) strcpy(t_mm, t_mask);
    tm[0] = strtok(t_mm, delimiter1);
    tm[1] = strtok(NULL, delimiter1);
    tm[2] = strtok(NULL, delimiter1);
    tm[3] = strtok(NULL, delimiter1);

    for(i=0;i<min_range_mask;i++){
        if((atoi(s[i]) & atoi(sm[i])) != (atoi(t[i]) & atoi(tm[i])))  
            return 0;
    }
    return 1;
}

/* purpose: determine the range of netmask 
   return 1: maens 0.0.0.0
          2: maens 255.0.0.0
          3: maens 255.255.0.0
          4: maens 255.255.255.0
          5: maens 255.255.255.255
         -1: maens 'else' or error
*/  
int netmask_check(char *nmask){
   
    const char delimiter1[] = ".";
    char *m1,*m2,*m3,*m4,mm[20];
    int ing[4];
    int i,j,k,count=0;
 
    if(!nmask) 
        return -1;
    // 1.len check
    if((strlen(nmask) < 7) || (strlen(nmask) > 15))
        return -1;
       
    // 2.delimiter check
    j=strlen(nmask);
    (void) strcpy(mm,nmask);
    for(i=0;i<j;i++){
        if(mm[i] == '.')
            count++;
    }
    MSG("%s (nmask . = %d)\n",nmask,count);
    if(count != 3)   
        return -1;
    m1 = strtok(mm, delimiter1);  // get field1
    m2 = strtok(NULL, delimiter1);// get field2
    m3 = strtok(NULL, delimiter1);// get field3
    m4 = strtok(NULL, delimiter1);// get field4
    if(m1== NULL || m2== NULL || m3== NULL || m4== NULL)
        return -1;
         
    // 3.digit check
    if(!is_all_digit(m1) || !is_all_digit(m2) || !is_all_digit(m3) || !is_all_digit(m4))
        return -1;
         
    ing[0]=atoi(m1);
    ing[1]=atoi(m2);
    ing[2]=atoi(m3);
    ing[3]=atoi(m4);
    // 4.value check
    if((ing[0]>255) || (ing[1]>255) || (ing[2]>255) || (ing[3]>255))
        return -1;
  
    for(j=0;j<4;j++){
        for(i=7;i>=0;i--){
	    if((ing[j] & (1 << i)) == 0){      // get the value of the ith bit
	        if((ing[j] & (255 >> (8-i))) != 0){  // get the bits of the right side from the (i-1)th bit
	   	    MSG("j=%d,- ",j);	
	   	    return -1;
	   	}
	   	if(j<3){
	   	    for(k=(j+1);k<4;k++)
	   	        if(ing[k] != 0){ 
	   	            MSG("j=%d,ing(-) ",j);
	   		    return -1;
	   		}
	   	 }
	    }
        }
    }

    // ============ return value ===================
    if((ing[0]+ing[1]+ing[2]+ing[3])==0) 
        return 1;  // 0.0.0.0

    if(ing[0]!=0){
        if((ing[1]+ing[2]+ing[3])==0)   
            return 2;  // xxx.0.0.0
        if(ing[1]!=0){
     	    if((ing[2]+ing[3])==0)   
     	        return 3;  // xxx.xxx.0.0
     	    else if(ing[3]==0)     
     	        return 4;  // xxx.xxx.xxx.0
     	    else
     	        return 5;  // xxx.xxx.xxx.xxx
        }     
    }
    return -1;
}

/*return 1 if all are digits, otherwise 0 */
int is_all_digit(char *digit){
    
    int i;
    
    if(digit == NULL)
        return 0;
    for(i=0;i<strlen(digit);i++)
        if(!isdigit(digit[i]))
            return 0;
    return 1;
}
