/* copy.c:
 *
 * Copyright (C) 1998  Kenneth Albanowski <kjahds@kjahds.com>,
 *                     The Silver Hammer Group, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
//add by snop to include definition of data type
#include "include/httpd.h"
#include "include/httpd_sysconf.h"

static char copybuf[16384];
#define BUFSIZE 128
#define DEBUG
#define SHOW_CONSOLE
#define LONG_LEN			 30

#undef DEBUG
#undef SHOW_CONSOLE

extern CGI_ENTRY cgi_entries[];
extern WEB_VAR   var_entries[];
//extern char hdcapacity[5];

#ifdef SHOW_CONSOLE
extern FILE *fd_console;  
#endif

int copy(FILE *read_f, FILE *write_f);
int handle_get(FILE *read_f, FILE *write_f);
char *stristr(/*const*/ char *a, /*const*/ char *b);
void status_value_insert(char *line, char *var_head, FILE *out);
void text_value_insert(char *line, char *var_head, FILE *out);
void radio_value_insert(char *line, char *var_head, FILE *out);
void password_value_insert(char *line, char *var_head, FILE *out);
char *select_value_get(char *line, char *var_head, FILE *out);
void select_value_insert(char *value,char *line, char *var_head,FILE *out);
void parseargs(char *input, ARGUMENT *args);
void unescape(char *string);
char *x_strtok(char *s, const char *delim);
void DoCGI(FILE *out, char *filename, char *query);

extern int TIMEOUT;

int copy(FILE *read_f, FILE *write_f)
{
  int n;
  int wrote;

  alarm(TIMEOUT);
  while ((n = fread(copybuf,1,sizeof(copybuf),read_f)) != 0) {
    alarm(TIMEOUT);
    wrote = fwrite(copybuf,n,1,write_f);
    alarm(TIMEOUT);
    if (wrote < 1)
    	return -1;
  }
  alarm(0);
  return 0;
}

int handle_get(FILE *read_f, FILE *write_f)
{
    char *file_head;
    char *var_index;
    char filebuf[BUFSIZE];
    char *sel_value='\0';
     
    while((fgets(filebuf, 128, read_f)) != 0)
    {
        file_head=filebuf;  
        if ((var_index=(char *) stristr(file_head,"\"??"))!=NULL)                   
            status_value_insert(file_head, var_index, write_f);  
                     
        else if ((var_index=(char *) stristr(file_head,"<input type=\"text\""))!=NULL)                   
            text_value_insert(file_head, var_index, write_f);        	       
                       
        else  if ((var_index=(char *) stristr(file_head,"<input type=\"radio\""))!=NULL)  
            radio_value_insert(file_head, var_index,write_f);
            
        else  if ((var_index=(char *) stristr(file_head,"<input type=\"password\""))!=NULL)  
            password_value_insert(file_head, var_index, write_f);  
               
        else if((var_index=(char *) stristr(file_head,"<select"))!=NULL)                 
            sel_value = select_value_get(file_head, var_index, write_f);      
                               
        else if ((var_index=(char *) stristr(file_head,"<option value=\""))!=NULL)     
            select_value_insert(sel_value, file_head,var_index, write_f);
        else if ((var_index=(char *) stristr(file_head,"<input type=\"hidden\""))!=NULL)                   
            text_value_insert(file_head, var_index, write_f);
        else
            fprintf(write_f,"%s",filebuf); 
    }
  return 0;    
}


char *stristr(/*const*/ char *a, /*const*/ char *b)
{

    char *c;
    char *d;

    while (*a)
    {
        c = (char *) b;
        d = (char *) a;

        while (*c)
        {
            if (tolower(*c) != tolower(*d))  break;
            if  (!(*d))   return NULL;   
            
            c++;
            d++;
        }

        if (!(*c))
            return (char *) a;
        a++;
    }

    return NULL;
}


void status_value_insert(char *line, char *var_head, FILE *out){
	
    WEB_VAR *p = var_entries;	
    char *file_head2,*file_tail,*file_head1;	
    file_head2=line;
    file_tail=line;            
    file_head1=var_head;  
    
	file_head1[0]='\0';	
    file_head1+=3;   	 
    var_head=file_head1;    
    file_head2=strchr(file_head1,'?');            	 
    file_head2[0]='\0';   	 
    file_head2+=3;
    fprintf(out,"%s",file_tail);

    if(!strcasecmp(var_head, "hdused")){
        file_tail=file_head1;   
    }else if(!strcasecmp(var_head, "uptime")){
        file_tail=file_head1;        	
    }else{
        p = var_entries;                       
        while(p->name[0] != '\0'){    /* search the variable value  */
            if(strcmp(p->name, var_head) == 0){
                fprintf(out,"%s",p->value);                
                file_tail=file_head1;
           	}
            p++;
        } 
    }                       
    fprintf(out,"%s",file_head2); 	/* send out the remain of line */
}

//find there is a input type is "text" in this line and insert the value for displaying
void text_value_insert(char *line, char *var_head, FILE *out)
{
    WEB_VAR *p = var_entries;	
    char *file_head2,*file_tail,*file_head1;	
    file_head2=line;
    file_tail=line;            
    file_head1=var_head;  
    
    if ((var_head=(char *)stristr(file_head1,"name=\""))!=NULL){  
        file_head1=var_head;	          		
        file_head1+=6;            	 
        var_head=file_head1;    
        file_head2=strchr(file_head1,'\"');    	 
        file_head2[0]='\0';            	 
        file_head2++;
        fprintf(out,"%s",file_tail);
        fprintf(out,"\" ");
        //file_head[5]='\0';            	
       	p = var_entries;
                                     
        while (p->name[0] != '\0'){             /* search the variable value  */
            if(strcmp(p->name, var_head) == 0 ){            		
                fprintf(out,"value=\"");
                fprintf(out,"%s",p->value);                       
                fprintf(out,"\" ");
                file_tail=file_head1;
            }
            p++;
        } 
                   
    }             
    fprintf(out,"%s",file_head2); 	/* send out the remain of line */
}

//find there is a input type is "password" in this line and insert the value for displaying
void password_value_insert(char *line, char *var_head, FILE *out)
{
  
    WEB_VAR *p = var_entries;	
    char *file_head2,*file_tail,*file_head1;	
    file_head2=line;
    file_tail=line;            
    file_head1=var_head;  
    if ((var_head=(char *)stristr(file_head1,"name=\""))!=NULL){  
        file_head1=var_head;	          		
        file_head1+=6;            	 
        var_head=file_head1;    
        file_head2=strchr(file_head1,'\"');            	 
        file_head2[0]='\0';            	 
        file_head2++;
        fprintf(out,"%s",file_tail);
        fprintf(out,"\" ");
        //file_head[5]='\0';
        p = var_entries;                       
        while (p->name[0] != '\0'){             /* search the variable value  */
            if (strcmp(p->name, var_head) == 0 ){
                fprintf(out,"value=\"");
                fprintf(out,"%s",p->value);                       
                fprintf(out,"\" ");
                file_tail=file_head1;
            }
            p++;
        } 
                   
    }             
    fprintf(out,"%s",file_head2); 	/* send out the remain of line */
}

// find there is a input type is "radio" in this line and insert the value for displaying
void radio_value_insert(char *line, char *var_head, FILE *out)
{    
    WEB_VAR *p = var_entries;	
    char *file_head2,*file_tail,*file_head1,*radio_var,*radio_tail;	
    file_head2=line;
    file_tail=line;            
    file_head1=var_head;  
    radio_var=(char *)stristr(file_head1,"value=\"");
    var_head=(char *)stristr(file_head1,"name=\"");      
    if(var_head<radio_var){
        file_head1=var_head;	          		
        file_head1+=6;            	 
        var_head=file_head1;    
        file_head2=strchr(file_head1,'\"');            	 
        file_head2[0]='\0';            	 
        file_head2++;
        fprintf(out,"%s",file_tail);
        fprintf(out,"\" ");
     
        file_tail=file_head2;
        radio_var+=7;
        radio_tail=strchr(radio_var,'\"');
        //radio_tail++;
        radio_tail[0]='\0';
        radio_tail++;
        fprintf(out,"%s",file_tail);
        fprintf(out,"\" "); 
        file_head2=radio_tail;
    }else{
        radio_var+=7;
        radio_tail=strchr(radio_var,'\"');
        //radio_tail++;
        radio_tail[0]='\0';
        radio_tail++;
        fprintf(out,"%s",file_tail);
        fprintf(out,"\" ");    
        file_head2=radio_tail; 
      
        file_tail=radio_tail;
        file_head1=var_head;	          		
        file_head1+=6;            	 
        var_head=file_head1;    
        file_head2=strchr(file_head1,'\"');            	 
        file_head2[0]='\0';            	 
        file_head2++;
        fprintf(out,"%s",file_tail);
        fprintf(out,"\" ");
    }	
    //file_head[5]='\0';        
    p = var_entries;                       
    while (p->name[0] != '\0'){             /* search the variable value  */
        if (strcmp(p->name, var_head) == 0 ){         	
            if((strcmp(p->value,radio_var)==0) )
                fprintf(out,"checked");   
        }
        p++;
    } 
    fprintf(out,"%s",file_head2); 	/* send out the remain of line */
}

// find there is a input type is "text" in this line and insert the value for displaying
char *select_value_get(char *line, char *var_head, FILE *out)
{   
    WEB_VAR *p = var_entries;	
    char *file_head2,*file_tail,*file_head1;	
    file_head2=line;
    file_tail=line;            
    file_head1=var_head;  
    if ((var_head=(char *) stristr(file_head1,"name=\""))!=NULL){  
        file_head1=var_head;	          		
        file_head1+=6;            	 
        var_head=file_head1;    
        file_head2=strchr(file_head1,'\"');            	 
        file_head2[0]='\0';            	 
        file_head2++;
        fprintf(out,"%s",file_tail);
        fprintf(out,"\" ");
        fprintf(out,"%s",file_head2); 
#ifdef DEBUG
    printf("select_value_get: %s\n",file_head2);
#endif
        //file_head[5]='\0';
        p = var_entries;                       
        while (p->name[0] != '\0'){             /* search the variable value  */
            if(strcmp(p->name, var_head) == 0 ){         	            
                return (p->value);
            }
            p++;
        } 
#ifdef DEBUG
    printf("select_value_get: %s\n",var_head);
#endif
        return(NULL);      
    }          
    return(NULL);
}

// find there is a input type is "text" in this line and insert the value for displaying
void select_value_insert(char *value,char *line, char *var_head, FILE *out)
{   
    char *file_head2,*file_tail,*file_head1;	
    file_head2=line;
    file_tail=line;            
    file_head1=var_head;  
#ifdef DEBUG
    printf("enter select_value_insert\n");
#endif
    if ((var_head=(char *) stristr(file_head1,"value=\""))!=NULL){  
        file_head1=var_head;        		
        file_head1+=7;            	 
        var_head=file_head1;    
        file_head2=strchr(file_head1,'\"');            	     
        file_head2[0]='\0';            	 
        file_head2++;
        fprintf(out,"%s",file_tail);
        fprintf(out,"\" ");
        if(strcmp(value,var_head)==0)
            fprintf(out,"selected");                                             
    }             
    fprintf(out,"%s",file_head2);	/* send out the remain of line */
#ifdef DEBUG
    printf("select_value_insert: %s\n",file_head2);
#endif
}

void parseargs(char *input, ARGUMENT *args)
{
    char *name, *value;
    ARGUMENT *p_arg;

    while ((name = x_strtok(input, "=")) != NULL){
        value = x_strtok(NULL, "&");
        p_arg = args;
        while (p_arg->name != NULL){
            if (strcmp(name, p_arg->name) == 0){
#ifdef DEBUG
    printf("p_arg->name: %s\n",p_arg->name);
#endif
                if (value == NULL) *p_arg->var = '\0';
                else strncpy(p_arg->var, value, p_arg->len);
#ifdef DEBUG
    printf("p_arg->var(before): %s\n",p_arg->var);
#endif
                p_arg->var[(p_arg->len)-1] = '\0';
#ifdef DEBUG
    printf("p_arg->var(after): %s\n",p_arg->var);
#endif
                unescape(p_arg->var);
#ifdef DEBUG
    printf("p_arg->var(decode): %s\n",p_arg->var);
#endif
                break;
            }
            p_arg++;
        }
        /* We only need "input" for the first strtok call */
        input = NULL;
    }
    return;
}

/* Given a www-form encoded string, restore the original: */
void unescape(char *string)
{
    char *src = string, *dest = string;
    int digit1, digit2;

    while (*src!='\0'){
        switch (*src){
            case '+':
                *dest = ' ';
                break;
            case '%':
                src ++;
                if (*src >= '0' && *src <= '9') digit1 = *src - '0';
                else if (*src >= 'A' && *src <= 'F') digit1 = (*src - 'A') + 0xA;
                else if (*src >= 'a' && *src <= 'f') digit1 = (*src - 'a') + 0xA;
                else digit1 = 0;
                src ++;
                if (*src >= '0' && *src <= '9') digit2 = *src - '0';
                else if (*src >= 'A' && *src <= 'F') digit2 = (*src - 'A') + 0xA;
                else if (*src >= 'a' && *src <= 'f') digit2 = (*src - 'a') + 0xA;
                else digit2 = 0;
                *dest = (digit1 * 0x10) + digit2;
                break;
            default:
                *dest = *src;
        }
        src ++;
        dest ++;
    }
    *dest = '\0';
    return;
}

char *x_strtok(char *s, const char *delim)
{
    static char *start;
    char *p;
    if (s!=NULL) start=s;
    if (*start=='\0') return NULL;
    p=start;
    while (*start!=*delim && *start!='\0') start++;
    if (*start!='\0'){
        *start='\0';
        start++;
    }
    return p;
}

void DoCGI(FILE *out, char *filename, char *query){	
    
    CGI_ENTRY *p = cgi_entries;
       
         
                    	  
#ifdef DEBUG
    printf("filename: %s\n",filename);
    printf("query: %s\n",query);
#endif

    while((p->name[0] != ' ') && (p->name[0] != '\0')){
        if(strcmp(p->name, filename) == 0) 
            break;
        p++;
    }
    if(p->handler != NULL){
        fprintf(out, "HTTP/1.0 200 OK\r\n"
                     "Content-type: text/html\r\n\r\n");   
        p->handler(query, out);
    }else{
        fprintf(out, "HTTP/1.0 404 Not Found\r\n"
                     "Content-type: text/html\r\n\r\n"
                     "<html>\r\n"
                     "<head><title>404 Not Found</title></head>\r\n"
                     "<body><h1>404 Not Found</h1>\r\n"
                     "<p>The resource you have requested is not available."
                     "</p></body>\r\n"
                     "</html>\r\n");
    }
}
