#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>
#include <sys/stat.h>
#include <dirent.h>
#include <signal.h>
#include <unistd.h>
#include <ctype.h>
#include "include/sp_cservice_dbg.h"

#include <stdarg.h>

#define STR_NUM_CITICAL    "/var/run/num_critical" 
#define STR_NUM_ACCEPT    	"/var/run/num_accept" 
#define WATCHDOG_PID_FILE	"/var/run/watchdog.pid"

static int NUM_CITICAL=0;
void sp_system( char *fmt,...);

int get_num_crt(){
	int dw_crt_qty;
	FILE* fp;
	unsigned char sz_line[12];
	
	memset(sz_line, '\0', sizeof(sz_line));
	
	fp = fopen(STR_NUM_CITICAL, "rt");
	if (fp) {	// File opened for read OK ?		
		if (fread(sz_line, sizeof(char), sizeof(sz_line) - 1, fp) > 0) {
			dw_crt_qty = (unsigned int)atoi(sz_line);
		}		
		fclose(fp);
	}
	sp_cserviceTrace("%s: %s..: crt_num=%d\n", __FILE__, __func__, dw_crt_qty);
	return dw_crt_qty;
}

void set_num_crt(int num){
	FILE* fp;
	unsigned char sz_line[12];
	
	memset(sz_line, '\0', sizeof(sz_line));
	sprintf(sz_line, "%d", num);
	sp_cserviceTrace("%s: %s..:original sz_line=%s\n", __FILE__, __func__, sz_line);
	fp = fopen(STR_NUM_CITICAL, "w+t");
	if (fp) {	// File opened for read OK ?		
		if (fwrite(sz_line, sizeof(char), strlen(sz_line) , fp) == strlen(sz_line) ) {
			fclose(fp);
		}else
			sp_cserviceTrace("%s: %s..:fwrite error..\n", __FILE__, __func__);
	}else
		sp_cserviceTrace("%s: %s..:fopen error STR_NUM_CITICAL=%s\n", __FILE__, __func__, STR_NUM_CITICAL);
	
}			


void add_num_crt(){
	NUM_CITICAL++;
	sp_cserviceTrace("%s: %s..:echo %d > %s\n", __FILE__, __func__, NUM_CITICAL, STR_NUM_CITICAL);
	set_num_crt(NUM_CITICAL);
	
}

void del_num_crt(){
	NUM_CITICAL--;
	sp_cserviceTrace("%s: %s..:echo %d > %s\n", __FILE__, __func__, NUM_CITICAL, STR_NUM_CITICAL);
	set_num_crt(NUM_CITICAL);
}

//--------------------------------------------------------------------------------------------------
void set_num_accept(int num){
	FILE* fp;
	unsigned char sz_line[12];
	
	memset(sz_line, '\0', sizeof(sz_line));
	sprintf(sz_line, "%d", num);
	sp_cserviceTrace("%s: %s..:original sz_line=%s\n", __FILE__, __func__, sz_line);
	fp = fopen(STR_NUM_ACCEPT, "w+t");
	if (fp) {	// File opened for read OK ?		
		if (fwrite(sz_line, sizeof(char), strlen(sz_line) , fp) == strlen(sz_line) ) {
			fclose(fp);
		}else
			sp_cserviceTrace("%s: %s..:fwrite error..\n", __FILE__, __func__);
	}else
		sp_cserviceTrace("%s: %s..:fopen error STR_NUM_CITICAL=%s\n", __FILE__, __func__, STR_NUM_CITICAL);
	
}			


int get_pid_from_file(char* ptr){
	int dw_crt_qty=0;
	FILE* fp;
	unsigned char sz_line[12];
	
	memset(sz_line, '\0', sizeof(sz_line));
	
	fp = fopen(WATCHDOG_PID_FILE, "rt");
	if (fp) {	// File opened for read OK ?		
		if (fread(sz_line, sizeof(char), sizeof(sz_line) - 1, fp) > 0) {
			dw_crt_qty = (unsigned int)atoi(sz_line);
		}		
		fclose(fp);
	}
	sp_cserviceTrace("%s: %s..: pid_from_file=%d\n", __FILE__, __func__, dw_crt_qty);
	return dw_crt_qty;
}

void sp_system( char *fmt,...)
{
    va_list ap;
	char fmtbuf[256];
	
    va_start(ap,fmt);
    vsnprintf(fmtbuf,128,fmt,ap);
    system(fmtbuf);
    va_end(ap);
}