//#include "includes.h"
#include "sp_lib_dbg.h"
#include <assert.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "sp_iconv_init.h"





#define	INIT_FILE_LINE_WIDTH	80
#define spWhitespaceString              " \t"

const char* sp_strSkipSpace(const char* pszString);
const char* sp_strSkip(const char* pszString, const char* pszSkip);
void dump_charset(int index);

const char* sp_strSkipSpace(const char* pszString)
{
	return (const char*)sp_strSkip(pszString, spWhitespaceString);
}

const char* sp_strSkip(const char* pszString, const char* pszSkip)
{
    assert(0 != pszString);
    assert(0 != pszSkip);

    while ('\0' != *pszString)
    {
        const char* pszSearch = pszSkip;
        while (*pszString != *pszSearch)
        {
            if ('\0' == *pszSearch)
            {
                /* Not matched any skip characters, so return.
                 */
                return pszString;
            }
            pszSearch ++;
        }

        pszString ++;
    }

    /* If here, the input string is either empty or only contained characters to be skipped.
     */
    return pszString;
}


//int main()
int sp_iconv_init()
{
	FILE* fp;
	int i=0,j, found, init=0;
	char dir[80];
	static   char					dbuf[INIT_FILE_LINE_WIDTH];
	SP_ICONV_INIT_DUMP("%s: %s..: %d\n", __FILE__, __func__,ICONV_INIT_FILE_COUNT);
	
	for(i=0; i<ICONV_INIT_FILE_COUNT; i++ ){
		if( (iconv_file[i].grain >3) || (iconv_file[i].grain <= 0) )
			SP_ICONV_INIT_DUMP("%s: %s..:invalid.. iconv_file[i].grain=%d\n", __FILE__, __func__, iconv_file[i].grain);
			
		if( (iconv_file[i].charset==NULL) )
		{
			SP_ICONV_INIT_DUMP("%s: %s..:if( (iconv_file[%d].charset==NULL) )\n", __FILE__, __func__, i);
			exit(0);
		}
	}
	
	sprintf(dir,"/mnt/%s", FILE_CP);
	if  ((fp = fopen(dir, "r")) == NULL){
		SP_ICONV_INIT_DUMP("%s: %s..:fopen %s fail\n", __FILE__, __func__, dir);
		assert(fp==NULL);
		//exit (1);
	}else{
    	char *temp, *ch, *chset_name;
    	char label[5][40];
    	int k=0;
    	int new_chset=0;
    	int base16 =1;
    		
    	memset(dbuf, 0, INIT_FILE_LINE_WIDTH);
  	
  		SP_ICONV_INIT_DUMP("%s: %s..:fopen %s ok\n", __FILE__, __func__, dir);
  	
    	while ( ((temp=fgets(dbuf, INIT_FILE_LINE_WIDTH, fp) ) != NULL) )	{
    		
        	//SP_ICONV_INIT_DUMP("%s: %s..:dbuf=%s\n", __FILE__, __func__, dbuf);
        	
        	//skip the enter key
	        if (strlen(sp_strSkipSpace(dbuf)) == 1)
            	continue;
            
          	temp = (char *)sp_strSkipSpace( dbuf );
          	//SP_ICONV_INIT_DUMP("%s: %s..:temp=%s\n", __FILE__, __func__, temp);
          	
          	if(strncmp(temp, "//static", 8)==0){
          		//No this is a start of newly char set..
          		new_chset =1;
          		
	          	sscanf(temp, "%s %s %s %s %s", label[0], label[1], label[2], label[3], label[4]);
	          	//SP_ICONV_INIT_DUMP("after sscanf..:label[0]=%s label[1]=%s label[2]=%s label[3]=%s label[4]=%s\n", 
	          	//			label[0], label[1], label[2], label[3], label[4]);
	          	
	          	chset_name = !strcmp(label[2], "unsigned") ? label[4] : label[3];
	          	//SP_ICONV_INIT_DUMP("%s: %s..:chset_name=%s\n", __FILE__, __func__, chset_name);
	          	if( (ch=strchr(chset_name, '[')) !=NULL ){
	          		SP_ICONV_INIT_DUMP("%s: %s..:'[' found in scanf of %s\n", __FILE__, __func__, chset_name);
	          		fclose(fp);
	          		exit(0);
	        	}
	        	
	          	found = -1;
	          	k=0;
	        	
	          	//need to search.. the array
	          	if( !strcmp(iconv_file[init].file, chset_name) ){
	          		found = init;
	          		//SP_ICONV_INIT_DUMP("%s: %s..:iconv_file[%d].file=%s\n", __FILE__, __func__, init, iconv_file[init].file);
	          		//SP_ICONV_INIT_DUMP("%s: %s..:found=%d\n", __FILE__, __func__, found);
	          		init++;
	          	}else{
	        		for(i=0; i<ICONV_INIT_FILE_COUNT; i++){
	        			if( !strcmp(iconv_file[i].file, chset_name) ){
	        				//SP_ICONV_INIT_DUMP("%s: %s..:iconv_file[%d].file=%s\n", __FILE__, __func__, i, iconv_file[i].file);
	        				found = i;
	        				break;
	        			}
	        		}
	        	}
	        	if(found == -1){
        			SP_ICONV_INIT_DUMP("%s: %s..:fail to find mapping structure for %s\n", __FILE__, __func__, chset_name);
        			//fclose(fp);
        			//exit(1);
	        	}
				//sp
				/*
	        	if(found==1)
	        		break;
	        	*/	
	        	continue;
	        	
        	}else if(temp[0] == '/' && (temp[1] == '/' || temp[1] == '*')  )
          		continue;
          	if(found != -1) {
	          	// Look for comment lines; they start with # or % 
	          	if ((strchr(temp, '#') == 0)
	               && (strchr(temp, '%') == 0)
	               && (temp[0] != 0x0d))
	        	{
	        		char str[7];
	        		char* cur_str= str;
	        		int count=0;
	        		int init_ch=0;
	        		
	        		memset(str, 0, 7);
	        		//SP_ICONV_INIT_DUMP("%s: %s..:1..temp=%s\n", __FILE__, __func__, temp);
	        		
	        		while(*temp != 0){
//temp++;
	        			while( (temp[0]==' ') ||(temp[0]=='\t') )
	        				temp++;
	        				
	        			if(*temp != ',' && *temp != ' '){
	        				//SP_ICONV_INIT_DUMP("%s: %s..:if(*temp=%c != ',' && *temp != ' '){\n", __FILE__, __func__, *temp);
	        				*cur_str++ = *temp++;
	        				/*
	        				cur_str[init_ch] = *temp; 
	        				init_ch++;
	        				temp++;
	        				if(init_ch==7){
	        					printf("%s: %s..:if(init_ch==7){ temp=%s\n", __FILE__, __func__, temp);
	        					
	        				}
	        				//assert(init_ch==7);
	        				*/
	        			}else{
	        				
	        				
	        				//count++;
	        				//terminate the string 
	        				
	        				*cur_str = 0;
	        				//cur_str[init_ch]=0;
	        				
							//SP_ICONV_INIT_DUMP("%s: %s..:temp=%p\n", __FILE__, __func__, temp);
	        				temp = temp + 1;	//skip the ',' char.
	        				//SP_ICONV_INIT_DUMP("%s: %s..:temp=%p\n", __FILE__, __func__, temp);
	        				
//	        				temp = (char *)sp_strSkipSpace( temp );
	        				
	        				//if(found==9){
	        				//	SP_ICONV_INIT_DUMP("%s: %s..:temp=%s\n", __FILE__, __func__, temp);
	        				//	SP_ICONV_INIT_DUMP("%s: %s..:str=%s strtol(str, NULL, 16)=0x%04x\n", __FILE__, __func__, str, strtol(str, NULL, 16));
	        				//}
	        				
	        				if(new_chset){
	        					new_chset =0;
	        					if( (str[0]=='0') && (str[1]=='x') )
	        						base16 =1;
	        					else 
	        						base16 =0;
	        				}
	        				
	        				if(iconv_file[found].grain==1)
	        					//iconv_file[found].uchset[k++]= (base16) ? strtol(str, NULL, 16): strtol(str, NULL, 10);
	        					((unsigned char*)iconv_file[found].charset)[k++]= (base16) ? strtol(str, NULL, 16): strtol(str, NULL, 10);
	        				else if(iconv_file[found].grain==2){
	        					//iconv_file[found].shset[k++]= (base16) ? strtol(str, NULL, 16): strtol(str, NULL, 10);
	        					((short*)iconv_file[found].charset)[k++]= (base16) ? strtol(str, NULL, 16): strtol(str, NULL, 10);
	        					
	        					//if(found==9)
	        						//SP_ICONV_INIT_DUMP("%s: %s..:iconv_file[found].shset[%d]=0x%04x\n", __FILE__, __func__, k-1, iconv_file[found].shset[k-1] );
	        					
	        				}else{
	        					//iconv_file[found].ushset[k++]= (base16) ? strtol(str, NULL, 16): strtol(str, NULL, 10);
	        					((unsigned short*)iconv_file[found].charset)[k++]= (base16) ? strtol(str, NULL, 16): strtol(str, NULL, 10);
	        					
	        					//if(found==0)
	        					//	SP_ICONV_INIT_DUMP("%s: %s..:iconv_file[0].ushset[%d]=0x%04x\n", __FILE__, __func__, k-1, iconv_file[0].ushset[k-1] );
	        					
	        					//if( !strcmp(iconv_file[found].file, "isoir165ext_2charset") ) 
	        					//	SP_ICONV_INIT_DUMP("%s: %s..:iconv_file[found].ushset[%d]=0x%04x\n", __FILE__, __func__, k-1, iconv_file[found].ushset[k-1] );
	        					
	        				}
	        					
	        				cur_str= str;
	        				//init_ch=0;
	        				
	        			}
	        			//if(count ==8)
	        			//	break;	//skip the rest of comment in the tail..
	        		}//while(*temp != 0)
	        		
	        		/*
	        		if( !strcmp(iconv_file[found].file, "isoir165ext_2charset") && k >= 875){ 
	        			printf("break..");
	        			break;
	        		}
	        		*/
	        	}
        	}//if(found!=-1)
        	
        	memset(dbuf, 0, INIT_FILE_LINE_WIDTH);
        }//while	        
        fclose(fp);
        
        for(i=0; i<ICONV_INIT_FILE_COUNT; i++){
        	;//dump_charset(i);
        	/*
        	if(i<2)
        		dump_charset(i);
        	else if(i>38)
        		dump_charset(i);
        	*/
        	/*
        	if( !strcmp(iconv_file[i].file, "isoir165ext_2charset") ) 
        		dump_charset(i);
        	*/
        }
        
        
    }//else of fopen..
	
    return(0);
    
}

void dump_charset(int index){
	int i=0;
	
	sp_iconv_initTrace("dump %s\n", iconv_file[index].file);
	for (i=0; i< iconv_file[index].size; i++ )
	{
		if(i% 8 ==0)
			SP_ICONV_INIT_DUMP("\n");
		if(iconv_file[index].grain == 1)
			SP_ICONV_INIT_DUMP("0x%02x, ", ((unsigned char*)iconv_file[index].charset)[i]);
		else if(iconv_file[index].grain == 2)
			SP_ICONV_INIT_DUMP("%5d, ", ((short *)iconv_file[index].charset)[i]);
		else
			SP_ICONV_INIT_DUMP("0x%04x, ", ((unsigned short*)iconv_file[index].charset)[i]);
	}
	SP_ICONV_INIT_DUMP("\n");	
}



