// Send the ioctl command to eth device for power down NH200 .

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <asm/errno.h>
#include <net/if.h>          // for ifreq & IFNAMSIZ
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>


//
// Subject :
//   The main (entry) routine.
// 
//
int main(int argc, char **argv)
{
  argc = argc;
  argv = argv;
  
  // 1) initiate the ifreq structure
  struct ifreq st_ifr;
  strcpy(st_ifr.ifr_name, "eth0"); 
  st_ifr.ifr_data = NULL;

  // 2) create a channel to net of kernel
  int dw_sockfd = 0;
  if ((dw_sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
    printf("Error : failed to create a channel to the NET kernel.\n");
    return (-ENODEV);
  }

  // 3) issue command to Ethernet driver              
  if (ioctl(dw_sockfd, SIOCDEVPRIVATE + 10, &st_ifr) < 0) {   // (+ 12) to set Bridge or Router mode
    printf("Error : failed to control device %s\n", st_ifr.ifr_name);
    return (-EIO);
  }

  return (0);                           // return as error
}

