#ifndef BTCONFIG_H
#define BTCONFIG_H

extern size_t cfg_req_slice_size;

#define MAX_METAINFO_FILESIZ	4194304
#define cfg_max_slice_size 131072
#define cfg_req_queue_length 64

#ifdef M_NH220
 
  #define M_1K           1024 		         // 1024 == 1K

  // Convert Bps (Bytes/sec) to Kbps (Kbits/sec) in  xx.xxxx  format
  #define Bps_2_Kbps(Bps)  ( (Bps * 8.0) / 1024.0 )

  // NO# of seconds to update the status of P2P to file
  // Do not set it too small to reduce the system performance
  #define SECONDS_TO_UPDATE_STATUS_FILE  10      // update status file per 10 seconds

  // Maximum of bandwdith usable for download and upload (in Kbps).
  // In order to limit the download/upload bandwidth separatedly. 
  //   The "size_t" is 4-byte sign integer (maximum positive value is (2**31)/1024 Kbps)  
  #define MAX_OF_BANDWIDTH   (2 * M_1K * M_1K)   // (2*K*K) Kbps == 2Gbps
  #define MIN_OF_BANDWIDTH   1                   // 1Kbps
  extern size_t  cfg_max_download_bandwidth, cfg_max_upload_bandwidth;


  #define MAX_OF_PEERS  10                       // maximum NO# of peers allowed
  #define MIN_OF_PEERS  1                        // minimum NO# of peers allowed
#endif

extern size_t cfg_cache_size;

extern size_t cfg_max_peers;
extern size_t cfg_min_peers;

extern int cfg_listen_port;
extern int cfg_max_listen_port;
extern int cfg_min_listen_port;

extern time_t cfg_seed_hours;

extern int cfg_max_bandwidth;

// arguments global value
extern char *arg_metainfo_file;
extern char *arg_bitfield_file;
extern char *arg_save_as;

extern unsigned char arg_flg_force_seed_mode;
extern unsigned char arg_flg_check_only;
extern unsigned char arg_flg_exam_only;
extern unsigned char arg_flg_make_torrent;

extern size_t arg_piece_length;
extern char *arg_announce;
#endif
