#include "includes.h"
#include "sp_lib_dbg.h"

static int NUM_DAEMON=0;

int get_num_smb(){
	int dw_smb_qty= -1;
	FILE* fp;
	sp_smbd_num_dbg(0,("%s: %s..:\n", __FILE__, __func__));
	//unsigned char sz_line[80];
	unsigned char sz_line[12];
	
	memset(sz_line, '\0', sizeof(sz_line));
	
	fp = fopen(STR_SMBD_NUM_FILE, "r");
	if (fp) {	// File opened for read OK ?		
		if (fread(sz_line, sizeof(char), sizeof(sz_line) - 1, fp) > 0) {
			dw_smb_qty = (unsigned int)atoi(sz_line);
		}		
		fclose(fp);
		//SP_SMBD_NUM_DUMP("%s: %s..:current smb_num=%d\n", __FILE__, __func__, dw_smb_qty);
		return dw_smb_qty;
	}else{
		SAMBA_DUMP("%s: %s..:fopen STR_SMBD_NUM_FILE=%s fail strerror(%d)=%s\n", __FILE__, __func__, STR_SMBD_NUM_FILE, errno, strerror(errno));
	}
	return dw_smb_qty;
}

void set_num_smb(int num){
	FILE* fp;
	unsigned char sz_line[12];
	
	memset(sz_line, '\0', sizeof(sz_line));
	sprintf(sz_line, "%d", num);
	SP_SMBD_NUM_DUMP("%s: %s..:original sz_line=%s\n", __FILE__, __func__, sz_line);
	fp = fopen(STR_SMBD_NUM_FILE, "w+t");
	if (fp) {	// File opened for read OK ?		
		if (fwrite(sz_line, sizeof(char), strlen(sz_line) , fp) == strlen(sz_line) ) {
			fclose(fp);
		}else
			SP_SMBD_NUM_DUMP("%s: %s..:fwrite error..\n", __FILE__, __func__);
	}else
		SP_SMBD_NUM_DUMP("%s: %s..:fopen error STR_SMBD_NUM_FILE=%s\n", __FILE__, __func__, STR_SMBD_NUM_FILE);
	
}			

void add_num_smb(){
	NUM_DAEMON++;
	SP_SMBD_NUM_DUMP("%s: %s..:echo %d > %s\n", __FILE__, __func__, NUM_DAEMON, STR_SMBD_NUM_FILE);
	set_num_smb(NUM_DAEMON);
	
}

void del_num_smb(){
	NUM_DAEMON--;
	SP_SMBD_NUM_DUMP("%s: %s..:echo %d > %s\n", __FILE__, __func__, NUM_DAEMON, STR_SMBD_NUM_FILE);
	set_num_smb(NUM_DAEMON);
}





int smbd_add_lock_file()
{	sp_smbd_num_dbg(0,("%s: %s..:\n", __FILE__, __func__));
	int file_desc;
    
    file_desc = open(STR_SMBD_LOCK_FILE, O_RDWR | O_CREAT | O_EXCL, 0444);
    if (file_desc == -1) {
        sp_smbd_num_dbg(0,("%s: %s..:Open STR_SMBD_LOCK_FILE=%s failed..strerror(%d)=%s\n", __FILE__, __func__, 
				STR_SMBD_LOCK_FILE, errno, strerror(errno) ));
		//SAMBA_DUMP("%s: %s..:Open STR_SMBD_LOCK_FILE=%s failed..strerror(%d)=%s\n", __FILE__, __func__, 
		//		STR_SMBD_LOCK_FILE, errno, strerror(errno) );
        return -1;
    }else {
        sp_smbd_num_dbg(0,("%s: %s..:Open STR_SMBD_LOCK_FILE=%s succeeded\n", __FILE__, __func__, STR_SMBD_LOCK_FILE));
        //SAMBA_DUMP("%s: %s..:Open STR_SMBD_LOCK_FILE=%s succeeded\n", __FILE__, __func__, STR_SMBD_LOCK_FILE);
    }
    close(file_desc);
    return 0;
}

int smbd_del_lock_file(){
	sp_smbd_num_dbg(0,("%s: %s..:\n", __FILE__, __func__));
	int ret= unlink(STR_SMBD_LOCK_FILE);
	
	if (ret == -1){
		SAMBA_DUMP("%s: %s..:unlink STR_SMBD_LOCK_FILE=%s fails..strerror(%d)=%s\n", __FILE__, __func__, 
				STR_SMBD_LOCK_FILE, errno, strerror(errno) );
	}	
	return ret;	
}


int sp_sleep(int s, int ms){
	struct timeval tv;
	int retval;
	//struct timeval {
	//	time_t		tv_sec;		// seconds 
	//	suseconds_t	tv_usec;	// microseconds 
	//};
	sp_smbd_num_dbg(0,("%s: %s..:\n", __FILE__, __func__));
	
	//sleep() is a bad idea..
	tv.tv_sec = s;                    // wait for s seconds. ms microseconds
    tv.tv_usec = ms;

	retval = select(0, NULL, NULL, NULL, &tv); 	// wait for n seconds with non-blocking
	if (retval == -1){
		SAMBA_DUMP("%s: %s..:select fails..strerror(%d)=%s\n", __FILE__, __func__, errno, strerror(errno) );
	}

	return retval;	
}








