#!/bin/sh
#

#. /etc/init.d/options
#. /etc/init.d/netdevconf

# Declarations

UPNP_ENABLE=1
#LIF=$realdev_int
LIF=eth0
UPNPPORT="8091" 

start() {
    if [ ${UPNP_ENABLE} -eq 1 ] ; then
      route add -net 239.0.0.0 netmask 255.0.0.0 ${LIF}
      #cd /upnp_soho
      cd /etc/xml
      watch_prog upnp_soho 15 10 '/sbin/upnp_soho -p 8091 &'&
      echo $! > /var/run/watch_upnp.pid
      #$LOG "upnp: upnp_soho started."
    fi
}

stop() {
	kill `cat /var/run/watch_upnp.pid`
    killall -9 upnp_soho
    rm /var/run/upnp_soho.pid
    rm /var/run/watch_upnp.pid
    #$LOG "upnp: upnp_soho stop."
}

restart() {
    stop 
    while pidof upnp_soho;do sleep 1;done
    start
}


case "$1" in
  start)
	start
    ;;		
  stop)
    stop
    ;;
  restart)
    restart
    ;;
  *) 
    echo "Usage: $0 {start|stop|restart}"
    ;;        
esac
