#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <arpa/inet.h>
#include <stdarg.h>

#include "debug.h"

#define SIGWATCHDOG			101

#define STR_NUM_CITICAL    "/var/run/num_critical" 
#define WATCHDOG_PID_FILE	"/var/run/watchdog.pid"
void sp_system( char *fmt,...);


int get_num_crt(){
	int dw_crt_qty;
	FILE* fp;
	unsigned char sz_line[12];
	
	memset(sz_line, '\0', sizeof(sz_line));
	
	fp = fopen(STR_NUM_CITICAL, "rt");
	if (fp) {	// File opened for read OK ?		
		if (fread(sz_line, sizeof(char), sizeof(sz_line) - 1, fp) > 0) {
			dw_crt_qty = (unsigned int)atoi(sz_line);
		}		
		fclose(fp);
	}
	sp_watchdogTrace("%s: %s..:original crt_num=%d\n", __FILE__, __func__, dw_crt_qty);
	return dw_crt_qty;
}

int get_num_accept(){
	int dw_crt_qty;
	FILE* fp;
	unsigned char sz_line[12];
	
	memset(sz_line, '\0', sizeof(sz_line));
	
	fp = fopen(STR_NUM_ACCEPT, "rt");
	if (fp) {	// File opened for read OK ?		
		if (fread(sz_line, sizeof(char), sizeof(sz_line) - 1, fp) > 0) {
			dw_crt_qty = (unsigned int)atoi(sz_line);
		}		
		fclose(fp);
	}
	sp_watchdogTrace("%s: %s..:original crt_num=%d\n", __FILE__, __func__, dw_crt_qty);
	return dw_crt_qty;
}
		
static void sig_watchdog()
{
	sp_watchdogTrace("%s: %s..:\n", __FILE__, __func__);
	
	if (signal(SIGWATCHDOG, sig_watchdog) == SIG_ERR)	
		sp_watchdogTrace("%s: %s..:signal error\n", __FILE__, __func__);

	sp_system("/sbin/httpd&");
	
	return;	
}

//---------------------------------------------------------------------------------------------------
int main(int argc, char *argv[])
{
	int pid_fd;
	
	sp_watchdogTrace("%s: %s..:\n", __FILE__, __func__);
	
	pid_fd = pidfile_acquire(WATCHDOG_PID_FILE);
	pidfile_write_release(pid_fd);
		
	if (signal(SIGWATCHDOG, sig_watchdog) == SIG_ERR)
		sp_watchdogTrace("%s: %s..:signal error in init\n", __FILE__, __func__);
	else
		sp_watchdogTrace("%s: %s..:signal OK..\n", __FILE__, __func__);
		
#ifndef DEBUGGING
	pid_fd = pidfile_acquire(WATCHDOG_PID_FILE);
	if (daemon(0, 1)) {
        (void) fprintf(stderr, "portmap: fork: %s", strerror(errno));
        exit(1);
    }
    pidfile_write_release(pid_fd);
#endif   
    
    while(1) {
		sleep(100);
	}

	
}



//---------------------------------------------------------------------------------------------------


void sp_system( char *fmt,...)
{
    va_list ap;
	char fmtbuf[256];
	
    va_start(ap,fmt);
    vsnprintf(fmtbuf,128,fmt,ap);
    system(fmtbuf);
    va_end(ap);
}