#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/vfs.h>
#include <errno.h>
#include <dirent.h>
#include <fcntl.h>
#include "include/httpd.h"
#include "include/httpd_torrent.h"
#include "include/httpd_sysconf.h"

#define READ_LONG			1024
#define MAX_URL 			100
#define MAX_USER 			50
#define MAX_NAME			17
#define MAX_TORRENT         10
#define MAX_QUEUE           50

#define DEBUG
#undef DEBUG
#ifdef DEBUG
#define MSG(string,args...) fprintf(stderr,string,##args)
#else
#define MSG(string,args...)
#endif

void show_download_folder(char *data, FILE *out);
void list_torrent_file(char *data, FILE *out);
void torrent_config(char *data, FILE *out);
void show_file_and_folder(FILE *out, char *dir, char *kind, int depth);
void set_torrent_download(char *data, FILE *out);
void set_folder_download(char *data, FILE *out);
void set_torrent_option(char *data, FILE *out);
int search_torrent_file(char *dir, int depth);
void Config_torrent(char *data, FILE *out);
int parser_status(char *dir_name, char *file_name, int record_num);
void Show_download_status(char *data, FILE *out);
void Show_queue_config(char *data, FILE *out);
void torrent_management(char *data, FILE *out);
void change_queue_config(char *data, FILE *out);
void Set_webserver(char *data, FILE *out);
void write_services(int num);
extern void get_hdcapacity(void);
extern void httpd_decode(char *string);
extern void Restart_System(char *data, FILE *out);

int status_num;
int add_count;
DOWNLOAD_DATA ADD_FILE[50];
DOWNLOAD_DATA_TEMP ADD_FILE_TEMP[50];  //allen adds to declare source BT path
DOWNLOAD_DATA_TEMP_HISTORY ADD_FILE_TEMP_HISTORY[50];  //allen adds to declare source BT path
char file_directory[4096];
DOWNLOAD_STATUS status_record[MAX_TORRENT];
CONFIGURATION_DATA queue_record[MAX_QUEUE];
CONFIGURATION_DATA new_download;
extern char hdcapacity[20];

extern struct{
    char DHCP_ENABLE[2];
    char IP[20];
    char GATEWAY[20];
    char NETMASK[20];
    char HOSTNAME[17];
    char WORKGROUP[17];
    char HOSTNAME_FULL[51];
    char USERNAME[20];
    char PASSWORD[20];
    char FTP_MAX_UNIT[3];
	char FTP_PORT_NUMBER[6];
	char FTP_TIMEOUT[4];
	char FTP_ANONYMITY[2];
	char FTP_ENABLE[2];
	char LEGAL_IP[10][20];
	char IP_SECURITY_MODE[2];
	char LEGAL_MAC[10][30];
	char MAC_SECURITY_MODE[2];
	char TIME_MODE[2];
	char TIME_SERVER[40];
	char TIME_ZONE[25];
	char TIME_DIFFER[10];
	char TIME_VALUE[30];
	char DNS_SERVER[20];
	char CODE_SET[20];
	char TCONFIG_FOLDER[17];
	char TCONFIG_FILENAME[17];
	char TORRENT_USER[3];
	char TORRENT_ENABLE[2];
	char WEB_ENABLE[2];
	char WEB_PORT[6];
	char WEB_FOLDER[17];
	char CRON_ENABLE[2];
	char CRON_START_DAY[2];
	char CRON_START_HOUR[3];
	char CRON_START_MIN[3];
	char CRON_END_DAY[2];
	char CRON_END_HOUR[3];
	char CRON_END_MIN[3];
	char ADMIN_PORT[6];
}CONFIG;

#if defined(CENTURY)

//CGI to show P2P main WEB page
void torrent_config(char *data, FILE *out){
	
	FILE *fp;
	char *ptr;
	unsigned long long size;
    int i, count=0;
    float percent, small_size;
    char compare[1024], max_bw[8], min_bw[8];
	char LineBuf[1024], dir[30], command[50], time[21];
	
	//get_hdcapacity();
	memset(file_directory,0,4096);
	for(i=0;i<MAX_TORRENT;i++)
		memset(status_record,0,sizeof(status_record));
	status_num = 0;
	sprintf(dir,"/mnt/%s",CONFIG.TCONFIG_FOLDER);
	search_torrent_file(dir,0);    //get the information about downloading
	chdir("/htdocs");
	
	if((fp=fopen("/htdocs/torrent_refresh.htm","r")) == NULL){
	    return;
	}else{
	    while(fgets(LineBuf,1023,fp) != NULL)
            fprintf(out,"%s",LineBuf);
        fclose(fp);
    }
    fprintf(out,"<form name=\"p2p\" method=\"Get\" action=\"torrent_management.cgi\">\n");
    fprintf(out,"<tr><td colspan=7></td></tr>\n");
    //To print downloading files(up to 10)
#ifdef CENTURY
    fprintf(out,"<tr><td colspan=7><b><font color=\"#0C479D\">Downloading ... </font></b><hr></td></tr>\n");        
    fprintf(out,"<tr><td width=\"5%\" bgcolor=\"#DFEFFF\"><b><font color=\"#0C479D\" size=\"2\"><div id=\"sel\" onmousemove=\"show(this.id)\">Sel</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"file\" onmousemove=\"show(this.id)\">Torrent File</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"percent\" onmousemove=\"show(this.id)\">D/L(%)</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"size\" onmousemove=\"show(this.id)\">Size(MB)</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"time\" onmousemove=\"show(this.id)\">Start Time</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"rate\" onmousemove=\"show(this.id)\">Rate(Down/Up)</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"max\" onmousemove=\"show(this.id)\">MAX Rate(Down/Up)</div></font></b></td></tr>\n");
#else
    fprintf(out,"<tr><td colspan=7><b><font color=\"#%s\">Downloading ... </font></b><hr></td></tr>\n",get_font_color());        
    fprintf(out,"<tr><td width=\"5%\" bgcolor=\"#FFFFFF\"><b><font color=\"#0066CC\" size=\"2\"><div id=\"sel\" onmousemove=\"show(this.id)\">Sel</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"file\" onmousemove=\"show(this.id)\">Torrent File</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"percent\" onmousemove=\"show(this.id)\">D/L(%)</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"size\" onmousemove=\"show(this.id)\">Size(MB)</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"time\" onmousemove=\"show(this.id)\">Start Time</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"rate\" onmousemove=\"show(this.id)\">Rate(Down/Up)</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"max\" onmousemove=\"show(this.id)\">MAX Rate(Down/Up)</div></font></b></td></tr>\n");
#endif

    for(i=0;i<MAX_TORRENT;i++){
    	if(strlen(status_record[i].filename)){
    		//1. Download Percent
		    percent = ((float)atoi(status_record[i].piece_receive)/(float)atoi(status_record[i].piece_file)) * (float)100;
		    //MSG("%s: Line%d - status_record[%d].piece_receive = %s\n",__func__,__LINE__,i,status_record[i].piece_receive);
		    //MSG("%s: Line%d - status_record[%d].piece_file = %s\n",__func__,__LINE__,i,status_record[i].piece_file);
		    //MSG("%s: Line%d - percent = %.2f\n",__func__,__LINE__,percent);
    		//2. File size(Unit: KBit)
    		if(strlen(status_record[i].piece_len) && strlen(status_record[i].piece_total)){
    		    size = ((unsigned long long)atoi(status_record[i].piece_len) * (unsigned long long)atoi(status_record[i].piece_total))/(unsigned long long)1000000;
    		    MSG("%s: Line%d - %d\n",__func__,__LINE__,atoi(status_record[i].piece_len) * atoi(status_record[i].piece_total));
    		}else{
    		    size = ((unsigned long long)atoi(status_record[i].piece_len) * (unsigned long long)atoi(status_record[i].piece_file))/(unsigned long long)1000000;
    		    MSG("%s: Line%d - %d\n",__func__,__LINE__,atoi(status_record[i].piece_len) * atoi(status_record[i].piece_file));
    		}
    		if(size < 1){
	    		if(strlen(status_record[i].piece_len) && strlen(status_record[i].piece_total)){
	    		    small_size = ((float)atoi(status_record[i].piece_len) * (float)atoi(status_record[i].piece_total))/(float)1000000;
	    		}else{
	    		    small_size = ((float)atoi(status_record[i].piece_len) * (float)atoi(status_record[i].piece_file))/(float)1000000;
	    		}
	    	}
    		//3. Start time
    		strcpy(compare,status_record[i].filename);
    		ptr = strrchr(compare,'.');
    		*ptr = '\0';
    		//MSG("%s: Line%d - compare = %s\n",__func__,__LINE__,compare);
    		get_start_time(compare,time,status_record[i].dirname,max_bw,min_bw);
    		//MSG("%s: Line%d - time = %s\n",__func__,__LINE__,time);
    		fprintf(out,"<tr><td width=\"5%%\"><input type=\"checkbox\" name=\"del_t\" value=\"%s\"></td>\n",status_record[i].filename);
    		fprintf(out,"<td><a href=\"Show_download_status.cgi?dir=%s&file=%s&num=%d&status=%d\"><font size=\"2\" color=\"#%s\">%s</font></a></td>\n",status_record[i].dirname,status_record[i].filename,i,status_record[i].condition,get_font_color(),compare);
    		fprintf(out,"<td><font size=\"2\" color=\"#%s\">%.2f</font></td>\n",get_font_color(),percent);
    		if(size < 1)
    		    fprintf(out,"<td><font size=\"2\" color=\"#%s\">%.2f</font></td>\n",get_font_color(),small_size);
    		else
    		    fprintf(out,"<td><font size=\"2\" color=\"#%s\">%lld</font></td>\n",get_font_color(),size);
    		fprintf(out,"<td><font size=\"2\" color=\"#%s\">%s</font></td>\n",get_font_color(),time);
    		fprintf(out,"<td><font size=\"2\" color=\"#%s\">%s/%s</font></td>\n",get_font_color(),status_record[i].download_bw,status_record[i].upload_bw);
    		fprintf(out,"<td><font size=\"2\" color=\"#%s\">%s/%s</font></td></tr>\n",get_font_color(),max_bw,min_bw);
    	}
    }
    if(status_num == 0)
        fprintf(out,"<tr><td colspan=7><font color=\"#%s\">No downloading files</font></td></tr>\n",get_font_color());
    fprintf(out,"<tr><td colspan=7><br></td></tr>\n");
#ifdef CENTURY
    fprintf(out,"<tr><td colspan=7><br></td></tr>\n");
    fprintf(out,"<tr><td colspan=7><br></td></tr>\n");
#endif
    for(i=0;i<MAX_QUEUE;i++)
		memset(queue_record,0,sizeof(queue_record));
    read_queue_data();    //get the information about queuing
#ifdef CENTURY
    fprintf(out,"<tr><td colspan=7><b><font color=\"#0C479D\">Waiting for downloading ... </font></b><hr></td></tr>\n");    //To print queue files(up to 10)
    fprintf(out,"<tr><td width=\"5%%\" bgcolor=\"#DFEFFF\"><b><font color=\"#0C479D\" size=\"2\"><div id=\"sel_q\" onmousemove=\"show(this.id)\">Sel</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b>File Name</b></font></td><td colspan=5></td></tr>\n");
#else
    fprintf(out,"<tr><td colspan=7><b><font color=\"#%s\">Waiting for downloading ... </font></b><hr></td></tr>\n",get_font_color());    //To print queue files(up to 10)
    fprintf(out,"<tr><td width=\"5%%\" bgcolor=\"#FFFFFF\"><b><font color=\"#0066CC\" size=\"2\"><div id=\"sel_q\" onmousemove=\"show(this.id)\">Sel</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b>File Name</b></font></td><td colspan=5></td></tr>\n");
#endif
    for(i=0;i<MAX_QUEUE;i++){
    	if(strlen(queue_record[i].filename)){
            fprintf(out,"<tr><td width=\"5%%\"><input type=\"checkbox\" name=\"del_t\" value=\"%s\"></td>\n",queue_record[i].filename);
    		fprintf(out,"<td><a href=\"Show_queue_config.cgi?dir=%s&file=%s\"><font size=\"2\" color=\"#%s\">%s</font></a></td><td colspan=5></td></tr>\n",queue_record[i].dirname,queue_record[i].filename,get_font_color(),strrchr(queue_record[i].filename,'/')+1);
    		count++;
    	}
    }
    if(count == 0)
        fprintf(out,"<tr><td colspan=7><font color=\"#%s\">No queuing files</font></td></tr>\n",get_font_color());
    fprintf(out,"</table>\n");
#ifdef CENTURY
    fprintf(out,"<table border=\"0\" width=\"550\" height=\"50\" align=\"center\"><tr>\n");
#else
    fprintf(out,"<table><tr>\n");
#endif
    fprintf(out,"<td align=center><br>\n");
    MSG("%s: Line%d - hdcapacity = %s\n",__func__,__LINE__,hdcapacity);
    if(strcmp(hdcapacity,"2") || strcmp(CONFIG.TORRENT_ENABLE,"1")){       //cannot find HD, button disabled
        fprintf(out,"<input type=\"button\" name=\"set_torrent\" value=\"Add\" onClick=\"location.replace('list_torrent_file.cgi?directory=/mnt/%s&kind=file')\" disabled>&nbsp;\n",CONFIG.TCONFIG_FOLDER);
        fprintf(out,"<input type=\"submit\" name=\"save_torrent\" value=\"Inactive\" disabled>\n");
        fprintf(out,"<input type=\"button\" name=\"Back\" value=\"Back\" onclick=\"history.back()\"></td>\n");
    }else{
        if(status_num >= atoi(CONFIG.TORRENT_USER)){
        	fprintf(out,"<input type=\"button\" name=\"set_torrent\" value=\"Add\" onClick=\"alert('Active Torrent number is over the limit!! What you add will be in queue.'); location.replace('list_torrent_file.cgi?directory=/mnt/%s&kind=file');\">&nbsp;\n",CONFIG.TCONFIG_FOLDER);
            fprintf(out,"<input type=\"submit\" name=\"save_torrent\" value=\"Inactive\">\n");
            fprintf(out,"<input type=\"button\" name=\"Back\" value=\"Back\" onclick=\"history.back()\"></td>\n");
        }else{
            fprintf(out,"<input type=\"button\" name=\"set_torrent\" value=\"Add\" onClick=\"location.replace('list_torrent_file.cgi?directory=/mnt/%s&kind=file')\">&nbsp;\n",CONFIG.TCONFIG_FOLDER);
            fprintf(out,"<input type=\"submit\" name=\"save_torrent\" value=\"Inactive\">\n");
            fprintf(out,"<input type=\"button\" name=\"Back\" value=\"Back\" onclick=\"history.back()\"></td>\n");
        }       
    }
    fprintf(out,"</tr>\n</table>\n");
#ifdef CENTURY
    fprintf(out,"<table border=\"0\" width=\"550\" height=\"50\" align=\"center\">\n");
    fprintf(out,"<tr><td width=8%% valign=top><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\"><b>Note:</b></font></td>\n",get_font_color());
    fprintf(out,"<td width=100%% align=left><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\">\n",get_font_color());
    fprintf(out,"<b>1. Click \"Add\" to add a new download process.\n");
    fprintf(out,"<br>2. Click \"Inactive\" to remove the process you select from the list.\n");
    fprintf(out,"<br>3. This page will refresh automatically every 60 seconds.</td></tr></table>\n");
#else
    fprintf(out,"<table border=\"0\" width=\"75%%\" height=\"50\" align=\"center\">\n");
    fprintf(out,"<tr><td width=8%% valign=top><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\"><b>Note:</b></font></td>\n",get_font_color());
    fprintf(out,"<td width=100%% align=left><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\">\n",get_font_color());
    fprintf(out,"<b>1. Click \"Add\" to add a new download process.\n");
    fprintf(out,"<br>2. Click \"Inactive\" to remove the process you select from the list.\n");
    fprintf(out,"<br>3. This page will refresh automatically every 60 seconds.</td></tr></table>\n");
#endif
    fprintf(out,"</body></html>\n");
    if(!strcmp(CONFIG.CRON_ENABLE,"0"))
        check_torrent_status(out);
}
#elif defined(ZyXEL) || defined(PCI)

//CGI to show P2P main WEB page
void torrent_config(char *data, FILE *out){
	
	FILE *fp;
	char *ptr;
	unsigned long long size;
  int i, count=0;
  float percent, small_size;
  char compare[1024], max_bw[8], min_bw[8];
	char LineBuf[1024], dir[30], command[50], time[21];
	
	//get_hdcapacity();
	memset(file_directory,0,4096);
	for(i=0;i<MAX_TORRENT;i++)
		memset(status_record,0,sizeof(status_record));
	status_num = 0;
	sprintf(dir,"/mnt/%s",CONFIG.TCONFIG_FOLDER);
	search_torrent_file(dir,0);    //get the information about downloading
	chdir("/htdocs");
	
	if((fp=fopen("/htdocs/torrent_refresh.htm","r")) == NULL){
	    return;
	}else{
	    while(fgets(LineBuf,1023,fp) != NULL)
            fprintf(out,"%s",LineBuf);
        fclose(fp);
    }
    fprintf(out,"<form name=\"p2p\" method=\"Get\" action=\"torrent_management.cgi\">\n");
    fprintf(out,"<TBODY><TR bgColor=#ffffff><TD width=2>&nbsp;</TD><TD width=550><TABLE borderColor=#ccccdd cellSpacing=0 cellPadding=0 width=550 border=1><TBODY>\n");
		fprintf(out,"<!--File Download Status -->\n");
		fprintf(out,"<table border=1 cellpadding=4 cellspacing=0 width=\"655\"><tr><td width=\"100\" bgColor=#333399 class=style2 colspan=3><font size=2 face=\"Arial, Helvetica, sans-serif\"><DIV align=center valign=top>P2P Status</div></font></td>\n");
		fprintf(out,"<tr><tr bgcolor=\"#FFFFFF\"><th height=\"25\" align=\"left\" bgcolor=\"#FFFFFF\"><div align=center valign=top>Description</div></th>\n");
		fprintf(out,"<td height=\"25\" colspan=2>1. Click \"Add\" to add a new download process.<BR>2. Click \"Inactive\" to remove the chosen processes.\n");
		fprintf(out,"<br><div id=\"explain\">3. Move the cursor over the header field to see its hints.</td></tr></table>\n");
    
    //fprintf(out,"<tr><td colspan=7></td></tr>\n");
    //To print downloading files(up to 10)
#ifdef CENTURY
    fprintf(out,"<tr><td colspan=7><b><font color=\"#FFFFFF\">Download List </font></b><hr></td></tr>\n");        
    fprintf(out,"<tr><td width=\"5%\" bgcolor=\"#DFEFFF\"><b><font color=\"#0C479D\" size=\"2\"><div id=\"sel\" onmousemove=\"show(this.id)\">Sel</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"file\" onmousemove=\"show(this.id)\">Torrent File</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"percent\" onmousemove=\"show(this.id)\">D/L(%)</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"size\" onmousemove=\"show(this.id)\">Size(MB)</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"time\" onmousemove=\"show(this.id)\">Start Time</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"rate\" onmousemove=\"show(this.id)\">Rate(Down/Up)</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"max\" onmousemove=\"show(this.id)\">MAX Rate(Down/Up)</div></font></b></td></tr>\n");
#else
    //fprintf(out,"<tr><td colspan=7><b><font color=\"#%s\">Downloading ... </font></b><hr></td></tr>\n",get_font_color());        
    //fprintf(out,"<tr><td width=\"5%\" bgcolor=\"#FFFFFF\"><b><font color=\"#0066CC\" size=\"2\"><div id=\"sel\" onmousemove=\"show(this.id)\">Sel</div></font></b></td>\n");
    //fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"file\" onmousemove=\"show(this.id)\">Torrent File</div></font></b></td>\n");
    //fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"percent\" onmousemove=\"show(this.id)\">D/L(%)</div></font></b></td>\n");
    //fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"size\" onmousemove=\"show(this.id)\">Size(MB)</div></font></b></td>\n");
    //fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"time\" onmousemove=\"show(this.id)\">Start Time</div></font></b></td>\n");
    //fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"rate\" onmousemove=\"show(this.id)\">Rate(Down/Up)</div></font></b></td>\n");
    //fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"max\" onmousemove=\"show(this.id)\">MAX Rate(Down/Up)</div></font></b></td></tr>\n");

    fprintf(out,"<P></P>\n");
		fprintf(out,"<table border=1 cellpadding=4 cellspacing=0 width=\"655\"><td bgColor=#333399 class=style2 colspan=3><font size=2 face=\"Arial, Helvetica, sans-serif\"><DIV align=left valign=top>Downloading List</div></font></td><tr></table>\n");
		fprintf(out,"<table border=1 cellpadding=0 cellspacing=0 width=\"655\" style=\"word-break:break-all\"><tr align=center>\n");
		fprintf(out,"<tr><td width=\"20\" bgColor=#333399 class=style2><font size=1 face=\"Arial, Helvetica, sans-serif\"><div align=center id=\"sel\" onmousemove=\"show(this.id)\"> </div></font></td>\n");
		fprintf(out,"<td width=\"90\" bgColor=#333399 class=style2><font size=1 face=\"Arial, Helvetica, sans-serif\"><div align=center id=\"file\" onmousemove=\"show(this.id)\">File Name</div></font></td>\n");
		fprintf(out,"<td width=\"50\" bgColor=#333399 class=style2><font size=1 face=\"Arial, Helvetica, sans-serif\"><div align=center id=\"percent\" onmousemove=\"show(this.id)\">D/L(%%)</div></font></td>\n");
		fprintf(out,"	<td width=\"60\" bgColor=#333399 class=style2><font size=1 face=\"Arial, Helvetica, sans-serif\"><div align=center id=\"size\" onmousemove=\"show(this.id)\">Size(MB)</div></font></td>\n");
		fprintf(out,"	<td width=\"130\" bgColor=#333399 class=style2><font size=1 face=\"Arial, Helvetica, sans-serif\"><div align=center id=\"time\" onmousemove=\"show(this.id)\">Start Time</div></font></td>\n");
		fprintf(out,"<td width=\"170\" bgColor=#333399 class=style2><font size=1 face=\"Arial, Helvetica, sans-serif\"><div align=center id=\"rate\" onmousemove=\"show(this.id)\">Rate(down/up)</div></td>\n");
		fprintf(out,"<td width=\"100\" bgColor=#333399 class=style2><font size=1 face=\"Arial, Helvetica, sans-serif\"><div align=center id=\"max\" onmousemove=\"show(this.id)\">MAX Rt.</div></td>\n");
    
#endif

    for(i=0;i<MAX_TORRENT;i++){
    	if(strlen(status_record[i].filename)){
    		//1. Download Percent
		    percent = ((float)atoi(status_record[i].piece_receive)/(float)atoi(status_record[i].piece_file)) * (float)100;
		    //MSG("%s: Line%d - status_record[%d].piece_receive = %s\n",__func__,__LINE__,i,status_record[i].piece_receive);
		    //MSG("%s: Line%d - status_record[%d].piece_file = %s\n",__func__,__LINE__,i,status_record[i].piece_file);
		    //MSG("%s: Line%d - percent = %.2f\n",__func__,__LINE__,percent);
    		//2. File size(Unit: KBit)
    		if(strlen(status_record[i].piece_len) && strlen(status_record[i].piece_total)){
    		    size = ((unsigned long long)atoi(status_record[i].piece_len) * (unsigned long long)atoi(status_record[i].piece_total))/(unsigned long long)1000000;
    		    MSG("%s: Line%d - %d\n",__func__,__LINE__,atoi(status_record[i].piece_len) * atoi(status_record[i].piece_total));
    		}else{
    		    size = ((unsigned long long)atoi(status_record[i].piece_len) * (unsigned long long)atoi(status_record[i].piece_file))/(unsigned long long)1000000;
    		    MSG("%s: Line%d - %d\n",__func__,__LINE__,atoi(status_record[i].piece_len) * atoi(status_record[i].piece_file));
    		}
    		if(size < 1){
	    		if(strlen(status_record[i].piece_len) && strlen(status_record[i].piece_total)){
	    		    small_size = ((float)atoi(status_record[i].piece_len) * (float)atoi(status_record[i].piece_total))/(float)1000000;
	    		}else{
	    		    small_size = ((float)atoi(status_record[i].piece_len) * (float)atoi(status_record[i].piece_file))/(float)1000000;
	    		}
	    	}
    		//3. Start time
    		strcpy(compare,status_record[i].filename);
    		ptr = strrchr(compare,'.');
    		*ptr = '\0';
    		//MSG("%s: Line%d - compare = %s\n",__func__,__LINE__,compare);
    		get_start_time(compare,time,status_record[i].dirname,max_bw,min_bw);
    		//MSG("%s: Line%d - time = %s\n",__func__,__LINE__,time);
    		fprintf(out,"<tr><td width=\"5%%\"><input type=\"checkbox\" name=\"del_t\" value=\"%s\"></td>\n",status_record[i].filename);
    		fprintf(out,"<td><a href=\"Show_download_status.cgi?dir=%s&file=%s&num=%d&status=%d\"><font size=\"1\" color=\"#%s\">%s</font></a></td>\n",status_record[i].dirname,status_record[i].filename,i,status_record[i].condition,get_font_color(),compare);
    		fprintf(out,"<td><div align=right><font size=\"1\" color=\"#%s\">%.1f</font></div></td>\n",get_font_color(),percent);
    		if(size < 1)
    		    fprintf(out,"<td><div align=center><font size=\"1\" color=\"#%s\">%.1f</font></div></td>\n",get_font_color(),small_size);
    		else
    		    fprintf(out,"<td><div align=right><font size=\"1\" color=\"#%s\">%lld</font></div></td>\n",get_font_color(),size);
    		    
    		if(strlen(time) == 0)
    			fprintf(out,"<td><font size=\"1\" color=\"#%s\">N/A</font></td>\n",get_font_color());
    		else
    			fprintf(out,"<td><div align=center><font size=\"1\" color=\"#%s\">%s</font></div></td>\n",get_font_color(),time);
    		fprintf(out,"<td><div align=center><font size=\"1\" color=\"#%s\">%s/%s</font></div></td>\n",get_font_color(),status_record[i].download_bw,status_record[i].upload_bw);
    		fprintf(out,"<td><div align=center><font size=\"1\" color=\"#%s\">%s/%s</font></div></td></tr>\n",get_font_color(),max_bw,min_bw);
    	}
    }
    if(status_num == 0)
        fprintf(out,"<tr><td colspan=7><font color=\"#%s\">No downloading files</font></td></tr>\n",get_font_color());
    //fprintf(out,"<tr><td colspan=7><br></td></tr>\n");
#ifdef CENTURY
    fprintf(out,"<tr><td colspan=7><br></td></tr>\n");
    fprintf(out,"<tr><td colspan=7><br></td></tr>\n");
#endif
		fprintf(out,"<tr bgcolor=\"#FFFFFF\"><td width=\"100\" height=\"25\" colspan=2 align=\"left\" bgcolor=\"#FFFFFF\"><div align=center valign=center><b>Notice</div></td><td height=\"25\" colspan=6>The download numbers permit ten items for constaint with maximun value.</td></tr></table>\n");
		/*
		<table border="1" width="655" style="word-break:break-all"><tr align=center>
		<td width="210" bgColor=#333399 class=style2><font size=2 face="Arial, Helvetica, sans-serif"><div id="sel_q" onmousemove="show(this.id)">Sel</div></font></td>
		<td width="205" bgColor=#333399 class=style2 colspan=7><font size=2 face="Arial, Helvetica, sans-serif"><div align=center valign=top>File Name</div></font></td>
		<tr><td width="5%" colspan=1><input type="checkbox" name="del_t" value="/mnt/Share/creep.torrent"></td>
		<td colspan=7><a href="Show_queue_config.cgi?dir=/mnt/Share&file=/mnt/Share/creep.torrent"><font size="2" color="#000000">creep.torrent</font></a></td></tr>
		<tr bgcolor="#FFFFFF"><th height="25" align="left" bgcolor="#FFFFFF"><div align=center valign=center>Notice</div></th><td height="25" colspan=7>It had recorded download information history that included successful status and failure status in the past.</td></tr>
		</table>
		*/
    for(i=0;i<MAX_QUEUE;i++)
		memset(queue_record,0,sizeof(queue_record));
    read_queue_data();    //get the information about queuing
#ifdef CENTURY
    fprintf(out,"<tr><td colspan=7><b><font color=\"#0C479D\">Download Queue</font></b><hr></td></tr>\n");    //To print queue files(up to 10)
    fprintf(out,"<tr><td width=\"5%%\" bgcolor=\"#DFEFFF\"><b><font color=\"#0C479D\" size=\"1\"><div align=left id=\"sel_q\" onmousemove=\"show(this.id)\">Select</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"1\"><b>File Name</b></font></td><td colspan=5></td></tr>\n");
#else
    //fprintf(out,"<tr><td colspan=7><b><font color=\"#%s\">Waiting for downloading ... </font></b><hr></td></tr>\n",get_font_color());    //To print queue files(up to 10)
    //fprintf(out,"<tr><td width=\"5%%\" bgcolor=\"#FFFFFF\"><b><font color=\"#0066CC\" size=\"2\"><div id=\"sel_q\" onmousemove=\"show(this.id)\">Sel</div></font></b></td>\n");
    //fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b>File Name</b></font></td><td colspan=5></td></tr>\n");
    fprintf(out,"<P></P>\n");
		fprintf(out,"<table border=1 cellpadding=4 cellspacing=0 width=\"655\"><tr><td width=\"200\" bgColor=#333399 class=style2 colspan=3><font size=2><DIV align=left valign=top>Download Queue</div></font></td><tr></table>\n");
		fprintf(out,"<table border=1 cellpadding=0 cellspacing=0 width=\"655\" style=\"word-break:break-all\"><tr align=center>\n");
		//fprintf(out,"<td width=\"20\" bgColor=#333399 class=style2><font size=1 face=\"Arial, Helvetica, sans-serif\"><div id=\"sel_q\" onmousemove=\"show(this.id)\">V</div></font></td>\n");
		fprintf(out,"<td width=\"20\" bgColor=#333399 class=style2><font size=1 face=\"Arial, Helvetica, sans-serif\"><div align=center id=\"sel\" onmousemove=\"show(this.id)\"> </div></font></td>\n");
		fprintf(out,"<td width=\"630\" bgColor=#333399 class=style2><font size=1 face=\"Arial, Helvetica, sans-serif\"><div align=center>File Name</div></font></td>\n");
#endif
    for(i=0;i<MAX_QUEUE;i++){
    	if(strlen(queue_record[i].filename)){
            fprintf(out,"<tr><td width=20 align=center><input type=\"checkbox\" name=\"del_t\" value=\"%s\"></td>\n",queue_record[i].filename);
    		fprintf(out,"<td width=630 ><a href=\"Show_queue_config.cgi?dir=%s&file=%s\"><font size=\"2\" color=\"#%s\">%s</font></a></td></tr>\n",queue_record[i].dirname,queue_record[i].filename,get_font_color(),strrchr(queue_record[i].filename,'/')+1);
    		count++;
    	}
    }
    if(count == 0)
       fprintf(out,"<tr><td colspan=8><font color=\"#%s\">No queuing files</font></td></tr>\n",get_font_color());
    fprintf(out,"<tr bgcolor=\"#FFFFFF\"><td width=\"100\" bgcolor=\"#FFFFFF\"><div align=center valign=center><b>Notice</div></td>\n");
    fprintf(out,"<td width=550 >It had recorded download information history that included successful status and failure status in the past.</td></tr>\n");
    fprintf(out,"</table>\n");

#ifdef CENTURY
    fprintf(out,"<table border=\"0\" width=\"550\" height=\"50\" align=\"center\"><tr>\n");
#else
    fprintf(out,"<table align=center><tr>\n");
#endif
    fprintf(out,"<td><br>\n");
    MSG("%s: Line%d - hdcapacity = %s\n",__func__,__LINE__,hdcapacity);
    if(strcmp(hdcapacity,"2") || strcmp(CONFIG.TORRENT_ENABLE,"1")){       //cannot find HD, button disabled
        //fprintf(out,"<input type=\"button\" name=\"set_torrent\" value=\"Add\" onClick=\"location.replace('list_torrent_file.cgi?directory=/mnt/%s&kind=file')\" disabled>&nbsp;\n",CONFIG.TCONFIG_FOLDER);
        //fprintf(out,"<input type=\"submit\" name=\"save_torrent\" value=\"Inactive\" disabled>\n");
        //fprintf(out,"<input type=\"button\" name=\"Back\" value=\"Back\" onclick=\"history.back()\"></td>\n");
        fprintf(out,"<input type=\"button\" name=\"set_torrent\" value=\"Add\" onClick=\"location.replace('list_torrent_file.cgi?directory=/mnt/%s&kind=file')\" disabled>&nbsp;&nbsp;&nbsp;&nbsp;\n",CONFIG.TCONFIG_FOLDER);
				fprintf(out,"<input type=\"submit\" name=\"save_torrent\" value=\"Inactive\" disabled>&nbsp;&nbsp;&nbsp;&nbsp;\n");
				fprintf(out,"<input type=\"button\" value=\"Back\" onclick=\"history.back()\"></TD>\n");
    }else{
        if(status_num >= atoi(CONFIG.TORRENT_USER)){
        	//fprintf(out,"<input type=\"button\" name=\"set_torrent\" value=\"Add\" onClick=\"alert('Active Torrent number is over the limit!! What you add will be in queue.'); location.replace('list_torrent_file.cgi?directory=/mnt/%s&kind=file');\">&nbsp;\n",CONFIG.TCONFIG_FOLDER);
            //fprintf(out,"<input type=\"submit\" name=\"save_torrent\" value=\"Inactive\">\n");
            //fprintf(out,"<input type=\"button\" name=\"Back\" value=\"Back\" onclick=\"history.back()\"></td>\n");
         fprintf(out," <input type=\"button\" name=\"set_torrent\" value=\"Add\" onClick=\"alert('Active Torrent number is over the limit!! What you add will be in queue.');location.replace('list_torrent_file.cgi?directory=/mnt/%s&kind=file')\">&nbsp;&nbsp;&nbsp;&nbsp;\n",CONFIG.TCONFIG_FOLDER);
				 fprintf(out,"	<input type=\"submit\" name=\"save_torrent\" value=\"Inactive\">&nbsp;&nbsp;&nbsp;&nbsp;\n");
				 fprintf(out,"	<input type=\"button\" value=\"Back\" onclick=\"history.back()\"></TD>\n");
        }else{
            //fprintf(out,"<input type=\"button\" name=\"set_torrent\" value=\"Add\" onClick=\"location.replace('list_torrent_file.cgi?directory=/mnt/%s&kind=file')\">&nbsp;\n",CONFIG.TCONFIG_FOLDER);
            //fprintf(out,"<input type=\"submit\" name=\"save_torrent\" value=\"Inactive\">\n");
            //fprintf(out,"<input type=\"button\" name=\"Back\" value=\"Back\" onclick=\"history.back()\"></td>\n");        
           fprintf(out," <input type=\"button\" name=\"set_torrent\" value=\"Add\" onClick=\"location.replace('list_torrent_file.cgi?directory=/mnt/%s&kind=file')\">&nbsp;&nbsp;&nbsp;&nbsp;\n",CONFIG.TCONFIG_FOLDER);
		  		 fprintf(out,"	<input type=\"submit\" name=\"save_torrent\" value=\"Inactive\">&nbsp;&nbsp;&nbsp;&nbsp;\n");
					 fprintf(out,"	<input type=\"button\" value=\"Back\" onclick=\"history.back()\"></TD>\n");
        }
    }
    //fprintf(out,"</tr>\n</table>\n");
    fprintf(out,"</TR></table>\n");
#ifdef CENTURY
    fprintf(out,"<table border=\"0\" width=\"550\" height=\"50\" align=\"center\">\n");
    fprintf(out,"<tr><td width=8%% valign=top><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\"><b>Note:</b></font></td>\n",get_font_color());
    fprintf(out,"<td width=100%% align=left><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\">\n",get_font_color());
    fprintf(out,"<b>1. Click \"Add\" to add a new download process.\n");
    fprintf(out,"<br>2. Click \"Inactive\" to remove the process you select from the list.\n");
    fprintf(out,"<br>3. This page will refresh automatically every 60 seconds.</td></tr></table>\n");
#else
    //fprintf(out,"<table border=\"0\" width=\"75%%\" height=\"50\" align=\"center\">\n");
    //fprintf(out,"<tr><td width=8%% valign=top><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\"><b>Note:</b></font></td>\n",get_font_color());
    //fprintf(out,"<td width=100%% align=left><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\">\n",get_font_color());
    //fprintf(out,"<b>1. Click \"Add\" to add a new download process.\n");
    //fprintf(out,"<br>2. Click \"Inactive\" to remove the process you select from the list.\n");
    //fprintf(out,"<br>3. This page will refresh automatically every 60 seconds.</td></tr></table>\n");
    fprintf(out,"<MAP name=Map><area shape=\"rect\" coords=\"010,1,240,23\" href=\"torrent_basic.htm\">\n");
		fprintf(out,"<area shape=\"rect\" coords=\"243,1,460,23\" href=\"torrent_config.cgi\"></MAP></form>\n");
#endif
    fprintf(out,"</body></html>\n");
    if(!strcmp(CONFIG.CRON_ENABLE,"0"))
        check_torrent_status(out);
}

#else
//CGI to show P2P main WEB page
void torrent_config(char *data, FILE *out){
	
	FILE *fp;
	char *ptr;
	unsigned long long size;
    int i, count=0;
    float percent, small_size;
    char compare[1024], max_bw[8], min_bw[8];
	char LineBuf[1024], dir[30], command[50], time[21];
	
	//get_hdcapacity();
	memset(file_directory,0,4096);
	for(i=0;i<MAX_TORRENT;i++)
		memset(status_record,0,sizeof(status_record));
	status_num = 0;
	sprintf(dir,"/mnt/%s",CONFIG.TCONFIG_FOLDER);
	search_torrent_file(dir,0);    //get the information about downloading
	chdir("/htdocs");
	
	if((fp=fopen("/htdocs/torrent_refresh.htm","r")) == NULL){
	    return;
	}else{
	    while(fgets(LineBuf,1023,fp) != NULL)
            fprintf(out,"%s",LineBuf);
        fclose(fp);
    }
    fprintf(out,"<form name=\"p2p\" method=\"Get\" action=\"torrent_management.cgi\">\n");
    fprintf(out,"<tr><td colspan=7></td></tr>\n");
    //To print downloading files(up to 10)
#ifdef CENTURY
    fprintf(out,"<tr><td colspan=7><b><font color=\"#0C479D\">Downloading ... </font></b><hr></td></tr>\n");        
    fprintf(out,"<tr><td width=\"5%\" bgcolor=\"#DFEFFF\"><b><font color=\"#0C479D\" size=\"2\"><div id=\"sel\" onmousemove=\"show(this.id)\">Sel</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"file\" onmousemove=\"show(this.id)\">Torrent File</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"percent\" onmousemove=\"show(this.id)\">D/L(%)</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"size\" onmousemove=\"show(this.id)\">Size(MB)</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"time\" onmousemove=\"show(this.id)\">Start Time</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"rate\" onmousemove=\"show(this.id)\">Rate(Down/Up)</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b><div id=\"max\" onmousemove=\"show(this.id)\">MAX Rate(Down/Up)</div></font></b></td></tr>\n");
#else
    fprintf(out,"<tr><td colspan=7><b><font color=\"#%s\">Downloading ... </font></b><hr></td></tr>\n",get_font_color());        
    fprintf(out,"<tr><td width=\"5%\" bgcolor=\"#FFFFFF\"><b><font color=\"#0066CC\" size=\"2\"><div id=\"sel\" onmousemove=\"show(this.id)\">Sel</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"file\" onmousemove=\"show(this.id)\">Torrent File</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"percent\" onmousemove=\"show(this.id)\">D/L(%)</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"size\" onmousemove=\"show(this.id)\">Size(MB)</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"time\" onmousemove=\"show(this.id)\">Start Time</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"rate\" onmousemove=\"show(this.id)\">Rate(Down/Up)</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b><div id=\"max\" onmousemove=\"show(this.id)\">MAX Rate(Down/Up)</div></font></b></td></tr>\n");
#endif

    for(i=0;i<MAX_TORRENT;i++){
    	if(strlen(status_record[i].filename)){
    		//1. Download Percent
		    percent = ((float)atoi(status_record[i].piece_receive)/(float)atoi(status_record[i].piece_file)) * (float)100;
		    //MSG("%s: Line%d - status_record[%d].piece_receive = %s\n",__func__,__LINE__,i,status_record[i].piece_receive);
		    //MSG("%s: Line%d - status_record[%d].piece_file = %s\n",__func__,__LINE__,i,status_record[i].piece_file);
		    //MSG("%s: Line%d - percent = %.2f\n",__func__,__LINE__,percent);
    		//2. File size(Unit: KBit)
    		if(strlen(status_record[i].piece_len) && strlen(status_record[i].piece_total)){
    		    size = ((unsigned long long)atoi(status_record[i].piece_len) * (unsigned long long)atoi(status_record[i].piece_total))/(unsigned long long)1000000;
    		    MSG("%s: Line%d - %d\n",__func__,__LINE__,atoi(status_record[i].piece_len) * atoi(status_record[i].piece_total));
    		}else{
    		    size = ((unsigned long long)atoi(status_record[i].piece_len) * (unsigned long long)atoi(status_record[i].piece_file))/(unsigned long long)1000000;
    		    MSG("%s: Line%d - %d\n",__func__,__LINE__,atoi(status_record[i].piece_len) * atoi(status_record[i].piece_file));
    		}
    		if(size < 1){
	    		if(strlen(status_record[i].piece_len) && strlen(status_record[i].piece_total)){
	    		    small_size = ((float)atoi(status_record[i].piece_len) * (float)atoi(status_record[i].piece_total))/(float)1000000;
	    		}else{
	    		    small_size = ((float)atoi(status_record[i].piece_len) * (float)atoi(status_record[i].piece_file))/(float)1000000;
	    		}
	    	}
    		//3. Start time
    		strcpy(compare,status_record[i].filename);
    		ptr = strrchr(compare,'.');
    		*ptr = '\0';
    		//MSG("%s: Line%d - compare = %s\n",__func__,__LINE__,compare);
    		get_start_time(compare,time,status_record[i].dirname,max_bw,min_bw);
    		//MSG("%s: Line%d - time = %s\n",__func__,__LINE__,time);
    		fprintf(out,"<tr><td width=\"5%%\"><input type=\"checkbox\" name=\"del_t\" value=\"%s\"></td>\n",status_record[i].filename);
    		fprintf(out,"<td><a href=\"Show_download_status.cgi?dir=%s&file=%s&num=%d&status=%d\"><font size=\"2\" color=\"#%s\">%s</font></a></td>\n",status_record[i].dirname,status_record[i].filename,i,status_record[i].condition,get_font_color(),compare);
    		fprintf(out,"<td><font size=\"2\" color=\"#%s\">%.2f</font></td>\n",get_font_color(),percent);
    		if(size < 1)
    		    fprintf(out,"<td><font size=\"2\" color=\"#%s\">%.2f</font></td>\n",get_font_color(),small_size);
    		else
    		    fprintf(out,"<td><font size=\"2\" color=\"#%s\">%lld</font></td>\n",get_font_color(),size);
    		fprintf(out,"<td><font size=\"2\" color=\"#%s\">%s</font></td>\n",get_font_color(),time);
    		fprintf(out,"<td><font size=\"2\" color=\"#%s\">%s/%s</font></td>\n",get_font_color(),status_record[i].download_bw,status_record[i].upload_bw);
    		fprintf(out,"<td><font size=\"2\" color=\"#%s\">%s/%s</font></td></tr>\n",get_font_color(),max_bw,min_bw);
    	}
    }
    if(status_num == 0)
        fprintf(out,"<tr><td colspan=7><font color=\"#%s\">No downloading files</font></td></tr>\n",get_font_color());
    fprintf(out,"<tr><td colspan=7><br></td></tr>\n");
#ifdef CENTURY
    fprintf(out,"<tr><td colspan=7><br></td></tr>\n");
    fprintf(out,"<tr><td colspan=7><br></td></tr>\n");
#endif
    for(i=0;i<MAX_QUEUE;i++)
		memset(queue_record,0,sizeof(queue_record));
    read_queue_data();    //get the information about queuing
#ifdef CENTURY
    fprintf(out,"<tr><td colspan=7><b><font color=\"#0C479D\">Waiting for downloading ... </font></b><hr></td></tr>\n");    //To print queue files(up to 10)
    fprintf(out,"<tr><td width=\"5%%\" bgcolor=\"#DFEFFF\"><b><font color=\"#0C479D\" size=\"2\"><div id=\"sel_q\" onmousemove=\"show(this.id)\">Sel</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#DFEFFF\"><font color=\"#0C479D\" size=\"2\"><b>File Name</b></font></td><td colspan=5></td></tr>\n");
#else
    fprintf(out,"<tr><td colspan=7><b><font color=\"#%s\">Waiting for downloading ... </font></b><hr></td></tr>\n",get_font_color());    //To print queue files(up to 10)
    fprintf(out,"<tr><td width=\"5%%\" bgcolor=\"#FFFFFF\"><b><font color=\"#0066CC\" size=\"2\"><div id=\"sel_q\" onmousemove=\"show(this.id)\">Sel</div></font></b></td>\n");
    fprintf(out,"<td bgcolor=\"#FFFFFF\"><font color=\"#0066CC\" size=\"2\"><b>File Name</b></font></td><td colspan=5></td></tr>\n");
#endif
    for(i=0;i<MAX_QUEUE;i++){
    	if(strlen(queue_record[i].filename)){
            fprintf(out,"<tr><td width=\"5%%\"><input type=\"checkbox\" name=\"del_t\" value=\"%s\"></td>\n",queue_record[i].filename);
    		fprintf(out,"<td><a href=\"Show_queue_config.cgi?dir=%s&file=%s\"><font size=\"2\" color=\"#%s\">%s</font></a></td><td colspan=5></td></tr>\n",queue_record[i].dirname,queue_record[i].filename,get_font_color(),strrchr(queue_record[i].filename,'/')+1);
    		count++;
    	}
    }
    if(count == 0)
        fprintf(out,"<tr><td colspan=7><font color=\"#%s\">No queuing files</font></td></tr>\n",get_font_color());
    fprintf(out,"</table>\n");
#ifdef CENTURY
    fprintf(out,"<table border=\"0\" width=\"550\" height=\"50\" align=\"center\"><tr>\n");
#else
    fprintf(out,"<table><tr>\n");
#endif
    fprintf(out,"<td align=center><br>\n");
    MSG("%s: Line%d - hdcapacity = %s\n",__func__,__LINE__,hdcapacity);
    if(strcmp(hdcapacity,"2") || strcmp(CONFIG.TORRENT_ENABLE,"1")){       //cannot find HD, button disabled
        fprintf(out,"<input type=\"button\" name=\"set_torrent\" value=\"Add\" onClick=\"location.replace('list_torrent_file.cgi?directory=/mnt/%s&kind=file')\" disabled>&nbsp;\n",CONFIG.TCONFIG_FOLDER);
        fprintf(out,"<input type=\"submit\" name=\"save_torrent\" value=\"Inactive\" disabled>\n");
        fprintf(out,"<input type=\"button\" name=\"Back\" value=\"Back\" onclick=\"history.back()\"></td>\n");
    }else{
        if(status_num >= atoi(CONFIG.TORRENT_USER)){
        	fprintf(out,"<input type=\"button\" name=\"set_torrent\" value=\"Add\" onClick=\"alert('Active Torrent number is over the limit!! What you add will be in queue.'); location.replace('list_torrent_file.cgi?directory=/mnt/%s&kind=file');\">&nbsp;\n",CONFIG.TCONFIG_FOLDER);
            fprintf(out,"<input type=\"submit\" name=\"save_torrent\" value=\"Inactive\">\n");
            fprintf(out,"<input type=\"button\" name=\"Back\" value=\"Back\" onclick=\"history.back()\"></td>\n");
        }else{
            fprintf(out,"<input type=\"button\" name=\"set_torrent\" value=\"Add\" onClick=\"location.replace('list_torrent_file.cgi?directory=/mnt/%s&kind=file')\">&nbsp;\n",CONFIG.TCONFIG_FOLDER);
            fprintf(out,"<input type=\"submit\" name=\"save_torrent\" value=\"Inactive\">\n");
            fprintf(out,"<input type=\"button\" name=\"Back\" value=\"Back\" onclick=\"history.back()\"></td>\n");
        }       
    }
    fprintf(out,"</tr>\n</table>\n");
#ifdef CENTURY
    fprintf(out,"<table border=\"0\" width=\"550\" height=\"50\" align=\"center\">\n");
    fprintf(out,"<tr><td width=8%% valign=top><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\"><b>Note:</b></font></td>\n",get_font_color());
    fprintf(out,"<td width=100%% align=left><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\">\n",get_font_color());
    fprintf(out,"<b>1. Click \"Add\" to add a new download process.\n");
    fprintf(out,"<br>2. Click \"Inactive\" to remove the process you select from the list.\n");
    fprintf(out,"<br>3. This page will refresh automatically every 60 seconds.</td></tr></table>\n");
#else
    fprintf(out,"<table border=\"0\" width=\"75%%\" height=\"50\" align=\"center\">\n");
    fprintf(out,"<tr><td width=8%% valign=top><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\"><b>Note:</b></font></td>\n",get_font_color());
    fprintf(out,"<td width=100%% align=left><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\">\n",get_font_color());
    fprintf(out,"<b>1. Click \"Add\" to add a new download process.\n");
    fprintf(out,"<br>2. Click \"Inactive\" to remove the process you select from the list.\n");
    fprintf(out,"<br>3. This page will refresh automatically every 60 seconds.</td></tr></table>\n");
#endif
    fprintf(out,"</body></html>\n");
    if(!strcmp(CONFIG.CRON_ENABLE,"0"))
        check_torrent_status(out);
}

#endif
//To get the execute time
void get_start_time(char *compare, char *time, char *dir_name, char *max_bw, char *min_bw){
	
	FILE *fp;
	char *ptr, *end;
	char LineBuf[1024], command[50];
	
	MSG("%s: Line%d - comapre = %s\n",__func__,__LINE__,compare);
	sprintf(command,"/mnt/%s/.%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
	if((fp = fopen(command,"r")) != NULL){
        while((ptr = fgets(LineBuf,1023,fp)) != NULL){
    	    if((ptr = strstr(LineBuf,"TORRENT_RECORD")) != NULL){
    		    if(strstr(LineBuf,compare) && strstr(LineBuf,dir_name)){
	    		    ptr = strchr(LineBuf,'=');
		    			ptr++;
		    			ptr = strtok(ptr,",");
	    	    	ptr = strtok(NULL,",");
	    	    	ptr = strtok(NULL,",");
	    	    	ptr = strtok(NULL,",");
	    	    	ptr = strtok(NULL,",");
	    	    	ptr = strtok(NULL,",");
	    	    	ptr = strtok(NULL,",");
	    	    	strcpy(max_bw,ptr);
	    	    	MSG("%s: Line %d - max_bw = %s\n",__func__,__LINE__,max_bw);
	    	    	ptr = strtok(NULL,",");
	    	    	strcpy(min_bw,ptr);
	    	    	MSG("%s: Line %d - min_bw = %s\n",__func__,__LINE__,min_bw);
	    	    	ptr = strtok(NULL,",");
	    	    	strncpy(time,ptr,20);
	    	    	time[20] = '\0';
	    	    	MSG("%s: Line %d - time = %s\n",__func__,__LINE__,time);
	    		  }
	    	  }
	      }
	    	fclose(fp);
  }
}

//To find xxx.torrent.status in folder
int search_torrent_file(char *dir, int depth){
	
	DIR *dp;
	FILE *fp;
	char *ptr;
	int status;
	struct dirent *entry;
	struct stat statbuf;
	
	if((dp = opendir(dir)) == NULL){
		printf("cannot open directory: %s\n",dir);
		return 0;
    }
	//MSG("%s: Line%d - status_num = %d, dir = %s\n",__func__,__LINE__,status_num,dir);
	if(status_num == atoi(CONFIG.TORRENT_USER))
	    return 0;
    strcat(file_directory,"/");
		strcat(file_directory,dir);
		chdir(dir);
		while((entry = readdir(dp)) != NULL){
			lstat(entry->d_name,&statbuf);
			if(S_ISDIR(statbuf.st_mode)){
				if(strcmp(".",entry->d_name) == 0 || strcmp("..",entry->d_name) == 0)
				    continue;
				//printf("%*s%s/\n",depth,"",entry->d_name);
				search_torrent_file(entry->d_name,depth+4);
			}else{
			    if(strstr(entry->d_name,".torrent.status")){
		            status = parser_status(file_directory+1,entry->d_name,status_num);
			            if((status != 0) && (status != 3)){
			                strcpy(status_record[status_num].filename,entry->d_name);
			                strcpy(status_record[status_num].dirname,file_directory+1);
			                status_record[status_num].condition = status;
			                //MSG("%s: Line%d - status_record[%d].filename = %s, status_record[%d].dirname = %s\n",__func__,__LINE__,status_num,status_record[status_num].filename,status_num,status_record[status_num].dirname);
			                status_num ++;
			            }
		            //printf("status_num = %d, filename = %s, file_directory = %s\n",status_num,entry->d_name,file_directory);
			    	if(status_num == atoi(CONFIG.TORRENT_USER))
			    	    break;
			    }
			}
		}
	chdir("..");
	ptr = strrchr(file_directory,'/');    //directory goes backwards
	*ptr = '\0';
	closedir(dp);
}

//parser xxx.torrent.status to get the information
//Return value: 0 - can't read xxx.torrent.status or the process is being deleted
//              1 - read through the xxx.torrent.status successfully
//              2 - under checking
//              3 - download process is finished
int parser_status(char *dir_name, char *file_name, int record_num){
	
	int mark = 0;
	FILE *fp, *fi;
	char *ptr, *end;
	char open_file[4096], LineBuf[1024], torrent_config[50];
	
	//First, check the torrent config
	strcpy(open_file,dir_name);
	strcat(open_file,"/");
	strcat(open_file,file_name);
	ptr = strrchr(open_file,'.');
	*ptr = '\0';
	MSG("%s: Line%d - parser_status... open_file = %s\n",__func__,__LINE__,open_file);
	sprintf(torrent_config,"/mnt/%s/.%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
	if((fi = fopen(torrent_config,"r")) == NULL){
		MSG("%s: Line%d - torrent_config = %s\n",__func__,__LINE__,torrent_config);
		return 0;
	}else{
	    while(fgets(LineBuf,1023,fi)){
	    	if(strstr(LineBuf,open_file)){
	    		MSG("%s: Line%d\n",__func__,__LINE__);
	    	    mark = 1;
	    	    break;
	    	}
	    }
	    fclose(fi);
	}
	if(mark == 0){    //Don't find the torrent filename in torrent config
		MSG("%s: Line%d\n",__func__,__LINE__);
	    return 0;
	}
	//Second, read the status file
	strcpy(open_file,dir_name);
	strcat(open_file,"/");
	strcat(open_file,file_name);
	MSG("%s: Line%d - open_file = %s\n",__func__,__LINE__,open_file);
	if((fp = fopen(open_file,"r")) == NULL){
		MSG("%s: Line%d - return 0!!\n",__func__,__LINE__);
		return 0;
	}else{
		while(fgets(LineBuf,255,fp)){
			MSG("%s: Line%d - while loop!!\n",__func__,__LINE__);
			if((ptr = strstr(LineBuf,"PID :")) != NULL){
				MSG("%s: Line%d - parser PID :!!\n",__func__,__LINE__);
				MSG("%s: Line%d - ptr=%s!!\n",__func__,__LINE__,ptr);
				ptr += 6;
				MSG("%s: Line%d - ptr=%s!!\n",__func__,__LINE__,ptr);
				end = strchr(ptr,'\n');
				MSG("%s: Line%d - parser blank!!\n",__func__,__LINE__);
				*end = '\0';
				MSG("%s: Line%d - parser \0!!\n",__func__,__LINE__);
				strcpy(status_record[record_num].pid,ptr);
				MSG("%s: Line %d - status_record[%d].pid = %s\n",__func__,__LINE__,record_num,status_record[record_num].pid);
			}else if((ptr = strstr(LineBuf,"Check existing pieces :")) != NULL){
			    ptr += 24;
			    end = strchr(ptr,' ');
			    *end = '\0';
			    strcpy(status_record[record_num].piece_exist,ptr);
			    MSG("%s: Line %d - status_record[%d].piece_exist = %s\n",__func__,__LINE__,record_num,status_record[record_num].piece_exist);
			    end ++;
			    if((ptr = strstr(end,"checked / Total")) != NULL){
			    	ptr += 16;
			    	end = strchr(ptr,'\n');
			    	*end = '\0';
			    	strcpy(status_record[record_num].piece_total,ptr);
			    	MSG("%s: Line %d - status_record[%d].piece_total = %s\n",__func__,__LINE__,record_num,status_record[record_num].piece_total);
			    }
			    if(fgets(LineBuf,255,fp)){
			    	if((ptr = strstr(LineBuf,"Piece length :")) != NULL){
				    	ptr += 15;
				    	end = strstr(ptr,'\n');
				    	*end = '\0';
				    	strcpy(status_record[record_num].piece_len,ptr);
				    	MSG("%s: Line %d - status_record[%d].piece_len = %s\n",__func__,__LINE__,record_num,status_record[record_num].piece_len);
				    }
				}
				fclose(fp);
			    return 2;
		    }else if((ptr = strstr(LineBuf,"Port :")) != NULL){
		    	ptr += 7;
		    	end = strchr(ptr,'\n');
		    	*end = '\0';
		    	strcpy(status_record[record_num].listen_port,ptr);
		    	MSG("%s: Line %d - status_record[record_num].listen_port = %s\n",__func__,__LINE__,status_record[record_num].listen_port);
		    }else if((ptr = strstr(LineBuf,"Status     :")) != NULL){
				ptr += 13;
				end = strchr(ptr,'\n');
				*end = '\0';
				MSG("%s: Line%d - ptr = %s\n",__func__,__LINE__,ptr);
				if(strstr(ptr,"done")){
					fclose(fp);
					return 0;
				}else{
				    strcpy(status_record[record_num].status,ptr);
				}
			}else if((ptr = strstr(LineBuf,"Peer Count :")) != NULL){
				ptr += 13;
				end = strchr(ptr,'\n');
				*end = '\0';
				strcpy(status_record[record_num].peer,ptr);
				MSG("%s: Line %d - status_record[%d].peer = %s\n",__func__,__LINE__,record_num,status_record[record_num].peer);
			}else if((ptr = strstr(LineBuf,"NO# of pieces received :")) != NULL){
				ptr += 25;
				end = strchr(ptr,'\n');
				*end = '\0';
				strcpy(status_record[record_num].piece_receive,ptr);
				MSG("%s: Line %d - status_record[%d].piece_receive = %s\n",__func__,__LINE__,record_num,status_record[record_num].piece_receive);
		    }else if((ptr = strstr(LineBuf,"NO# of pieces of file :")) != NULL){
		    	ptr += 24;
		    	end = strchr(ptr,'\n');
		    	*end = '\0';
		    	strcpy(status_record[record_num].piece_file,ptr);
		    	MSG("%s: Line %d - status_record[%d].piece_file = %s\n",__func__,__LINE__,record_num,status_record[record_num].piece_file);
		    	if(strlen(status_record[record_num].piece_receive) && strlen(status_record[record_num].piece_file)){
		    		if(!strcmp(status_record[record_num].piece_file,status_record[record_num].piece_receive)){
		    			kill_finished_process(dir_name,file_name,status_record[record_num].pid);
		    			fclose(fp);
		    			return 3;
		    		}
		    	}
		    }else if((ptr = strstr(LineBuf,"NO# of pieces able to get from peer :")) != NULL){
		    	ptr += 38;
		    	end = strchr(ptr,'\n');
		    	*end = '\0';
		    	strcpy(status_record[record_num].piece_peer,ptr);
		    	MSG("%s: Line %d - status_record[%d].piece_peer = %s\n",__func__,__LINE__,record_num,status_record[record_num].piece_peer);
		    }else if((ptr = strstr(LineBuf,"Download Rate :")) != NULL){
		    	ptr += 16;
		    	end = strchr(ptr,'\n');
		    	*end = '\0';
		    	strcpy(status_record[record_num].download_bw,ptr);
		    	MSG("%s: Line %d - status_record[%d].download_bw = %s\n",__func__,__LINE__,record_num,status_record[record_num].download_bw);
		    }else if((ptr = strstr(LineBuf,"Upload Rate   :")) != NULL){
		    	ptr += 16;
		    	end = strchr(ptr,'\n');
		    	*end = '\0';
		    	strcpy(status_record[record_num].upload_bw,ptr);
		    	MSG("%s: Line %d - status_record[%d].upload_bw = %s\n",__func__,__LINE__,record_num,status_record[record_num].upload_bw);
		    }else if((ptr = strstr(LineBuf,"Tracker Refuse Count :")) != NULL){
		    	ptr += 23;
		    	end = strchr(ptr,'\n');
		    	*end = '\0';
		    	strcpy(status_record[record_num].tracker,ptr);
		    	MSG("%s: Line %d - status_record[%d].tracker = %s\n",__func__,__LINE__,record_num,status_record[record_num].tracker);
		    }else if((ptr = strstr(LineBuf,"Piece length :")) != NULL){
		    	ptr += 15;
		    	end = strchr(ptr,'\n');
		    	*end = '\0';
		    	strcpy(status_record[record_num].piece_len,ptr);
		    	MSG("%s: Line %d - status_record[%d].piece_len = %s\n",__func__,__LINE__,record_num,status_record[record_num].piece_len);
		    }
		}
		fclose(fp);
	}
	return 1;
}

//If some process is finished or killed, search the queue to excute
void check_torrent_status(FILE *out){
	
	FILE *fp, *fi;
	char *ptr, *end;
    int i=0, no_count=0, checked=0, differ =0, mark=0;
	char dir_filename[1024], LineBuf[1024], command[1050], compare[1024];
	CONFIGURATION_DATA excute[10];
	
	differ = atoi(CONFIG.TORRENT_USER) - status_num;
	if(differ > 0){
	    sprintf(dir_filename,"/mnt/%s/.%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
	    if((fp = fopen(dir_filename,"r")) == NULL)
            return;
        else{
		    while(fgets(LineBuf,1023,fp)){
		    	if((ptr = strstr(LineBuf,"TORRENT_RECORD")) != NULL){
		    		ptr = strchr(LineBuf,'=');
		    		ptr++;
		    		ptr = strtok(ptr,",");
		    		if(ptr != NULL){
		    		    strcpy(excute[no_count].filename,ptr);
		    		    strcpy(compare,excute[no_count].filename);
		    		    end = strrchr(compare,'/');
		    		    strcpy(compare,end+1);
		    		    MSG("%s: Line %d - compare = %s\n",__func__,__LINE__,compare);
		    		    checked = 0;
		    		    for(i=0;i<status_num;i++){
		    		    	if(strstr(status_record[i].filename,compare)){
		    		    		MSG("%s: Line %d - status_record[%d].filename = %s, compare = %s\n",__func__,__LINE__,i,status_record[i].filename,compare);
		    		    		checked = 1;
		    		    		break;
		    		    	}
		    		    }
		    		    if(checked == 1){
		    		    	excute[no_count].filename[0] = '\0';
		    		        continue;
		    		    }
	    	    		ptr = strtok(NULL,",");
	    	    		strcpy(excute[no_count].dirname,ptr);
	    	    		MSG("%s: Line %d - excute[%d].dirname = %s\n",__func__,__LINE__,no_count,excute[no_count].dirname);
	    	    		ptr = strtok(NULL,",");
	    	    		strcpy(excute[no_count].hours,ptr);
	    	    		MSG("%s: Line %d - excute[%d].hours = %s\n",__func__,__LINE__,no_count,excute[no_count].hours);
	    	    		ptr = strtok(NULL,",");
	    	    		strcpy(excute[no_count].port,ptr);
	    	    		MSG("%s: Line %d - excute[%d].port = %s\n",__func__,__LINE__,no_count,excute[no_count].port);
	    	    		ptr = strtok(NULL,",");
	    	    		strcpy(excute[no_count].max_peer,ptr);
	    	    		MSG("%s: Line %d - excute[%d].max_peer = %s\n",__func__,__LINE__,no_count,excute[no_count].max_peer);
	    	    		ptr = strtok(NULL,",");
	    	    		strcpy(excute[no_count].min_peer,ptr);
	    	    		MSG("%s: Line %d - excute[%d].min_peer = %s\n",__func__,__LINE__,no_count,excute[no_count].min_peer);
	    	    		ptr = strtok(NULL,",");
	    	    		strcpy(excute[no_count].max_bw,ptr);
	    	    		MSG("%s: Line %d - excute[%d].max_bw = %s\n",__func__,__LINE__,no_count,excute[no_count].max_bw);
	    	    		ptr = strtok(NULL,",");
	    	    		strcpy(excute[no_count].min_bw,ptr);
	    	    		MSG("%s: Line %d - excute[%d].min_bw = %s\n",__func__,__LINE__,no_count,excute[no_count].min_bw);
	    	    		differ--;
                        no_count++;
	    	    	}
	    	    }
	    	    if(differ == 0)
	    	        break;
	    	}
	        fclose(fp);
	    }
	    checked = 0;
    	if(no_count > 0){
    		for(i=0;i<no_count;i++){
    			sprintf(command,"/mnt/bt_clnt -s %s -e %s -p %s -M %s -m %s -Y %s -Z %s \"%s\" &",excute[i].dirname,excute[i].hours,excute[i].port,excute[i].max_peer,excute[i].min_peer,excute[i].max_bw,excute[i].min_bw,excute[i].filename);
    			MSG("%s: Line %d - command = %s\n",__func__,__LINE__,command);
                my_system(out,command);
                sprintf(command,"TZ=%s date \"+%%D %%T\" > /var/run/excute_time",CONFIG.TIME_ZONE);
                MSG("%s: Line %d - command = %s\n",__func__,__LINE__,command);
                my_system(out,command);
                if((fi = fopen("/var/run/excute_time","r")) != NULL){
        	        while(fgets(LineBuf,1023,fi))
        	            strncpy(excute[i].time,LineBuf,20);
        	        excute[i].time[20] = '\0';
                    fclose(fi);
                }
	    	}
            if((fp = fopen(dir_filename,"r")) == NULL)
                return;
            if((fi = fopen("/var/run/time_status","w+")) == NULL){
                return;
            }else{
	            while(fgets(LineBuf,1023,fp)){
	            	for(i=0;i<1023;i++){
			            if((LineBuf[i] == '\n') || (LineBuf[i] == '\r')){
				            LineBuf[i] = '\0';
				            i=1024;
				        }
				    }
	    	        checked = 0;
	    	        if((ptr = strstr(LineBuf,"TORRENT_RECORD")) != NULL){
	    		        ptr = strchr(LineBuf,'=');
	    		        ptr++;
	    		        for(i=0;i<no_count;i++){
	    			        if(strstr(ptr,excute[i].filename) && strstr(ptr,excute[i].dirname)){
	    			        	MSG("%s: Line %d - excute[%d].filename = %s, excute[%d].dirname = %s\n",__func__,__LINE__,i,excute[i].filename,i,excute[i].dirname);
	    			            checked = 1;
	    			            mark = i;
	    			            break;
	    			        }
	    		        }
	    		        if(checked == 1){
	    		        	end = strrchr(LineBuf,',');
	    		        	*end = '\0';
	    			        sprintf(command,"%s,%s",LineBuf,excute[mark].time);
	    			        MSG("%s: Line%d - command = %s\n",__func__,__LINE__,command);
	    			        fprintf(fi,"%s",command);
	    		        }else{
	    		            MSG("%s: Line%d - LineBuf = %s\n",__func__,__LINE__,LineBuf);
	    		            fprintf(fi,"%s\n",LineBuf);
	    		        }
	    	        }
	            }
	            fclose(fp);
	    	    fclose(fi);
	            sprintf(command,"/bin/mv /var/run/time_status /mnt/%s/.%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
	            MSG("%s: Line%d - command = %s\n",__func__,__LINE__,command);
	            my_system(out,command);
	        }
        }
	}
}

#if defined(CENTURY)

//CGI to show all information about download status
void Show_download_status(char *data, FILE *out){
	
	FILE *fp;
	int i, mark=0, status=0;
	char LineBuf[256];
	char directory[4096], file[128], num[3], condition[2];
	
	ARGUMENT args[]={
	    {"dir", directory, 4096},
	    {"file",file,128},
	    {"num",num,3},
	    {"status",condition,2},
        {NULL,NULL,0}
    };
    
    parseargs(data,args);
    mark = atoi(num);
    status = atoi(condition);
    MSG("%s: Line%d - dir = %s, file = %s, mark = %d, status = %d\n",__func__,__LINE__,directory,file,mark,status);
    /*for(i=0;i<MAX_QUEUE;i++){
    	if(strlen(status_record[i].dirname) && strlen(status_record[i].filename)){
    	    if(!strcmp(directory,status_record[i].dirname) && !strcmp(file,status_record[i].filename)){
    		    mark = i;
    		    break;
    		}
    	}
    }
    status = parser_status(directory,file,mark);
    MSG("%s: Line %d - mark = %d\n",__func__,__LINE__,mark);*/
    if((fp=fopen("/htdocs/torrent_head.htm","r")) == NULL){
	    return;
	}else{
	    while(fgets(LineBuf,255,fp) != NULL)
            fprintf(out,"%s",LineBuf);
        fclose(fp);
    }
    if(status == 1){            //Start downloading
    	fprintf(out,"<tr><td colspan=4><br></td></tr>\n");
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Status:</font></b></td>\n",get_column_bg());
	    if(strstr(status_record[mark].status,"-") || strstr(status_record[mark].status,"|") || strstr(status_record[mark].status,"/") || strstr(status_record[mark].status,"\\"))
	        fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">Downloading...</td>\n");
	    else
	        fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].status);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Listen Port:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].listen_port);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Peer Count:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].peer);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;No of piece received:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].piece_receive);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;No of piece of file:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].piece_file);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;No of piece from peer:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].piece_peer);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Download rate(Kbps):</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].download_bw);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Upload rate(Kbps):</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].upload_bw);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Tracker Refuse Count:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].tracker);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	}else if(status == 2){            //Under checking
		fprintf(out,"<tr><td colspan=4><br></td></tr>\n");
		fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Status:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">Checking...</td>\n");
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
		fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Existing pieces:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].piece_exist);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Total pieces:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].piece_total);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	}
    fprintf(out,"<tr><td align=center colspan=4 width=\"653\"><br><input type=\"button\" value=\"Back\" onclick=\"history.back()\"></td></tr>\n");
    fprintf(out,"</table><br>\n</body>\n</html>");
}

#elif defined(ZyXEL) || defined(PCI)

//CGI to show all information about download status
void Show_download_status(char *data, FILE *out){
	
	FILE *fp;
	int i, mark=0, status=0;
	char LineBuf[256];
	char directory[4096], file[128], num[3], condition[2];
	
	ARGUMENT args[]={
	    {"dir", directory, 4096},
	    {"file",file,128},
	    {"num",num,3},
	    {"status",condition,2},
        {NULL,NULL,0}
    };
    
    parseargs(data,args);
    mark = atoi(num);
    status = atoi(condition);
    MSG("%s: Line%d - dir = %s, file = %s, mark = %d, status = %d\n",__func__,__LINE__,directory,file,mark,status);
    /*for(i=0;i<MAX_QUEUE;i++){
    	if(strlen(status_record[i].dirname) && strlen(status_record[i].filename)){
    	    if(!strcmp(directory,status_record[i].dirname) && !strcmp(file,status_record[i].filename)){
    		    mark = i;
    		    break;
    		}
    	}
    }
    status = parser_status(directory,file,mark);
    MSG("%s: Line %d - mark = %d\n",__func__,__LINE__,mark);*/
    if((fp=fopen("/htdocs/torrent_head-1.htm","r")) == NULL){
	    return;
		}else{
		    while(fgets(LineBuf,255,fp) != NULL)
	            fprintf(out,"%s",LineBuf);
	        fclose(fp);
    }
    
    
  fprintf(out,"  <table width=\"552\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n");
fprintf(out,"<tr bgcolor=\"#FFFFFF\">\n");
 fprintf(out,"   <td width=\"002\">&nbsp;</td>\n");
  fprintf(out,"  <td width=\"550\">\n");
	fprintf(out,"<table width=\"550\" border=\"1\" cellpadding=\"0\" cellspacing=\"0\" bordercolor=\"#CCCCDD\">\n");

fprintf(out,"<tr bgcolor=#333399>\n");
	fprintf(out,"	<td height=\"30\" class=\"style2\" colspan=4>&nbsp;&nbsp;P2P</td> \n");
	fprintf(out,"</tr>\n");
    
    
    if(status == 1){            //Start downloading
    	//fprintf(out,"<tr><td colspan=4><br></td></tr>\n");
	    //fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    //fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Status:</font></b></td>\n",get_column_bg());
	    
	   fprintf(out," <tr>\n");
	fprintf(out,"	<th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;Status</th> \n");
	    
	    if(strstr(status_record[mark].status,"-") || strstr(status_record[mark].status,"|") || strstr(status_record[mark].status,"/") || strstr(status_record[mark].status,"\\")){
	        //fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">Downloading...</td>\n");
	        
	        fprintf(out,"	<td colspan=5>Downloading...</td></tr>\n");
	        
	    }    
	    else{
	        //fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].status);
	        
	        	fprintf(out,"<td colspan=5>%s</td></tr>\n",status_record[mark].status);
	        
	    }    
	      /*
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Listen Port:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].listen_port);	    	    
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Peer Count:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].peer);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;No of piece received:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].piece_receive);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;No of piece of file:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].piece_file);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;No of piece from peer:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].piece_peer);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Download rate(Kbps):</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].download_bw);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Upload rate(Kbps):</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].upload_bw);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Tracker Refuse Count:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].tracker);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	      */
	  
		  fprintf(out,"<tr><th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;Listen Port</th><td colspan=5>%s</td></tr>\n",status_record[mark].listen_port);	    
		  fprintf(out,"<tr><th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;Peer Count</th><td colspan=5>%s</td></tr>\n",status_record[mark].peer);		
			fprintf(out,"<tr><th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;No of piece received</th><td colspan=5>%s</td></tr>\n",status_record[mark].piece_receive);				
			fprintf(out,"<tr><th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;No of piece of file</th><td colspan=5>%s</td></tr>\n",status_record[mark].piece_file);		
			fprintf(out,"<tr><th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;No of piece from peer</th><td colspan=5>%s</td></tr>\n",status_record[mark].piece_peer);	
			fprintf(out,"<tr><th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;Download rate(Kbps)</th><td colspan=5>%s</td></tr>\n",status_record[mark].download_bw);
			fprintf(out,"<tr><th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;Upload rate(Kbps):</th><td colspan=5>%s</td></tr>\n",status_record[mark].upload_bw);	
			fprintf(out,"<tr><th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;Tracker Refuse Count</th><td colspan=5>%s</td></tr>\n",status_record[mark].tracker);
	
	
	
			}else if(status == 2){            //Under checking
				/*
				fprintf(out,"<tr><td colspan=4><br></td></tr>\n");
				fprintf(out,"<tr><td width=\"10%%\"></td>\n");
			    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Status:</font></b></td>\n",get_column_bg());
			    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">Checking...</td>\n");
			    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
				fprintf(out,"<tr><td width=\"10%%\"></td>\n");
			    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Existing pieces:</font></b></td>\n",get_column_bg());
			    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].piece_exist);
			    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
			    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
			    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Total pieces:</font></b></td>\n",get_column_bg());
			    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].piece_total);
			    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
			    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
			  */  
			   fprintf(out," <tr><th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;Status</th><td colspan=5>Checking...</td></tr>\n");
			   fprintf(out," <tr><th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;Existing pieces</th><td colspan=5>%s</td></tr>\n",status_record[mark].piece_exist);		
					fprintf(out,"<tr><th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;Total pieces</th><td colspan=5>%s</td></tr>\n",status_record[mark].piece_total);
			    
			}
	
	
	    //fprintf(out,"<tr><td align=center colspan=4 width=\"653\"><br><input type=\"button\" value=\"Back\" onclick=\"history.back()\"></td></tr>\n");
	    //fprintf(out,"</table><br>\n</body>\n</html>");
	    
	    fprintf(out,"<tr bgcolor=#333399><td height=\"30\" class=\"style2\" colspan=2>&nbsp;&nbsp;</td>\n");
			fprintf(out,"<td height=\"30\" colspan=2>&nbsp;&nbsp;<input type=\"button\" value=\"Back\" onclick=\"history.back()\">  \n");  			
			fprintf(out,"</td></tr></table></td></tr></table>		\n");
			fprintf(out,"<map name=\"Map\"><area shape=\"rect\" coords=\"010,1,240,23\" href=\"torrent_basic.htm\">\n");
			fprintf(out,"<area shape=\"rect\" coords=\"243,1,460,23\" href=\"torrent_config.cgi\"></map></body></html>\n");
    
}

#else

//CGI to show all information about download status
void Show_download_status(char *data, FILE *out){
	
	FILE *fp;
	int i, mark=0, status=0;
	char LineBuf[256];
	char directory[4096], file[128], num[3], condition[2];
	
	ARGUMENT args[]={
	    {"dir", directory, 4096},
	    {"file",file,128},
	    {"num",num,3},
	    {"status",condition,2},
        {NULL,NULL,0}
    };
    
    parseargs(data,args);
    mark = atoi(num);
    status = atoi(condition);
    MSG("%s: Line%d - dir = %s, file = %s, mark = %d, status = %d\n",__func__,__LINE__,directory,file,mark,status);
    /*for(i=0;i<MAX_QUEUE;i++){
    	if(strlen(status_record[i].dirname) && strlen(status_record[i].filename)){
    	    if(!strcmp(directory,status_record[i].dirname) && !strcmp(file,status_record[i].filename)){
    		    mark = i;
    		    break;
    		}
    	}
    }
    status = parser_status(directory,file,mark);
    MSG("%s: Line %d - mark = %d\n",__func__,__LINE__,mark);*/
    if((fp=fopen("/htdocs/torrent_head.htm","r")) == NULL){
	    return;
	}else{
	    while(fgets(LineBuf,255,fp) != NULL)
            fprintf(out,"%s",LineBuf);
        fclose(fp);
    }
    if(status == 1){            //Start downloading
    	fprintf(out,"<tr><td colspan=4><br></td></tr>\n");
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Status:</font></b></td>\n",get_column_bg());
	    if(strstr(status_record[mark].status,"-") || strstr(status_record[mark].status,"|") || strstr(status_record[mark].status,"/") || strstr(status_record[mark].status,"\\"))
	        fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">Downloading...</td>\n");
	    else
	        fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].status);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Listen Port:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].listen_port);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Peer Count:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].peer);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;No of piece received:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].piece_receive);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;No of piece of file:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].piece_file);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;No of piece from peer:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].piece_peer);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Download rate(Kbps):</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].download_bw);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Upload rate(Kbps):</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].upload_bw);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Tracker Refuse Count:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].tracker);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	}else if(status == 2){            //Under checking
		fprintf(out,"<tr><td colspan=4><br></td></tr>\n");
		fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Status:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">Checking...</td>\n");
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
		fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Existing pieces:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].piece_exist);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	    fprintf(out,"<td width=\"30%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Total pieces:</font></b></td>\n",get_column_bg());
	    fprintf(out,"<td width=\"47%%\" bgcolor=\"#FFFFFF\">%s</td>\n",status_record[mark].piece_total);
	    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
	    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
	}
    fprintf(out,"<tr><td align=center colspan=4 width=\"653\"><br><input type=\"button\" value=\"Back\" onclick=\"history.back()\"></td></tr>\n");
    fprintf(out,"</table><br>\n</body>\n</html>");
}

#endif
#if defined(CENTURY)
//To show the configuration of queue
void Show_queue_config(char *data, FILE *out){
	
	FILE *fr, *fw;
	char *ptr;
	char LineBuf[1024];
	char directory[256], file[256], command[50];
	CONFIGURATION_DATA queue_setup;
	
	ARGUMENT args[]={
	    {"dir", directory,256},
	    {"file",file,256},
        {NULL,NULL,0}
    };
    parseargs(data,args);
    MSG("%s: Line %d - directory = %s, file = %s\n",__func__,__LINE__,directory,file);
    sprintf(command,"/mnt/%s/.%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
	MSG("%s: Line %d - command = %s\n",__func__,__LINE__,command);
	if((fr = fopen(command,"r")) == NULL){
		return;
	}else{
	    while(fgets(LineBuf,1023,fr)){
	    	if((ptr = strstr(LineBuf,"TORRENT_RECORD")) != NULL){
	    		ptr = strchr(LineBuf,'=');
	    		ptr++;
	    		ptr = strtok(ptr,",");
	    		if(ptr != NULL){
	    		    strcpy(queue_setup.filename,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.dirname,ptr);
    	    		if(strcmp(directory,queue_setup.dirname) || strcmp(file,queue_setup.filename))
    	    		    continue;
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.hours,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.port,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.max_peer,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.min_peer,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.max_bw,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.min_bw,ptr);
    	    	}
    	    }
    	}
    	fclose(fr);
    }
    
	if((fw=fopen("/htdocs/torrent_head.htm","r")) == NULL){
        return;
	}else{
		while(fgets(LineBuf,1024,fw) != NULL)
	        fprintf(out,"%s",LineBuf);
	    fclose(fw);
	}
	fprintf(out,"<form name=\"p2p\" method=\"Get\" action=\"change_queue_config.cgi\" onsubmit=\"return check_form()\">\n");
	fprintf(out,"<input type=\"hidden\" name=\"dir\" value=\"%s\">\n",directory);
	fprintf(out,"<input type=\"hidden\" name=\"file\" value=\"%s\">\n",file);
	fprintf(out,"<tr><td colspan=4><br></td></tr>\n");
	fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Listen Port:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"port\" value=\"%s\"></td>\n",queue_setup.port);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Time to Leave:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"hours\" value=\"%s\">Hours</td>\n",queue_setup.hours);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Max Peers Count:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"max_peer\" value=\"%s\"></td>\n",queue_setup.max_peer);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Min Peers Count:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"min_peer\" value=\"%s\"></td>\n",queue_setup.min_peer);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Max Download Bandwidth:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"max_bw\" value=\"%s\">Kbps</td>\n",queue_setup.max_bw);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Max Upload Bandwidth:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"min_bw\" value=\"%s\">Kbps</td>\n",queue_setup.min_bw);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td align=center colspan=4 width=\"653\"><br><input type=\"submit\" value=\"Modify\">\n");
    fprintf(out,"<input type=\"button\" value=\"Back\" onclick=\"history.back()\"></td></tr>\n");
    fprintf(out,"</table><br>\n</body>\n</html>");
    fprintf(out,"<script language=\"JavaScript\">\n");
    fprintf(out,"function check_form(){\nif(check_port() == 0)\nreturn false;\nif(check_period() == 0)\nreturn false;\nif(check_peer() == 0)\nreturn false;\nif(check_bw() == 0)\nreturn false;\nreturn true;\n}\n");
    fprintf(out,"function check_port(){\nvar port = document.p2p.port;\nif(port.value < 0 || port.value > 65535){\nalert(\"Listen port must be between 0 and 65535, default is 2106 to 2706!!\");\nport.focus();\nreturn 0;\n}\nreturn 1;\n}\n");
    fprintf(out,"function check_period(){\nvar tmp, no_error = 1;\nvar period = document.p2p.hours.value;\nfor(var i=0;i<period.length;i++){\ntmp = period.charCodeAt(i);\nif(tmp == 46){\nalert(\"Please input an integer as period!!\");\nno_error = 0;\n");
    fprintf(out,"document.p2p.hours.focus();\nbreak;\n}\n}\nif(period < 0 || period > 72){\nalert(\"The value of time to leave must be less than 72 hours, default is 72!!\");\ndocument.p2p.hours.focus();\nno_error = 0;\n}\nreturn no_error;\n}\n");
    fprintf(out,"function check_peer(){\nvar no_error = 1;\nvar max = parseInt(document.p2p.max_peer.value,10);\nvar min = parseInt(document.p2p.min_peer.value,10);\nif(max < 1 || max > 10){\nalert(\"Max peer must be between 1 and 10!!\");document.p2p.max_peer.focus();\nno_error = 0;\n}\n");
    fprintf(out,"if(min < 1 || min > 10){\nalert(\"Min peer count must be between 1 and 10!!\");\ndocument.p2p.min_peer.focus();\nno_error = 0;\n}\nif(min > max){\nalert(\"Max peer count must be larger than min peer count!!\");\ndocument.p2p.max_peer.focus();\nno_error = 0;\n}\nreturn no_error;\n}\n");
    fprintf(out,"function check_bw(){\nvar no_error = 1;\nvar bw_max = parseInt(document.p2p.max_bw.value,10);\nvar bw_min = parseInt(document.p2p.min_bw.value,10);\n");
    fprintf(out,"if(bw_max < 1 || bw_max > 2097152){\nalert(\"Max download bandwidth must be between 1 and 2097152 Kbps!!\");\ndocument.p2p.max_bw.focus();\nno_error = 0;\n}\n");
    fprintf(out,"if(bw_min < 1 || bw_min > 2097152){\nalert(\"Max upload bandwidth must be between 1 and 2097152 Kbps!!\");\ndocument.p2p.min_bw.focus();\nno_error = 0;\n}\nreturn no_error;\n}\n");
    fprintf(out,"</script>\n");
}

#elif defined(ZyXEL) || defined(PCI)

//To show the configuration of queue
void Show_queue_config(char *data, FILE *out){
	
	FILE *fr, *fw;
	char *ptr;
	char LineBuf[1024];
	char directory[256], file[256], command[50];
	CONFIGURATION_DATA queue_setup;
	
	ARGUMENT args[]={
	    {"dir", directory,256},
	    {"file",file,256},
        {NULL,NULL,0}
    };
    parseargs(data,args);
    MSG("%s: Line %d - directory = %s, file = %s\n",__func__,__LINE__,directory,file);
    sprintf(command,"/mnt/%s/.%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
	MSG("%s: Line %d - command = %s\n",__func__,__LINE__,command);
	if((fr = fopen(command,"r")) == NULL){
		return;
	}else{
	    while(fgets(LineBuf,1023,fr)){
	    	if((ptr = strstr(LineBuf,"TORRENT_RECORD")) != NULL){
	    		ptr = strchr(LineBuf,'=');
	    		ptr++;
	    		ptr = strtok(ptr,",");
	    		if(ptr != NULL){
	    		    strcpy(queue_setup.filename,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.dirname,ptr);
    	    		if(strcmp(directory,queue_setup.dirname) || strcmp(file,queue_setup.filename))
    	    		    continue;
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.hours,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.port,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.max_peer,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.min_peer,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.max_bw,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.min_bw,ptr);
    	    	}
    	    }
    	}
    	fclose(fr);
    }
    
	if((fw=fopen("/htdocs/torrent_head-1.htm","r")) == NULL){
        return;
	}else{
		while(fgets(LineBuf,1024,fw) != NULL)
	        fprintf(out,"%s",LineBuf);
	    fclose(fw);
	}
	/*
	fprintf(out,"<form name=\"p2p\" method=\"Get\" action=\"change_queue_config.cgi\" onsubmit=\"return check_form()\">\n");
	fprintf(out,"<input type=\"hidden\" name=\"dir\" value=\"%s\">\n",directory);
	fprintf(out,"<input type=\"hidden\" name=\"file\" value=\"%s\">\n",file);
	fprintf(out,"<tr><td colspan=4><br></td></tr>\n");
	fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Listen Port:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"port\" value=\"%s\"></td>\n",queue_setup.port);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Time to Leave:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"hours\" value=\"%s\">Hours</td>\n",queue_setup.hours);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Max Peers Count:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"max_peer\" value=\"%s\"></td>\n",queue_setup.max_peer);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Min Peers Count:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"min_peer\" value=\"%s\"></td>\n",queue_setup.min_peer);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Max Download Bandwidth:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"max_bw\" value=\"%s\">Kbps</td>\n",queue_setup.max_bw);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Max Upload Bandwidth:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"min_bw\" value=\"%s\">Kbps</td>\n",queue_setup.min_bw);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td align=center colspan=4 width=\"653\"><br><input type=\"submit\" value=\"Modify\">\n");
    fprintf(out,"<input type=\"button\" value=\"Back\" onclick=\"history.back()\"></td></tr>\n");
    fprintf(out,"</table><br>\n</body>\n</html>");
    fprintf(out,"<script language=\"JavaScript\">\n");
    fprintf(out,"function check_form(){\nif(check_port() == 0)\nreturn false;\nif(check_period() == 0)\nreturn false;\nif(check_peer() == 0)\nreturn false;\nif(check_bw() == 0)\nreturn false;\nreturn true;\n}\n");
    fprintf(out,"function check_port(){\nvar port = document.p2p.port;\nif(port.value < 0 || port.value > 65535){\nalert(\"Listen port must be between 0 and 65535, default is 2106 to 2706!!\");\nport.focus();\nreturn 0;\n}\nreturn 1;\n}\n");
    fprintf(out,"function check_period(){\nvar tmp, no_error = 1;\nvar period = document.p2p.hours.value;\nfor(var i=0;i<period.length;i++){\ntmp = period.charCodeAt(i);\nif(tmp == 46){\nalert(\"Please input an integer as period!!\");\nno_error = 0;\n");
    fprintf(out,"document.p2p.hours.focus();\nbreak;\n}\n}\nif(period < 0 || period > 72){\nalert(\"The value of time to leave must be less than 72 hours, default is 72!!\");\ndocument.p2p.hours.focus();\nno_error = 0;\n}\nreturn no_error;\n}\n");
    fprintf(out,"function check_peer(){\nvar no_error = 1;\nvar max = parseInt(document.p2p.max_peer.value,10);\nvar min = parseInt(document.p2p.min_peer.value,10);\nif(max < 1 || max > 10){\nalert(\"Max peer must be between 1 and 10!!\");document.p2p.max_peer.focus();\nno_error = 0;\n}\n");
    fprintf(out,"if(min < 1 || min > 10){\nalert(\"Min peer count must be between 1 and 10!!\");\ndocument.p2p.min_peer.focus();\nno_error = 0;\n}\nif(min > max){\nalert(\"Max peer count must be larger than min peer count!!\");\ndocument.p2p.max_peer.focus();\nno_error = 0;\n}\nreturn no_error;\n}\n");
    fprintf(out,"function check_bw(){\nvar no_error = 1;\nvar bw_max = parseInt(document.p2p.max_bw.value,10);\nvar bw_min = parseInt(document.p2p.min_bw.value,10);\n");
    fprintf(out,"if(bw_max < 1 || bw_max > 2097152){\nalert(\"Max download bandwidth must be between 1 and 2097152 Kbps!!\");\ndocument.p2p.max_bw.focus();\nno_error = 0;\n}\n");
    fprintf(out,"if(bw_min < 1 || bw_min > 2097152){\nalert(\"Max upload bandwidth must be between 1 and 2097152 Kbps!!\");\ndocument.p2p.min_bw.focus();\nno_error = 0;\n}\nreturn no_error;\n}\n");
    fprintf(out,"</script>\n");  
  */  
  
  
  fprintf(out,"  <form name=\"p2p\" method=\"Get\" action=\"change_queue_config.cgi\" onsubmit=\"return check_form()\">\n");
fprintf(out,"<input type=\"hidden\" name=\"dir\" value=\"%s\">\n",directory);
fprintf(out,"<input type=\"hidden\" name=\"file\" value=\"%s\">\n",file);

fprintf(out,"<table width=\"552\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n");
fprintf(out,"<tr bgcolor=\"#FFFFFF\">\n");
 fprintf(out,"   <td width=\"002\">&nbsp;</td>\n");
  fprintf(out,"  <td width=\"550\">\n");
	fprintf(out,"<table width=\"550\" border=\"1\" cellpadding=\"0\" cellspacing=\"0\" bordercolor=\"#CCCCDD\">\n");

	fprintf(out,"<tr bgcolor=#333399>\n");
	fprintf(out,"	<td height=\"30\" class=\"style2\" colspan=4>&nbsp;&nbsp;P2P</td> \n");
	fprintf(out,"</tr>\n");

	fprintf(out,"<tr>\n");
	fprintf(out,"	<th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;Listen Port</th> \n");
	fprintf(out,"	<td colspan=5>\n");
  fprintf(out,"          <input type=\"text\" name=\"port\" value=\"%s\">\n",queue_setup.port);
	fprintf(out,"	</td>\n");
	fprintf(out,"</tr>		\n");
	
	fprintf(out,"<tr>\n");
	fprintf(out,"	<th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;Time to Leave</th> \n");
	fprintf(out,"	<td colspan=5>\n");
  fprintf(out,"          <input type=\"text\" name=\"hours\" value=\"%s\">Hours\n",queue_setup.hours);
	fprintf(out,"	</td>\n");
fprintf(out,"	</tr>\n");
	
	fprintf(out,"<tr>\n");
fprintf(out,"		<th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;Max Peers Count</th>\n");
	fprintf(out,"	<td colspan=5>\n");
  fprintf(out,"          <input type=\"text\" name=\"max_peer\" value=\"%s\">\n",queue_setup.max_peer);
	fprintf(out,"	</td>\n");
	fprintf(out,"</tr>\n");
	
	fprintf(out,"<tr>\n");
	fprintf(out,"	<th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;Min Peers Count</th>\n");
fprintf(out,"		<td colspan=5>\n");
  fprintf(out,"          <input type=\"text\" name=\"min_peer\" value=\"%s\">\n",queue_setup.min_peer);
	fprintf(out,"	</td>\n");
	fprintf(out,"</tr>\n");
	
	fprintf(out,"<tr>\n");
	fprintf(out,"	<th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;Max Download Bandwidth</th>\n");
	fprintf(out,"	<td colspan=5>\n");
  fprintf(out,"          <input type=\"text\" name=\"max_bw\" value=\"%s\">Kbps\n",queue_setup.max_bw);
	fprintf(out,"	</td>	\n");
fprintf(out,"	</tr>\n");
	
	fprintf(out,"<tr>\n");
	fprintf(out,"	<th bgcolor=#DDDDDD align=left>&nbsp;&nbsp;Max Upload Bandwidth</th>\n");
	fprintf(out,"	<td colspan=5>\n");
  fprintf(out,"          <input type=\"text\" name=\"min_bw\" value=\"%s\">Kbps\n",queue_setup.min_bw);
	fprintf(out,"	</td>\n");
	fprintf(out,"</tr>\n");
      
 
	fprintf(out,"<tr bgcolor=#FFFFFF>\n");
	fprintf(out,"	<th width=180 bgcolor=#FFFFFF align=\"left\">&nbsp;&nbsp;Note</th>\n");
	fprintf(out,"	<td colspan=5 class=\"style4\">\n");
	fprintf(out,"		&nbsp;&nbsp;1. The value of time to leave is an integer less than <br>&nbsp;&nbsp;72 hours.\n");
		fprintf(out,"	<br>&nbsp;&nbsp;2. Max and min peers count is between 1 and 10.\n");
		fprintf(out,"	<br>&nbsp;&nbsp;3. Max bandwidth for download and upload is <br>&nbsp;&nbsp;between 1 and 2097152 Kbps.\n");
	fprintf(out,"	</td>\n");
	fprintf(out,"</tr>\n");
	fprintf(out,"<tr bgcolor=#333399>\n");
	fprintf(out,"	<td height=\"30\" class=\"style2\" colspan=2>&nbsp;&nbsp;</td>\n");
	fprintf(out,"	<td height=\"30\" colspan=2>&nbsp;&nbsp;\n");
  fprintf(out,"  			<input type=\"submit\" value=\"Modify\">\n");
	fprintf(out,"		<input type=\"button\" value=\"Back\" onclick=\"history.back()\">\n");
  fprintf(out,"  			<!--<input type=\"button\" value=\"Jumbo\" onClick=\"parent.rightFrame.location.href='Show_Jumboframe.cgi'\">-->\n");
	fprintf(out,"	</td>\n");
	fprintf(out,"	</form>\n");
	fprintf(out,"</tr>\n");
	fprintf(out,"</table>\n");
  fprintf(out,"  </td>\n");
	fprintf(out,"	</tr>\n");
	fprintf(out,"	</table>\n");
		
	fprintf(out,"	<map name=\"Map\"> \n");
	fprintf(out,"		<area shape=\"rect\" coords=\"010,1,240,23\" href=\"torrent_basic.htm\">\n");
	fprintf(out,"<area shape=\"rect\" coords=\"243,1,460,23\" href=\"torrent_config.cgi\">\n");
	fprintf(out,"	</map>\n");
		
	fprintf(out,"	</body>\n");
	fprintf(out,"	</html>\n");
	fprintf(out,"	<script language=\"JavaScript\">\n");
	fprintf(out,"	function check_form(){\n");
	fprintf(out,"	if(check_port() == 0)\n");
	fprintf(out,"	return false;\n");
	fprintf(out,"	if(check_period() == 0)\n");
		fprintf(out,"return false;\n");
	fprintf(out,"	if(check_peer() == 0)\n");
		fprintf(out,"return false;\n");
	fprintf(out,"	if(check_bw() == 0)\n");
	fprintf(out,"	return false;\n");
	fprintf(out,"	return true;\n");
	fprintf(out,"	}\n");
	fprintf(out,"	function check_port(){\n");
	fprintf(out,"	var port = document.p2p.port;\n");
	fprintf(out,"	if(port.value < 0 || port.value > 65535){\n");
	fprintf(out,"	alert(\" Listen port must be between 0 and 65535, default is 2106 to 2706!!\");\n");
	fprintf(out,"	port.focus();\n");
	fprintf(out,"	return 0;\n");
	fprintf(out,"	}\n");
	fprintf(out,"	return 1;\n");
	fprintf(out,"	}\n");
	fprintf(out,"	function check_period(){\n");
	fprintf(out,"	var period = document.p2p.hours.value;\n");
	fprintf(out,"	for(var i=0;i<period.length;i++){\n");
	fprintf(out,"	tmp = period.charCodeAt(i);\n");
	fprintf(out,"	if(tmp == 46){\n");
	fprintf(out,"	alert(\"Please input a interge as period!!\");\n");
	fprintf(out,"	no_error = 0;\n");
		fprintf(out,"document.p2p.hours.focus();\n");
	fprintf(out,"	break;\n");
	fprintf(out,"	}\n");
	fprintf(out,"	}\n");
	fprintf(out,"	if(period < 0 || period > 72){\n");
	fprintf(out,"	alert(\"Waiting period must be under 72 hours, default is 72!!\");\n");
fprintf(out,"		document.p2p.hours.focus();\n");
	fprintf(out,"	no_error = 0;\n");
	fprintf(out,"	}\n");
	fprintf(out,"	return no_error;\n");
	fprintf(out,"	}\n");
	fprintf(out,"	function check_peer(){\n");
	fprintf(out,"	var no_error = 1;\n");
	fprintf(out,"	var max = parseInt(document.p2p.max_peer.value,10);\n");
	fprintf(out,"	var min = parseInt(document.p2p.min_peer.value,10);\n");
	fprintf(out,"	if(max < 1 || max > 10){\n");
	fprintf(out,"	alert(\"Max peer must be between 1 and 10!!\");document.p2p.max_peer.focus();\n");
	fprintf(out,"	no_error = 0;\n");
		fprintf(out,"}\n");
	fprintf(out,"	if(min < 1 || min > 10){\n");
	fprintf(out,"	alert(\"Min peer must be between 1 and 10!!\");\n");
	fprintf(out,"	document.p2p.min_peer.focus();\n");
	fprintf(out,"	no_error = 0;\n");
	fprintf(out,"	}\n");
	fprintf(out,"	if(min > max){\n");
	fprintf(out,"	alert(\"Max peer must be larger than min peer!!\");\n");
	fprintf(out,"	document.p2p.max_peer.focus();\n");
	fprintf(out,"	no_error = 0;\n");
	fprintf(out,"	}\n");
	fprintf(out,"	return no_error;\n");
	fprintf(out,"	}\n");
	fprintf(out,"	function check_bw(){\n");
	fprintf(out,"	var no_error = 1;\n");
	fprintf(out,"	var bw_max = parseInt(document.p2p.max_bw.value,10);\n");
	fprintf(out,"	var bw_min = parseInt(document.p2p.min_bw.value,10);\n");
	fprintf(out,"	if(bw_max < 1 || bw_max > 2097152){\n");
	fprintf(out,"	alert(\"Max bandwidth must be between 1 and 2097152!!\");\n");
	fprintf(out,"	document.p2p.max_bw.focus();\n");
	fprintf(out,"	no_error = 0;\n");
	fprintf(out,"	}\n");
	fprintf(out,"	if(bw_min < 1 || bw_min > 2097152){\n");
	fprintf(out,"	alert(\"Min bandwidth must be between 1 and 2097152!!\");\n");
		fprintf(out,"document.p2p.min_bw.focus();\n");
	fprintf(out,"	no_error = 0;\n");
	fprintf(out,"	}\n");
	fprintf(out,"	return no_error;\n");
		fprintf(out,"}\n");
	fprintf(out,"	</script>\n");
    
}
#else

//To show the configuration of queue
void Show_queue_config(char *data, FILE *out){
	
	FILE *fr, *fw;
	char *ptr;
	char LineBuf[1024];
	char directory[256], file[256], command[50];
	CONFIGURATION_DATA queue_setup;
	
	ARGUMENT args[]={
	    {"dir", directory,256},
	    {"file",file,256},
        {NULL,NULL,0}
    };
    parseargs(data,args);
    MSG("%s: Line %d - directory = %s, file = %s\n",__func__,__LINE__,directory,file);
    sprintf(command,"/mnt/%s/.%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
	MSG("%s: Line %d - command = %s\n",__func__,__LINE__,command);
	if((fr = fopen(command,"r")) == NULL){
		return;
	}else{
	    while(fgets(LineBuf,1023,fr)){
	    	if((ptr = strstr(LineBuf,"TORRENT_RECORD")) != NULL){
	    		ptr = strchr(LineBuf,'=');
	    		ptr++;
	    		ptr = strtok(ptr,",");
	    		if(ptr != NULL){
	    		    strcpy(queue_setup.filename,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.dirname,ptr);
    	    		if(strcmp(directory,queue_setup.dirname) || strcmp(file,queue_setup.filename))
    	    		    continue;
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.hours,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.port,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.max_peer,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.min_peer,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.max_bw,ptr);
    	    		ptr = strtok(NULL,",");
    	    		strcpy(queue_setup.min_bw,ptr);
    	    	}
    	    }
    	}
    	fclose(fr);
    }
    
	if((fw=fopen("/htdocs/torrent_head.htm","r")) == NULL){
        return;
	}else{
		while(fgets(LineBuf,1024,fw) != NULL)
	        fprintf(out,"%s",LineBuf);
	    fclose(fw);
	}
	fprintf(out,"<form name=\"p2p\" method=\"Get\" action=\"change_queue_config.cgi\" onsubmit=\"return check_form()\">\n");
	fprintf(out,"<input type=\"hidden\" name=\"dir\" value=\"%s\">\n",directory);
	fprintf(out,"<input type=\"hidden\" name=\"file\" value=\"%s\">\n",file);
	fprintf(out,"<tr><td colspan=4><br></td></tr>\n");
	fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Listen Port:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"port\" value=\"%s\"></td>\n",queue_setup.port);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Time to Leave:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"hours\" value=\"%s\">Hours</td>\n",queue_setup.hours);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Max Peers Count:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"max_peer\" value=\"%s\"></td>\n",queue_setup.max_peer);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Min Peers Count:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"min_peer\" value=\"%s\"></td>\n",queue_setup.min_peer);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Max Download Bandwidth:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"max_bw\" value=\"%s\">Kbps</td>\n",queue_setup.max_bw);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td width=\"10%%\"></td>\n");
    fprintf(out,"<td width=\"35%%\" bgcolor=\"#%s\"><b><font size=\"3\">&nbsp;Max Upload Bandwidth:</font></b></td>\n",get_column_bg());
    fprintf(out,"<td width=\"42%%\" bgcolor=\"#FFFFFF\"><input type=\"text\" name=\"min_bw\" value=\"%s\">Kbps</td>\n",queue_setup.min_bw);
    fprintf(out,"<td width=\"13%%\" bgcolor=\"#%s\"></td></tr>\n",get_overall_bg());
    fprintf(out,"<tr><td align=center colspan=4 width=\"653\"><br><input type=\"submit\" value=\"Modify\">\n");
    fprintf(out,"<input type=\"button\" value=\"Back\" onclick=\"history.back()\"></td></tr>\n");
    fprintf(out,"</table><br>\n</body>\n</html>");
    fprintf(out,"<script language=\"JavaScript\">\n");
    fprintf(out,"function check_form(){\nif(check_port() == 0)\nreturn false;\nif(check_period() == 0)\nreturn false;\nif(check_peer() == 0)\nreturn false;\nif(check_bw() == 0)\nreturn false;\nreturn true;\n}\n");
    fprintf(out,"function check_port(){\nvar port = document.p2p.port;\nif(port.value < 0 || port.value > 65535){\nalert(\"Listen port must be between 0 and 65535, default is 2106 to 2706!!\");\nport.focus();\nreturn 0;\n}\nreturn 1;\n}\n");
    fprintf(out,"function check_period(){\nvar tmp, no_error = 1;\nvar period = document.p2p.hours.value;\nfor(var i=0;i<period.length;i++){\ntmp = period.charCodeAt(i);\nif(tmp == 46){\nalert(\"Please input an integer as period!!\");\nno_error = 0;\n");
    fprintf(out,"document.p2p.hours.focus();\nbreak;\n}\n}\nif(period < 0 || period > 72){\nalert(\"The value of time to leave must be less than 72 hours, default is 72!!\");\ndocument.p2p.hours.focus();\nno_error = 0;\n}\nreturn no_error;\n}\n");
    fprintf(out,"function check_peer(){\nvar no_error = 1;\nvar max = parseInt(document.p2p.max_peer.value,10);\nvar min = parseInt(document.p2p.min_peer.value,10);\nif(max < 1 || max > 10){\nalert(\"Max peer must be between 1 and 10!!\");document.p2p.max_peer.focus();\nno_error = 0;\n}\n");
    fprintf(out,"if(min < 1 || min > 10){\nalert(\"Min peer count must be between 1 and 10!!\");\ndocument.p2p.min_peer.focus();\nno_error = 0;\n}\nif(min > max){\nalert(\"Max peer count must be larger than min peer count!!\");\ndocument.p2p.max_peer.focus();\nno_error = 0;\n}\nreturn no_error;\n}\n");
    fprintf(out,"function check_bw(){\nvar no_error = 1;\nvar bw_max = parseInt(document.p2p.max_bw.value,10);\nvar bw_min = parseInt(document.p2p.min_bw.value,10);\n");
    fprintf(out,"if(bw_max < 1 || bw_max > 2097152){\nalert(\"Max download bandwidth must be between 1 and 2097152 Kbps!!\");\ndocument.p2p.max_bw.focus();\nno_error = 0;\n}\n");
    fprintf(out,"if(bw_min < 1 || bw_min > 2097152){\nalert(\"Max upload bandwidth must be between 1 and 2097152 Kbps!!\");\ndocument.p2p.min_bw.focus();\nno_error = 0;\n}\nreturn no_error;\n}\n");
    fprintf(out,"</script>\n");
}

#endif
//CGI to change the original queue configuration
void change_queue_config(char *data, FILE *out){
	
	FILE *fr, *fw;
	char *ptr, *end;
	CONFIGURATION_DATA new_config;
	char command[100], LineBuf[1024];
	
	ARGUMENT args[]={
	    {"file",new_config.filename,4096},
	    {"dir",new_config.dirname,4096},
	    {"port",new_config.port,6},
	    {"hours",new_config.hours,3},
	    {"max_peer",new_config.max_peer,3},
	    {"min_peer",new_config.min_peer,3},
	    {"max_bw",new_config.max_bw,8},
	    {"min_bw",new_config.min_bw,8},
        {NULL,NULL,0}
    };
    parseargs(data,args);
    MSG("%s: Line %d - %s,%s,%s,%s,%s,%s,%s,%s\n",__func__,__LINE__,new_config.filename,new_config.dirname,new_config.hours,new_config.port,new_config.max_peer,new_config.min_peer,new_config.max_bw,new_config.min_bw);
    sprintf(command,"/mnt/%s/.%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
	MSG("%s: Line %d - command = %s\n",__func__,__LINE__,command);
	if((fr = fopen(command,"r")) == NULL || (fw = fopen("/var/run/change_status","w+")) == NULL){
		return;
	}else{
	    while(fgets(LineBuf,1023,fr)){
	    	MSG("%s: Line %d - LineBuf = %s\n",__func__,__LINE__,LineBuf);
	    	if((ptr = strstr(LineBuf,"TORRENT_RECORD")) != NULL){
	    	    if(strstr(LineBuf,new_config.filename) && strstr(LineBuf,new_config.dirname)){
	    	    	end = strchr(ptr,'=');
	    		    *end = '\0';
	    	    	MSG("%s: Line %d - %s=%s,%s,%s,%s,%s,%s,%s,%s\n",ptr,new_config.filename,new_config.dirname,new_config.hours,new_config.port,new_config.max_peer,new_config.min_peer,new_config.max_bw,new_config.min_bw);
	    	    	fprintf(fw,"%s=%s,%s,%s,%s,%s,%s,%s,%s,\n",ptr,new_config.filename,new_config.dirname,new_config.hours,new_config.port,new_config.max_peer,new_config.min_peer,new_config.max_bw,new_config.min_bw);
	    	    }else{
	    	        fputs(LineBuf,fw);
	    	    }
	    	}
	    }
	    fclose(fr);
	    fclose(fw);
	}
    sprintf(command,"/bin/mv /var/run/change_status /mnt/%s/.%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
    system(command);
    system("/bin/rm -f /var/run/change_status");
    fprintf(out,"<script language=\"JavaScript\">\n");
    fprintf(out,"location.replace('http://%s:%s/torrent_config.cgi');\n",CONFIG.IP,CONFIG.ADMIN_PORT);
    fprintf(out,"</script>\n");
}

//To show xxx.torrent in the specific folder
void list_torrent_file(char *data, FILE *out){
	
	FILE *fp;
	char LineBuf[256], directory[4096], kind[7];
	
	ARGUMENT args[]={
	    {"directory",directory,4096},
	    {"kind",kind,7},
        {NULL,NULL,0}
    };
    MSG("%s: Line%d - torrent data = %s\n",__func__,__LINE__,data);
    parseargs(data,args);
    MSG("%s: Line%d - directory = %s, kind = %s\n",__func__,__LINE__,directory,kind);
	
	if((fp=fopen("/htdocs/torrent_refresh.htm","r")) == NULL){
	    return;
	}else{
	    while(fgets(LineBuf,255,fp) != NULL)
            fprintf(out,"%s",LineBuf);
        fclose(fp);
    }
    memset(file_directory,0,4096);
    show_file_and_folder(out,directory,kind,0);
    chdir("/htdocs");
}

//To show the folders under specific folder
void show_download_folder(char *data, FILE *out){

  FILE *fp;
	char LineBuf[256], directory[4096], kind[7];
	
	ARGUMENT args[]={
	    {"directory", directory, 4096},
	    {"kind",kind,7},
        {NULL,NULL,0}
    };
    //printf("folder data = %s\n",data);
    parseargs(data,args);
    //printf("folder directory = %s\n",directory);
	
	if((fp=fopen("/htdocs/torrent_head.htm","r")) == NULL){
	    return;
	}else{
	    while(fgets(LineBuf,255,fp) != NULL)
            fprintf(out,"%s",LineBuf);
        fclose(fp);
    }
    memset(file_directory,0,4096);
    show_file_and_folder(out,directory,kind,0);
    chdir("/htdocs");
}

#if defined(CENTURY)

//Note: before calling this function, reset directory first
void show_file_and_folder(FILE *out, char *dir, char *sort, int depth){
	
	DIR *dp;
	char *ptr, *end;
	int i, j, count = 0;
	struct dirent *entry;
	struct stat statbuf;
	char check_dir[4096], compare[1024], compare1[1024];
	
	if((dp = opendir(dir)) == NULL){
		fprintf(stderr,"cannot open directory: %s\n",dir);
		return;
	}
	MSG("%s: Line %d - sort = %s\n",__func__,__LINE__,sort);
	if(!strcmp(sort,"file")){
#ifdef CENTURY
       fprintf(out,"<table width=\"550\" border=\"0\" align=\"center\">\n");
#else
		fprintf(out,"<table width=\"80%\" border=\"0\" align=\"center\">\n");
#endif
	    fprintf(out,"<tr><td><H3><font color=\"#%s\">Please select the BitTorrent file.</font></H3></td></tr></table>\n",get_font_color());
	    fprintf(out,"<form name=\"p2p\" method=\"Get\" action=\"set_torrent_download.cgi\" onsubmit=\"return validate();\">\n");
	}else{
#ifdef CENTURY
        fprintf(out,"<table width=\"550\" border=\"0\" align=\"center\">\n");
#else
	    fprintf(out,"<table width=\"80%%\" border=\"0\" align=\"center\">\n");
#endif
	    fprintf(out,"<tr><td><H3><font color=\"#%s\">Please select the download folder.</font></H3></td></tr></table>\n",get_font_color());
	    fprintf(out,"<form name=\"p2p\" method=\"Get\" action=\"set_folder_download.cgi\">\n");
	}
#ifdef CENTURY
    fprintf(out,"<table width=\"500\" border=\"0\" align=\"center\">\n");
#else
	fprintf(out,"<table width=\"75%%\" border=\"0\" align=\"center\">\n");
#endif
	fprintf(out,"<tr><td><img src=\"images/thread_new.gif\" border=\"0\"></td><td><b><font color=\"#%s\">Index of %s</font></b></td>\n\n",get_font_color(),dir+4);
	strcat(file_directory,dir);
    chdir(dir);
	while((entry = readdir(dp)) != NULL){
		lstat(entry->d_name,&statbuf);
		if(S_ISDIR(statbuf.st_mode)){        //Part to Show Folders
			if(strcmp(".",entry->d_name) == 0 || strcmp("..",entry->d_name) == 0)
			    continue;
			if(strcmp(entry->d_name,"lost+found") == 0)
			    continue;
			strcpy(check_dir,dir);
			strcat(check_dir,"/");
			strcat(check_dir,entry->d_name);
			if(!opendir(check_dir))
			    continue;
		    if(!strcmp(sort,"folder")){
		        fprintf(out,"<tr><td width=\"5%\"><img src=\"images/navbits_finallink.gif\" border=\"0\"></td>\n");
		        fprintf(out,"<td><p><input type=\"radio\" name=\"download_folder\" value=\"%s/%s\"><a href=\"show_download_folder.cgi?directory=%s/%s&kind=folder\"><font color=\"#%s\">%s</font></a></p></tr></td>\n",dir,entry->d_name,dir,entry->d_name,get_font_color(),entry->d_name);
		    }else{
		        fprintf(out,"<tr><td width=\"5%\"><img src=\"images/navbits_finallink.gif\" border=\"0\"></td>\n");
		        fprintf(out,"<td><p><a href=\"list_torrent_file.cgi?directory=%s/%s&kind=file\"><font color=\"#%s\">%s</font></a></p></tr></td>\n",dir,entry->d_name,get_font_color(),entry->d_name);
		    }
		    count ++;
		}else{                               //Part to Show Files
            if(!strcmp(sort,"file") && strstr(entry->d_name,".torrent") && !strstr(entry->d_name,".status")){
            	MSG("%s\n",entry->d_name);
            	for(i=0;i<strlen(entry->d_name);i++)
            	    MSG("%02x ",entry->d_name[i]);
            	MSG("\n");
            	fprintf(out,"<tr><td width=\"5%\"><img src=\"images/file.gif\" border=\"0\"></td>\n");		    
		        fprintf(out,"<td><input type=\"checkbox\" name=\"torrent_file\" value=\"%s/%s\" onclick=\"check_dup(this)\"><font color=\"#%s\">%s</font></tr></td>\n",file_directory,entry->d_name,get_font_color(),entry->d_name);		        
		    }
		    count ++;
		}
	}
	if(count == 0)
	    fprintf(out,"<tr><td><font color=\"#%s\">There are not any folders and files existing in this directory!!</font></td></tr>\n",get_font_color());
	fprintf(out,"</table>\n");
	//To print all the buttons
#ifdef CENTURY
	fprintf(out,"<table border=\"0\" width=\"500\" height=\"50\" align=\"center\">\n");
#else
    fprintf(out,"<table><tr>\n");
#endif
    fprintf(out,"<td align=center><br>\n");
    fprintf(out,"<input type=\"submit\" name=\"set_torrent\" value=\"Next\">&nbsp;\n");
    fprintf(out,"<input type=\"reset\" name=\"Reset\" value=\"Reset\">\n");
    fprintf(out,"<input type=\"button\" name=\"back\" value=\"Back\" onclick=\"history.back()\"></td>\n");
    fprintf(out,"</tr>\n</table>\n");
    fprintf(out,"<input type=\"hidden\" name=\"torrent_dup\">\n");
    fprintf(out,"<input type=\"hidden\" name=\"message\">\n");
#ifdef CENTURY
    fprintf(out,"<table border=\"0\" width=\"500\" height=\"50\" align=\"center\">\n");
    fprintf(out,"<tr><td width=8%% valign=top><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\"><b>Note:</b></font></td>\n",get_font_color());
    fprintf(out,"<td width=100%% align=left><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\">\n",get_font_color());
    fprintf(out,"<b>Click \"Next\" to continue the configuration.</td></tr></table>\n");
#else
    fprintf(out,"<table border=\"0\" width=\"75%%\" height=\"50\" align=\"center\">\n");
    fprintf(out,"<tr><td width=8%% valign=top><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\"><b>Note:</b></font></td>\n",get_font_color());
    fprintf(out,"<td width=100%% align=left><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\">\n",get_font_color());
    fprintf(out,"<b>Click \"Next\" to continue the configuration.</td></tr></table>\n");
#endif
	fprintf(out,"</body></html>\n");
	//JavaScript to check if the torrent file is downloading twice
	fprintf(out,"<script language=\"JavaScript\">\n");
	for(i=0;i<status_num;i++)
		fprintf(out,"var torrent%d = new Object();\n",i+1);  
    fprintf(out,"function check_dup(filename){\n");
//=============judge the downloading BT files to avoid conflict==============
	for(i=0;i<status_num;i++){
		strcpy(compare,status_record[i].filename);
		 for(j=0;j<MAX_QUEUE;j++){  
	      if(strlen(ADD_FILE_TEMP_HISTORY[j].filename) > 0 && strstr(ADD_FILE_TEMP_HISTORY[j].filename,compare)){
			      printf("ADD_FILE_TEMP_HISTORY[%d].filename = %s\n", j, ADD_FILE_TEMP_HISTORY[j].filename);
			      strcpy(compare1,ADD_FILE_TEMP_HISTORY[j].filename);			      			    	
			    	end = strrchr(compare1,'.');
    	      *end = '\0';
    	      ptr=strrchr(compare1,'/');
    	      ptr+=1;
    	      printf("compare1 = %s; ptr = %s; length of ptr = %d\n", compare1, ptr, strlen(ptr));
    	      strcpy(compare1,ptr);			    	
				    fprintf(out,"un%d=filename.value.indexOf(\"%s\",0)\n",j ,compare1);
				    fprintf(out,"        if(un%d >= 0){\n",j );
				    fprintf(out,"            if(filename.checked == true){\n");
				    fprintf(out,"                torrent%d.name = \"%s\";\n",i+1,compare);
				    fprintf(out,"                torrent%d.dup = 1;\n",i+1);
				    fprintf(out,"            }else\n");
				    fprintf(out,"                torrent%d.dup = 0;\n",i+1);
				    fprintf(out,"        }\n");
	      }
	   } 
	}
//============================================================================
	fprintf(out,"}\n");
	fprintf(out,"function validate(){\n");
	fprintf(out,"    document.p2p.torrent_dup.value = 0;\n");
	fprintf(out,"    document.p2p.message.value = \"\";\n");
	for(i=0;i<status_num;i++){
		fprintf(out,"    if(torrent%d.dup == 1){\n",i+1);
		fprintf(out,"        document.p2p.message.value += torrent%d.name;\n",i+1);
		fprintf(out,"        document.p2p.message.value += \"  \";\n");
		fprintf(out,"        document.p2p.torrent_dup.value += 1;\n");
		fprintf(out,"    }\n");
	}
	fprintf(out,"    if(document.p2p.torrent_dup.value > 0){\n");
	fprintf(out,"        alert(document.p2p.message.value + \" is being downloaded!!\");\n");
	fprintf(out,"        return false;\n");
	fprintf(out,"    }else\n");
	fprintf(out,"        return true;\n"); 
	fprintf(out,"}\n");
	fprintf(out,"</script>\n");
	//End of HTML format
	chdir("..");
	ptr = strrchr(file_directory,'/');    //directory goes backwards
	*ptr = '\0';
	closedir(dp);
}

#elif defined(ZyXEL) || defined(PCI)

//Note: before calling this function, reset directory first
void show_file_and_folder(FILE *out, char *dir, char *sort, int depth){
	
	DIR *dp;
	char *ptr, *end;
	int i, j, count = 0;
	struct dirent *entry;
	struct stat statbuf;
	char check_dir[4096], compare[1024], compare1[1024];
	
	if((dp = opendir(dir)) == NULL){
		fprintf(stderr,"cannot open directory: %s\n",dir);
		return;
	}
	MSG("%s: Line %d - sort = %s\n",__func__,__LINE__,sort);


	if(!strcmp(sort,"file")){

/*
#ifdef CENTURY
       fprintf(out,"<table width=\"550\" border=\"0\" align=\"center\">\n");
#else
		fprintf(out,"<table width=\"80%\" border=\"0\" align=\"center\">\n");
#endif
	    fprintf(out,"<tr><td><H3><font color=\"#%s\">Please select the BitTorrent file.</font></H3></td></tr></table>\n",get_font_color());
	    fprintf(out,"<form name=\"p2p\" method=\"Get\" action=\"set_torrent_download.cgi\" onsubmit=\"return validate();\">\n");
*/

fprintf(out,"<form name=\"p2p\" method=\"Get\" action=\"set_torrent_download.cgi\">\n");
fprintf(out,"<table width=\"550\" border=\"1\" bordercolor=\"#FFFFFF\" cellpadding=\"0\" cellspacing=\"0\">\n");
fprintf(out,"<tr bgcolor=\"#FFFFFF\">Please select the BitTorrent file.</tr>\n");
fprintf(out,"<br>\n");

	}else{
	/*
#ifdef CENTURY
        fprintf(out,"<table width=\"550\" border=\"0\" align=\"center\">\n");
#else
	    fprintf(out,"<table width=\"80%%\" border=\"0\" align=\"center\">\n");
#endif
	    fprintf(out,"<tr><td><H3><font color=\"#%s\">Please select the download folder.</font></H3></td></tr></table>\n",get_font_color());
	    fprintf(out,"<form name=\"p2p\" method=\"Get\" action=\"set_folder_download.cgi\">\n");
	  */
	  
	  fprintf(out,"<form name=\"p2p\" method=\"Get\" action=\"set_folder_download.cgi\">\n");
fprintf(out,"<table width=\"550\" border=\"1\" bordercolor=\"#FFFFFF\" cellpadding=\"0\" cellspacing=\"0\">\n");
fprintf(out,"<tr bgcolor=\"#FFFFFF\">Please select the download folder.</tr>\n");
fprintf(out,"<br>\n");
	    
	}
	
#ifdef CENTURY
    fprintf(out,"<table width=\"500\" border=\"0\" align=\"center\">\n");
#else
	fprintf(out,"<table width=\"75%%\" border=\"0\" align=\"center\">\n");
#endif

	//fprintf(out,"<tr><td><img src=\"images/thread_new.gif\" border=\"0\"></td><td><b><font color=\"#%s\">Index of %s</font></b></td>\n\n",get_font_color(),dir+4);
	
	fprintf(out,"<tr><td><img src=\"images/thread_new.gif\" border=\"0\"></td><td><b><font color=\"#000000\">Index of %s</font></b></td></tr>\n",dir+4);
	
	strcat(file_directory,dir);
    chdir(dir);
	while((entry = readdir(dp)) != NULL){
		lstat(entry->d_name,&statbuf);
		if(S_ISDIR(statbuf.st_mode)){        //Part to Show Folders
			if(strcmp(".",entry->d_name) == 0 || strcmp("..",entry->d_name) == 0)
			    continue;
			if(strcmp(entry->d_name,"lost+found") == 0)
			    continue;
			strcpy(check_dir,dir);
			strcat(check_dir,"/");
			strcat(check_dir,entry->d_name);
			if(!opendir(check_dir))
			    continue;
		    if(!strcmp(sort,"folder")){
		        fprintf(out,"<tr><td width=\"5%%\"><img src=\"images/navbits_finallink.gif\" border=\"0\"></td>\n");
		        fprintf(out,"<td><p><input type=\"radio\" name=\"download_folder\" value=\"%s/%s\"><a href=\"show_download_folder.cgi?directory=%s/%s&kind=folder\"><font color=\"#%s\">%s</font></a></p></tr></td>\n",dir,entry->d_name,dir,entry->d_name,get_font_color(),entry->d_name);
		    }else{
		        fprintf(out,"<tr><td width=\"5%%\"><img src=\"images/navbits_finallink.gif\" border=\"0\"></td>\n");
		        fprintf(out,"<td><p><a href=\"list_torrent_file.cgi?directory=%s/%s&kind=file\"><font color=\"#%s\">%s</font></a></p></tr></td>\n",dir,entry->d_name,get_font_color(),entry->d_name);
		    }
		    //fprintf(out,"<tr><td><p><a href=\"/../..%s/%s\">%s</a></p></tr></td>\n",dir,entry->d_name,entry->d_name);
		    count ++;
		}else{                               //Part to Show Files
            if(!strcmp(sort,"file") && strstr(entry->d_name,".torrent") && !strstr(entry->d_name,".status")){
            	MSG("%s\n",entry->d_name);
            	for(i=0;i<strlen(entry->d_name);i++)
            	    MSG("%02x ",entry->d_name[i]);
            	MSG("\n");
            	fprintf(out,"<tr><td width=\"5%%\"><img src=\"images/file.gif\" border=\"0\"></td>\n");		    
		        fprintf(out,"<td><input type=\"checkbox\" name=\"torrent_file\" value=\"%s/%s\" onclick=\"check_dup(this)\"><font color=\"#%s\">%s</font></tr></td>\n",file_directory,entry->d_name,get_font_color(),entry->d_name);
		    }
		    //fprintf(out,"%*s%s(%s)\n",depth,"",entry->d_name,file_directory);
		    count ++;
		}
	}
	if(count == 0)
	    fprintf(out,"<tr><td><font color=\"#%s\">There are not any folders and files existing in this directory!!</font></td></tr>\n",get_font_color());		
	fprintf(out,"</table>\n");
	
			
	//To print all the buttons
/*
#ifdef CENTURY
	fprintf(out,"<table border=\"0\" width=\"500\" height=\"50\" align=\"center\">\n");
#else
    fprintf(out,"<table><tr>\n");
#endif
*/
    //fprintf(out,"<td align=center><br>\n");
    //fprintf(out,"<input type=\"submit\" name=\"set_torrent\" value=\"Next\">&nbsp;\n");
    //fprintf(out,"<input type=\"reset\" name=\"Reset\" value=\"Reset\">\n");
    //fprintf(out,"<input type=\"button\" name=\"back\" value=\"Back\" onclick=\"history.back()\"></td>\n");
    //fprintf(out,"</tr>\n</table>\n");
    //fprintf(out,"<input type=\"hidden\" name=\"torrent_dup\">\n");
    //fprintf(out,"<input type=\"hidden\" name=\"message\">\n");
        
   fprintf(out," <br>\n");
		fprintf(out,"<table width=\"550\" border=\"1\" align=center bordercolor=\"#FFFFFF\" cellpadding=\"0\" cellspacing=\"0\">\n");
		fprintf(out,"<tr>\n");
		fprintf(out,"<td>\n");
	fprintf(out,"	<input type=\"submit\" name=\"set_torrent\" value=\"Next\">&nbsp;\n");
	fprintf(out,"	<input type=\"reset\" name=\"Reset\" value=\"Reset\">\n");
		fprintf(out,"<input type=\"button\" name=\"back\" value=\"Back\" onclick=\"history.back()\"></td>\n");
		fprintf(out,"</tr>\n");
		fprintf(out,"</table>		\n");
    fprintf(out,"<input type=\"hidden\" name=\"torrent_dup\">\n");
    fprintf(out,"<input type=\"hidden\" name=\"message\">\n");
    
    
#ifdef CENTURY
    fprintf(out,"<table border=\"0\" width=\"500\" height=\"50\" align=\"center\">\n");
    fprintf(out,"<tr><td width=8%% valign=top><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\"><b>Note:</b></font></td>\n",get_font_color());
    fprintf(out,"<td width=100%% align=left><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\">\n",get_font_color());
    fprintf(out,"<b>Click \"Next\" to continue the configuration.</td></tr></table>\n");
#else
    //fprintf(out,"<table border=\"0\" width=\"75%%\" height=\"50\" align=\"center\">\n");
    //fprintf(out,"<tr><td width=8%% valign=top><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\"><b>Note:</b></font></td>\n",get_font_color());
    //fprintf(out,"<td width=100%% align=left><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\">\n",get_font_color());
    //fprintf(out,"<b>Click \"Next\" to continue the configuration.</td></tr></table>\n");
    
    fprintf(out,"<br>\n");
		fprintf(out,"<br>\n");
		fprintf(out,"<tr><td width=8%% valign=top>Note:</td>\n");
		fprintf(out,"<td width=100%% align=left>Click \"Next\" to continue the configuration.</td></tr>\n");
		fprintf(out,"<map name=\"Map\">\n");
		fprintf(out,"<area shape=\"rect\" coords=\"010,1,220,23\" href=\"torrent_basic.htm\">\n");
		fprintf(out,"<area shape=\"rect\" coords=\"221,1,450,23\" href=\"torrent_config.cgi\">\n");
		fprintf(out,"</map>\n");
		fprintf(out,"</form>\n");
    
#endif
	fprintf(out,"</body></html>\n");
		
	/*
	//JavaScript to check if the torrent file is downloading twice
	fprintf(out,"<script language=\"JavaScript\">\n");
	for(i=0;i<status_num;i++)
		fprintf(out,"var torrent%d = new Object();\n",i+1);  
    fprintf(out,"function check_dup(filename){\n");
	for(i=0;i<status_num;i++){
		strcpy(compare,status_record[i].filename);
        ptr = strrchr(compare,'.');
    	*ptr = '\0';
	    fprintf(out,"        if(filename.value == \"/mnt/%s/%s\"){\n",CONFIG.TCONFIG_FOLDER,compare);
	    fprintf(out,"            if(filename.checked == true){\n");
	    fprintf(out,"                torrent%d.name = \"%s\";\n",i+1,compare);
	    fprintf(out,"                torrent%d.dup = 1;\n",i+1);
	    fprintf(out,"            }else\n");
	    fprintf(out,"                torrent%d.dup = 0;\n",i+1);
	    fprintf(out,"        }\n");
	}
	fprintf(out,"}\n");
	*/
//JavaScript to check if the torrent file is downloading twice
	fprintf(out,"<script language=\"JavaScript\">\n");
	for(i=0;i<status_num;i++)
		fprintf(out,"var torrent%d = new Object();\n",i+1);  
    fprintf(out,"function check_dup(filename){\n");
//=============judge the downloading BT files to avoid conflict==============
	for(i=0;i<status_num;i++){
		strcpy(compare,status_record[i].filename);
		 for(j=0;j<MAX_QUEUE;j++){  
	      if(strlen(ADD_FILE_TEMP_HISTORY[j].filename) > 0 && strstr(ADD_FILE_TEMP_HISTORY[j].filename,compare)){
			      printf("ADD_FILE_TEMP_HISTORY[%d].filename = %s\n", j, ADD_FILE_TEMP_HISTORY[j].filename);
			      strcpy(compare1,ADD_FILE_TEMP_HISTORY[j].filename);			      			    	
			    	end = strrchr(compare1,'.');
    	      *end = '\0';
    	      ptr=strrchr(compare1,'/');
    	      ptr+=1;
    	      printf("compare1 = %s; ptr = %s; length of ptr = %d\n", compare1, ptr, strlen(ptr));
    	      strcpy(compare1,ptr);			    	
				    fprintf(out,"un%d=filename.value.indexOf(\"%s\",0)\n",j ,compare1);
				    fprintf(out,"        if(un%d >= 0){\n",j );
				    fprintf(out,"            if(filename.checked == true){\n");
				    fprintf(out,"                torrent%d.name = \"%s\";\n",i+1,compare);
				    fprintf(out,"                torrent%d.dup = 1;\n",i+1);
				    fprintf(out,"            }else\n");
				    fprintf(out,"                torrent%d.dup = 0;\n",i+1);
				    fprintf(out,"        }\n");
	      }
	   } 
	}
//============================================================================
	fprintf(out,"}\n");
	
	fprintf(out,"function validate(){\n");
	fprintf(out,"    document.p2p.torrent_dup.value = 0;\n");
	fprintf(out,"    document.p2p.message.value = \"\";\n");
	for(i=0;i<status_num;i++){
		fprintf(out,"    if(torrent%d.dup == 1){\n",i+1);
		fprintf(out,"        document.p2p.message.value += torrent%d.name;\n",i+1);
		fprintf(out,"        document.p2p.message.value += \"  \";\n");
		fprintf(out,"        document.p2p.torrent_dup.value += 1;\n");
		fprintf(out,"    }\n");
	}
	fprintf(out,"    if(document.p2p.torrent_dup.value > 0){\n");
	fprintf(out,"        alert(document.p2p.message.value + \" is being downloaded!!\");\n");
	fprintf(out,"        return false;\n");
	fprintf(out,"    }else\n");
	fprintf(out,"        return true;\n"); 
	fprintf(out,"}\n");
	fprintf(out,"</script>\n");
	//End of HTML format
	chdir("..");
	ptr = strrchr(file_directory,'/');    //directory goes backwards
	*ptr = '\0';
	closedir(dp);
}

#else
//Note: before calling this function, reset directory first
void show_file_and_folder(FILE *out, char *dir, char *sort, int depth){
	
	DIR *dp;
	char *ptr, *end;
	int i, j, count = 0;
	struct dirent *entry;
	struct stat statbuf;
	char check_dir[4096], compare[1024], compare1[1024];
	
	if((dp = opendir(dir)) == NULL){
		fprintf(stderr,"cannot open directory: %s\n",dir);
		return;
	}
	MSG("%s: Line %d - sort = %s\n",__func__,__LINE__,sort);
	if(!strcmp(sort,"file")){
#ifdef CENTURY
       fprintf(out,"<table width=\"550\" border=\"0\" align=\"center\">\n");
#else
		fprintf(out,"<table width=\"80%\" border=\"0\" align=\"center\">\n");
#endif
	    fprintf(out,"<tr><td><H3><font color=\"#%s\">Please select the BitTorrent file.</font></H3></td></tr></table>\n",get_font_color());
	    fprintf(out,"<form name=\"p2p\" method=\"Get\" action=\"set_torrent_download.cgi\" onsubmit=\"return validate();\">\n");
	}else{
#ifdef CENTURY
        fprintf(out,"<table width=\"550\" border=\"0\" align=\"center\">\n");
#else
	    fprintf(out,"<table width=\"80%%\" border=\"0\" align=\"center\">\n");
#endif
	    fprintf(out,"<tr><td><H3><font color=\"#%s\">Please select the download folder.</font></H3></td></tr></table>\n",get_font_color());
	    fprintf(out,"<form name=\"p2p\" method=\"Get\" action=\"set_folder_download.cgi\">\n");
	}
#ifdef CENTURY
    fprintf(out,"<table width=\"500\" border=\"0\" align=\"center\">\n");
#else
	fprintf(out,"<table width=\"75%%\" border=\"0\" align=\"center\">\n");
#endif
	fprintf(out,"<tr><td><img src=\"images/thread_new.gif\" border=\"0\"></td><td><b><font color=\"#%s\">Index of %s</font></b></td>\n\n",get_font_color(),dir+4);
	strcat(file_directory,dir);
    chdir(dir);
	while((entry = readdir(dp)) != NULL){
		lstat(entry->d_name,&statbuf);
		if(S_ISDIR(statbuf.st_mode)){        //Part to Show Folders
			if(strcmp(".",entry->d_name) == 0 || strcmp("..",entry->d_name) == 0)
			    continue;
			if(strcmp(entry->d_name,"lost+found") == 0)
			    continue;
			strcpy(check_dir,dir);
			strcat(check_dir,"/");
			strcat(check_dir,entry->d_name);
			if(!opendir(check_dir))
			    continue;
		    if(!strcmp(sort,"folder")){
		        fprintf(out,"<tr><td width=\"5%\"><img src=\"images/navbits_finallink.gif\" border=\"0\"></td>\n");
		        fprintf(out,"<td><p><input type=\"radio\" name=\"download_folder\" value=\"%s/%s\"><a href=\"show_download_folder.cgi?directory=%s/%s&kind=folder\"><font color=\"#%s\">%s</font></a></p></tr></td>\n",dir,entry->d_name,dir,entry->d_name,get_font_color(),entry->d_name);
		    }else{
		        fprintf(out,"<tr><td width=\"5%\"><img src=\"images/navbits_finallink.gif\" border=\"0\"></td>\n");
		        fprintf(out,"<td><p><a href=\"list_torrent_file.cgi?directory=%s/%s&kind=file\"><font color=\"#%s\">%s</font></a></p></tr></td>\n",dir,entry->d_name,get_font_color(),entry->d_name);
		    }
		    //fprintf(out,"<tr><td><p><a href=\"/../..%s/%s\">%s</a></p></tr></td>\n",dir,entry->d_name,entry->d_name);
		    count ++;
		}else{                               //Part to Show Files
            if(!strcmp(sort,"file") && strstr(entry->d_name,".torrent") && !strstr(entry->d_name,".status")){
            	MSG("%s\n",entry->d_name);
            	for(i=0;i<strlen(entry->d_name);i++)
            	    MSG("%02x ",entry->d_name[i]);
            	MSG("\n");
            	fprintf(out,"<tr><td width=\"5%\"><img src=\"images/file.gif\" border=\"0\"></td>\n");		    
		        fprintf(out,"<td><input type=\"checkbox\" name=\"torrent_file\" value=\"%s/%s\" onclick=\"check_dup(this)\"><font color=\"#%s\">%s</font></tr></td>\n",file_directory,entry->d_name,get_font_color(),entry->d_name);
		    }
		    //fprintf(out,"%*s%s(%s)\n",depth,"",entry->d_name,file_directory);
		    count ++;
		}
	}
	if(count == 0)
	    fprintf(out,"<tr><td><font color=\"#%s\">There are not any folders and files existing in this directory!!</font></td></tr>\n",get_font_color());
	fprintf(out,"</table>\n");
	//To print all the buttons
#ifdef CENTURY
	fprintf(out,"<table border=\"0\" width=\"500\" height=\"50\" align=\"center\">\n");
#else
    fprintf(out,"<table><tr>\n");
#endif
    fprintf(out,"<td align=center><br>\n");
    fprintf(out,"<input type=\"submit\" name=\"set_torrent\" value=\"Next\">&nbsp;\n");
    fprintf(out,"<input type=\"reset\" name=\"Reset\" value=\"Reset\">\n");
    fprintf(out,"<input type=\"button\" name=\"back\" value=\"Back\" onclick=\"history.back()\"></td>\n");
    fprintf(out,"</tr>\n</table>\n");
    fprintf(out,"<input type=\"hidden\" name=\"torrent_dup\">\n");
    fprintf(out,"<input type=\"hidden\" name=\"message\">\n");
#ifdef CENTURY
    fprintf(out,"<table border=\"0\" width=\"500\" height=\"50\" align=\"center\">\n");
    fprintf(out,"<tr><td width=8%% valign=top><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\"><b>Note:</b></font></td>\n",get_font_color());
    fprintf(out,"<td width=100%% align=left><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\">\n",get_font_color());
    fprintf(out,"<b>Click \"Next\" to continue the configuration.</td></tr></table>\n");
#else
    fprintf(out,"<table border=\"0\" width=\"75%%\" height=\"50\" align=\"center\">\n");
    fprintf(out,"<tr><td width=8%% valign=top><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\"><b>Note:</b></font></td>\n",get_font_color());
    fprintf(out,"<td width=100%% align=left><font size=2 face=\"Arial, Helvetica, sans-serif\" color=\"#%s\">\n",get_font_color());
    fprintf(out,"<b>Click \"Next\" to continue the configuration.</td></tr></table>\n");
#endif
	fprintf(out,"</body></html>\n");
	//JavaScript to check if the torrent file is downloading twice
	fprintf(out,"<script language=\"JavaScript\">\n");
	for(i=0;i<status_num;i++)
		fprintf(out,"var torrent%d = new Object();\n",i+1);  
    fprintf(out,"function check_dup(filename){\n");
//=============judge the downloading BT files to avoid conflict==============
	for(i=0;i<status_num;i++){
		strcpy(compare,status_record[i].filename);
		 for(j=0;j<MAX_QUEUE;j++){  
	      if(strlen(ADD_FILE_TEMP_HISTORY[j].filename) > 0 && strstr(ADD_FILE_TEMP_HISTORY[j].filename,compare)){
			      printf("ADD_FILE_TEMP_HISTORY[%d].filename = %s\n", j, ADD_FILE_TEMP_HISTORY[j].filename);
			      strcpy(compare1,ADD_FILE_TEMP_HISTORY[j].filename);			      			    	
			    	end = strrchr(compare1,'.');
    	      *end = '\0';
    	      ptr=strrchr(compare1,'/');
    	      ptr+=1;
    	      printf("compare1 = %s; ptr = %s; length of ptr = %d\n", compare1, ptr, strlen(ptr));
    	      strcpy(compare1,ptr);			    	
				    fprintf(out,"un%d=filename.value.indexOf(\"%s\",0)\n",j ,compare1);
				    fprintf(out,"        if(un%d >= 0){\n",j );
				    fprintf(out,"            if(filename.checked == true){\n");
				    fprintf(out,"                torrent%d.name = \"%s\";\n",i+1,compare);
				    fprintf(out,"                torrent%d.dup = 1;\n",i+1);
				    fprintf(out,"            }else\n");
				    fprintf(out,"                torrent%d.dup = 0;\n",i+1);
				    fprintf(out,"        }\n");
	      }
	   } 
	}
//============================================================================
	fprintf(out,"}\n");
	fprintf(out,"function validate(){\n");
	fprintf(out,"    document.p2p.torrent_dup.value = 0;\n");
	fprintf(out,"    document.p2p.message.value = \"\";\n");
	for(i=0;i<status_num;i++){
		fprintf(out,"    if(torrent%d.dup == 1){\n",i+1);
		fprintf(out,"        document.p2p.message.value += torrent%d.name;\n",i+1);
		fprintf(out,"        document.p2p.message.value += \"  \";\n");
		fprintf(out,"        document.p2p.torrent_dup.value += 1;\n");
		fprintf(out,"    }\n");
	}
	fprintf(out,"    if(document.p2p.torrent_dup.value > 0){\n");
	fprintf(out,"        alert(document.p2p.message.value + \" is being downloaded!!\");\n");
	fprintf(out,"        return false;\n");
	fprintf(out,"    }else\n");
	fprintf(out,"        return true;\n"); 
	fprintf(out,"}\n");
	fprintf(out,"</script>\n");
	//End of HTML format
	chdir("..");
	ptr = strrchr(file_directory,'/');    //directory goes backwards
	*ptr = '\0';
	closedir(dp);
}
#endif

//CGI for torrent basic configuration such as configure path, user number(torrent_basic.htm)
void Config_torrent(char *data, FILE *out){
	
	FILE *fp;
    int num = 0;
	char command[50], LineBuf[1024], new_torrent_enable[2];
	char new_config_directory[MAX_NAME], new_config_filename[MAX_NAME];
	
	ARGUMENT args[]={
        {"torrent_enable",new_torrent_enable,2},
        {"mnt_dir",new_config_directory,MAX_NAME},
        {"tconfig_name",new_config_filename,MAX_NAME},
        {"max_user",CONFIG.TORRENT_USER,3},
        //{"cron_enable",CONFIG.CRON_ENABLE,2}, //crond disabled
        {"start_day",CONFIG.CRON_START_DAY,2},
        {"start_hour",CONFIG.CRON_START_HOUR,3},
        {"start_min",CONFIG.CRON_START_MIN,3},
        {"end_day",CONFIG.CRON_END_DAY,2},
        {"end_hour",CONFIG.CRON_END_HOUR,3},
        {"end_min",CONFIG.CRON_END_MIN,3},
        {NULL,NULL,0}
    };
    memset(new_config_directory,0,MAX_NAME);
    memset(new_config_filename,0,MAX_NAME);
    parseargs(data,args);
    MSG("%s: Line %d - mnt_dir = %s, config_name = %s\n",__func__,__LINE__,new_config_directory,new_config_filename);
    MSG("%s: Line %d - folder = %s, file = %s, length = %d\n",__func__,__LINE__,CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME,strlen(CONFIG.TCONFIG_FILENAME));
    num = bt_run();
    //printf("num = %d\n",num);
    if((!strcmp(new_torrent_enable,"1") && !strcmp(CONFIG.TORRENT_ENABLE,"0")) || (!strcmp(new_torrent_enable,"1") && !strcmp(CONFIG.TORRENT_ENABLE,"1"))){
        if((num == 1) && strlen(CONFIG.TCONFIG_FILENAME) && (strcmp(new_config_directory,CONFIG.TCONFIG_FOLDER) || strcmp(new_config_filename,CONFIG.TCONFIG_FILENAME))){
        	if((fp=fopen("/htdocs/torrent_head.htm","r")) != NULL){
			    while(fgets(LineBuf,1023,fp) != NULL)
			        fprintf(out,"%s",LineBuf);
			    	fclose(fp);
					}
					fprintf(out,"<tr><td>\n<font face=\"Arial, Helvetica, sans-serif\" color=\"#FFFFFF\">");
					fprintf(out,"You can't change the download folder or BitTorrent configuration file when the P2P is running.\n");
					fprintf(out,"</font></td></tr>\n");
					fprintf(out,"<tr><td>\n");
					fprintf(out,"<input type=\"button\" name=\"reset\" value=\"BACK\" onclick='history.back();'></td></tr></table>\n");
					fprintf(out,"</body></html>\n");
					return;
       }
        else if((num == 1) && strlen(CONFIG.TCONFIG_FILENAME) && (!strcmp(new_config_directory,CONFIG.TCONFIG_FOLDER) && !strcmp(new_config_filename,CONFIG.TCONFIG_FILENAME))){
	        	if((fp=fopen("/htdocs/torrent_head.htm","r")) != NULL){
					    while(fgets(LineBuf,1023,fp) != NULL)
					        fprintf(out,"%s",LineBuf);
					    fclose(fp);
				    }
						fprintf(out,"<tr><td>\n<font face=\"Arial, Helvetica, sans-serif\" color=\"#000000\">");
						fprintf(out,"Change before stopping P2P program.\n");
						fprintf(out,"</font></td></tr>\n");
						fprintf(out,"<tr><td>\n");
						fprintf(out,"<input type=\"button\" name=\"reset\" value=\"BACK\" onclick='history.back();'></td></tr></table>\n");
						fprintf(out,"</body></html>\n");
						return;
        }
        else{
          strcpy(CONFIG.TORRENT_ENABLE,new_torrent_enable);
        	strcpy(CONFIG.TCONFIG_FOLDER,new_config_directory);
          strcpy(CONFIG.TCONFIG_FILENAME,new_config_filename);
		    	sprintf(command,"cd /mnt/%s; touch .%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
		    	system(command);
			  }
    }else if(!strcmp(new_torrent_enable,"0") && !strcmp(CONFIG.TORRENT_ENABLE,"1")){
    	if(num == 1){
		    	if((fp=fopen("/htdocs/torrent_head.htm","r")) != NULL){
				    while(fgets(LineBuf,1023,fp) != NULL)
				        fprintf(out,"%s",LineBuf);
				    fclose(fp);
					}
					fprintf(out,"<tr><td>\n<font face=\"Arial, Helvetica, sans-serif\" color=\"#000000\">");
					fprintf(out,"You can't disable when P2P is runnung.\n");
					fprintf(out,"</font></td></tr>\n");
					fprintf(out,"<tr><td>\n");
					fprintf(out,"<input type=\"button\" name=\"reset\" value=\"BACK\" onclick='history.back();'></td></tr></table>\n");
					fprintf(out,"</body></html>\n");
					return;
	    }
	    else{
	        strcpy(CONFIG.TORRENT_ENABLE,new_torrent_enable);
	        sprintf(command,"/bin/rm -f /mnt/%s/%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
	        system(command);
	        strcpy(CONFIG.TCONFIG_FILENAME,"");
	        strcpy(CONFIG.TCONFIG_FOLDER,"");
	    }
	}
	/*
		//crond disabled
    if(!strcmp(CONFIG.CRON_ENABLE,"1")){
    	cron_del_download();
    	my_system(out,"killall bt_clnt");
    	//printf("%s: Line %d\n",__func__,__LINE__);
    	my_system(out,"killall cron");
    	sprintf(command,"/etc/rc.d/cronedit.sh %s %s %s %s %s %s",CONFIG.CRON_START_DAY,CONFIG.CRON_START_HOUR,CONFIG.CRON_START_MIN,CONFIG.CRON_END_DAY,CONFIG.CRON_END_HOUR,CONFIG.CRON_END_MIN);
    	my_system(out,command);
    	my_system(out,"/sbin/cron");
    }else if(!strcmp(CONFIG.CRON_ENABLE,"0")){
    	system("killall cron");
    }
   */ 
   
    //printf("%s: Line %d\n",__func__,__LINE__);
    SaveConfiguration();
    //printf("%s: Line %d\n",__func__,__LINE__);
    fprintf(out,"<script language=\"JavaScript\">\n");
    fprintf(out,"location.replace('http://%s:%s/torrent_basic.htm');\n",CONFIG.IP,CONFIG.ADMIN_PORT);
    fprintf(out,"</script>\n");
    return;
}

int bt_run(void){
	
	FILE *fpin;
	char temp[256];
		
	if((fpin = popen("ps","r")) == NULL){
		//HDBG("smb_process_count: Can't open !! \n");
		return (-1);
	}

	while( fgets(temp, 255,fpin) != NULL){

		if (strstr(temp, "bt_clnt") != NULL)
			return 1;	
	}
	
	//printf();
	return 0;
    pclose(fpin);
}
//Mark status as done when enabling cron
void cron_del_download(void){
	
	int i;
	char *ptr;
	FILE *fi, *fo;
	char dir[30], open_file[4096], LineBuf[1024], command[50];
	
	sprintf(dir,"/mnt/%s",CONFIG.TCONFIG_FOLDER);
	status_num = 0;
	search_torrent_file(dir,0);
	chdir("/htdocs");
	if(status_num != 0){
		for(i=0;i<status_num;i++){
			if(!strlen(status_record[i].dirname) || !strlen(status_record[i].filename))
			    continue;
			strcpy(open_file,status_record[i].dirname);
			strcat(open_file,"/");
			strcat(open_file,status_record[i].filename);
			if((fi = fopen(open_file,"r")) == NULL)
			    continue;
			if((fo = fopen("/var/run/finish_status","w+")) == NULL)
			    continue;
			while(fgets(LineBuf,1023,fi)){
				if((ptr = strstr(LineBuf,"Status     :")) != NULL){
					fprintf(fo,"Status     : done\n");
				}else{
				    fputs(LineBuf,fo);
				}
			}
			fclose(fi);
			fclose(fo);
		    sprintf(command,"/bin/mv /var/run/finish_status %s",open_file);
		    system(command);
			system("/bin/rm -f /var/run/finish_status");
		}
	}
	return status_num;
}

//read the configure file stored in HD to get queue information, up to 50 records totally
//format:  TORRENT_R1=<xxx.torrent>,<download_folder>,<hours>,<port>,<max_peer>,<min_peer>,<max_bw>,<min_bw>
void read_queue_data(void){
	
	FILE *fp;
	int i, dup=0, no_queue=0;
	char *ptr, *end;
	char command[50], LineBuf[1024];
	
	sprintf(command,"/mnt/%s/.%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
	MSG("%s: Line%d - command = %s\n",__func__,__LINE__,command);
	if((fp = fopen(command,"r")) == NULL){
		return;
	}else{
	    while(fgets(LineBuf,1023,fp)){
	        ptr = strstr(LineBuf,"TORRENT_RECORD");
	        if(ptr == NULL)
	            continue;
	    	ptr = strchr(ptr,'=');
	    	ptr++;
	    	ptr = strtok(ptr,",");
	    	if(ptr == NULL)
	    	    continue;
	    	dup = 0;
	    	for(i=0;i<status_num;i++){
	    		//MSG("%s: Line%d - %s and status_record[%d].filename = %s\n",__func__,__LINE__,strrchr(ptr,'/')+1,i,status_record[i].filename);
	    		if(!strncmp(strrchr(ptr,'/')+1,status_record[i].filename,strlen(strrchr(ptr,'/')+1))){
	    	        dup = 1;
	    			MSG("%s: Line%d - dup = %d\n",__func__,__LINE__,dup);
	    		}
	    	}
	    	if(dup == 1)
	    		continue;
    		strcpy(queue_record[no_queue].filename,ptr);
    		//MSG("queue_record[%d].filename = %s\n",no_queue,queue_record[no_queue].filename);
    		ptr = strtok(NULL,",");
    		strcpy(queue_record[no_queue].dirname,ptr);
    		//MSG("queue_record[%d].dirname = %s\n",no_queue,queue_record[no_queue].dirname);
    		ptr = strtok(NULL,",");
    		strcpy(queue_record[no_queue].hours,ptr);
    		//MSG("queue_record[%d].hours = %s\n",no_queue,queue_record[no_queue].hours);
    		ptr = strtok(NULL,",");
    		strcpy(queue_record[no_queue].port,ptr);
    		//MSG("queue_record[%d].port = %s\n",no_queue,queue_record[no_queue].port);
    		ptr = strtok(NULL,",");
    		strcpy(queue_record[no_queue].max_peer,ptr);
    		//MSG("queue_record[%d].max_peer = %s\n",no_queue,queue_record[no_queue].max_peer);
    		ptr = strtok(NULL,",");
    		strcpy(queue_record[no_queue].min_peer,ptr);
    		//MSG("queue_record[%d].min_peer = %s\n",no_queue,queue_record[no_queue].min_peer);
    		ptr = strtok(NULL,",");
    		strcpy(queue_record[no_queue].max_bw,ptr);
    		//MSG("queue_record[%d].max_bw = %s\n",no_queue,queue_record[no_queue].max_bw);
    		ptr = strtok(NULL,",");
    		strcpy(queue_record[no_queue].min_bw,ptr);
    		//MSG("queue_record[%d].min_bw = %s\n",no_queue,queue_record[no_queue].min_bw);
    		no_queue++;
    	}
    	fclose(fp);
    }  
}

//CGI to get the torrent filename
void set_torrent_download(char *data, FILE *out){
	
	int i;
	char torrent_file[4096];
	
    add_count = 0;
    /*
    for(i=0;i<MAX_QUEUE;i++){
    	ADD_FILE[i].filename[0] = '\0';
    	ADD_FILE[i].time[0] = '\0';
    	ADD_FILE[i].execute[0] = '\0';
    }
    //inefficient code
    */ 
    
    memset((void *)ADD_FILE,0,  (sizeof(DOWNLOAD_DATA)*MAX_QUEUE) ); //this line should replace the inefficient code
    
    parse_download_torrent(&add_count,ADD_FILE,data);
    MSG("%s: Line %d - add_count = %d\n",__func__,__LINE__,add_count);
    //for(i=0;i<add_count;i++)
        //printf("%s: Line %d - ADD_FILE[%d].filename = %s\n",__func__,__LINE__,i,ADD_FILE[i].filename);
    //memset(new_download,0,sizeof(new_download));
    //strcpy(new_download.filename,torrent_file);
    fprintf(out,"<script language=\"JavaScript\">\n");
    fprintf(out,"location.replace('http://%s:%s/show_download_folder.cgi?directory=/mnt/%s&kind=folder');\n",CONFIG.IP,CONFIG.ADMIN_PORT,CONFIG.TCONFIG_FOLDER);
    fprintf(out,"</script>\n");
}

//CGI to get the download folder name
void set_folder_download(char *data, FILE *out){
	
	char download_folder[4096];
	
	ARGUMENT args[]={
        {"download_folder",download_folder,4096},
        {NULL,NULL,0}
    };
    memset(download_folder,0,4096);
    parseargs(data,args);
    if(!strlen(download_folder) || !strcmp(download_folder,"")){
        strcpy(download_folder,"/mnt/");
        strcat(download_folder,CONFIG.TCONFIG_FOLDER);
    }
    //printf("download_folder = %s\n",download_folder);
    strcpy(new_download.dirname,download_folder);
    fprintf(out,"<script language=\"JavaScript\">\n");
    fprintf(out,"location.replace('http://%s:%s/torrent_config.htm');\n",CONFIG.IP,CONFIG.ADMIN_PORT);
    fprintf(out,"</script>\n");
}

//CGI to set up the P2P configuration
void set_torrent_option(char *data, FILE *out){
	
	FILE *fi, *fo;
	int i, queue_num = 0, differ=0;
	char time[20];
	char command[4096], LineBuf[1024], dir[30];
	
	ARGUMENT args[]={
        {"torrent_port",new_download.port,6},
        {"exit_hours",new_download.hours,3},
        {"max_peer",new_download.max_peer,3},
        {"min_peer",new_download.min_peer,3},
        {"max_bw",new_download.max_bw,8},
        {"min_bw",new_download.min_bw,8},
        {NULL,NULL,0}
    };
    parseargs(data,args);
    //MSG("new_download.filename = %s\n",new_download.filename);
    MSG("new_download.dirname = %s\n",new_download.dirname);
    MSG("new_download.port = %s\n",new_download.port);
    MSG("new_download.hours = %s\n",new_download.hours);
    MSG("new_download.max_peer = %s\n",new_download.max_peer);
    MSG("new_download.min_peer = %s\n",new_download.min_peer);
    MSG("new_download.max_bw = %s\n",new_download.max_bw);
    MSG("new_download.min_bw = %s\n",new_download.min_bw);
    //Excute the new download
    sprintf(dir,"/mnt/%s",CONFIG.TCONFIG_FOLDER);
    memset(file_directory,0,4096);
    status_num = 0;
    search_torrent_file(dir,0);        //To get the number of downloading file
    chdir("/htdocs");
    MSG("%s: Line%d - status_num = %d, CONFIG.TORRENT_USER = %d\n",__func__,__LINE__,status_num,atoi(CONFIG.TORRENT_USER));
    differ = atoi(CONFIG.TORRENT_USER) - status_num;
    //Not over the limit, execute it
    if(differ > 0){
    	for(i=0;i<add_count && differ>0;i++,differ--){
    		//if(!strcmp(CONFIG.CRON_ENABLE,"0") && strlen(ADD_FILE[i].filename)){  //Cron disabled
    		if(strlen(ADD_FILE[i].filename)){  //Cron disabled
	            sprintf(command,"/mnt/bt_clnt -s %s -e %s -p %s -M %s -m %s -Y %s -Z %s \"%s\" &",new_download.dirname,new_download.hours,new_download.port,new_download.max_peer,new_download.min_peer,new_download.max_bw,new_download.min_bw,ADD_FILE[i].filename);
	            MSG("%s: Line%d - command = %s\n",__func__,__LINE__,command);
	            my_system(out,command);
	            
	            sprintf(command,"TZ=%s date \"+%%D %%T\" > /var/run/excute_time",CONFIG.TIME_ZONE);
	            MSG("%s: Line%d - command = %s\n",__func__,__LINE__,command);
	            my_system(out,command);
	            strcpy(ADD_FILE[i].execute,"1"); //this bt file has been executed!!
	            
	            if((fi = fopen("/var/run/excute_time","r")) != NULL){
	        	    while(fgets(LineBuf,1023,fi))
	        	        strncpy(ADD_FILE[i].time,LineBuf,20);
	        	        
	        	    ADD_FILE[i].time[20] = '\0';
	        	    MSG("%s: Line%d - ADD_FILE[%d].time = %s\n",__func__,__LINE__,i,ADD_FILE[i].time);
	                fclose(fi);
	                //printf("*****TIME from_execute_time:%s  len(%d)\n",ADD_FILE[i].time,strlen(ADD_FILE[i].time));
	                //printf("*****ADD_FILE[%d].execute:%s \n",i,ADD_FILE[i].execute);
	            }
	        }
	        /*
	        //crond disabled
	        else if(!strcmp(CONFIG.CRON_ENABLE,"1")){  //Cron enabled
	        	ADD_FILE[i].execute[0] = '\0';
	        	ADD_FILE[i].time[0] = '\0';
	        }
	        */
        }
    }
    sprintf(command,"/mnt/%s/.%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
    MSG("%s: Line%d - command = %s\n",__func__,__LINE__,command);
    if((fo = fopen("/var/run/duplicate_config","w+")) == NULL)
        return;
    if((fi = fopen(command,"r")) == NULL){
    	return;
    }else{
        while(fgets(LineBuf,1023,fi)){
        	MSG("%s: Line%d - LineBuf = %s\n",__func__,__LINE__,LineBuf);
        	if(strstr(LineBuf,"TORRENT_RECORD"))
        	    queue_num++;
        	fputs(LineBuf,fo);
        }
        
        //printf("add_count:%d  queue_num:%d  MAX_QUEUE:%d \n",add_count,queue_num,MAX_QUEUE);
        
        if(queue_num < MAX_QUEUE){
        	for(i=0;i<add_count && queue_num < MAX_QUEUE;i++){
        		MSG("%s: Line %d - ADD_FILE[%d].filename = %s, ADD_FILE[%d].time = %s, ADD_FILE[%d].execute = %s\n",__func__,__LINE__,i,ADD_FILE[i].filename,i,ADD_FILE[i].time,i,ADD_FILE[i].execute);
		    //printf("******ADD_FILE[%d].execute=%s  t1:%d  t2:%d\n",i,ADD_FILE[i].execute,(!strcmp(ADD_FILE[i].execute,"1")), strlen(ADD_FILE[i].time));
        	    if(strlen(ADD_FILE[i].filename)){
        	        if((!strcmp(ADD_FILE[i].execute,"1")) && strlen(ADD_FILE[i].time)){
	        	    	queue_num++;
	                        fprintf(fo,"TORRENT_RECORD%d=%s,%s,%s,%s,%s,%s,%s,%s,%s",queue_num,ADD_FILE[i].filename,new_download.dirname,new_download.hours,new_download.port,new_download.max_peer,new_download.min_peer,new_download.max_bw,new_download.min_bw,ADD_FILE[i].time);
	                        MSG("Line %d - TORRENT_RECORD%d=%s,%s,%s,%s,%s,%s,%s,%s,%s",__LINE__,queue_num,ADD_FILE[i].filename,new_download.dirname,new_download.hours,new_download.port,new_download.max_peer,new_download.min_peer,new_download.max_bw,new_download.min_bw,ADD_FILE[i].time);
	                        //printf("****true: TIME time:%s\n",ADD_FILE[i].time);
                    	}
                    	else{
	                        queue_num++;
	                        fprintf(fo,"TORRENT_RECORD%d=%s,%s,%s,%s,%s,%s,%s,%s,\n",queue_num,ADD_FILE[i].filename,new_download.dirname,new_download.hours,new_download.port,new_download.max_peer,new_download.min_peer,new_download.max_bw,new_download.min_bw);
	                        MSG("Line %d - TORRENT_RECORD%d=%s,%s,%s,%s,%s,%s,%s,%s,\n",__LINE__,queue_num,ADD_FILE[i].filename,new_download.dirname,new_download.hours,new_download.port,new_download.max_peer,new_download.min_peer,new_download.max_bw,new_download.min_bw);
	                        //printf("****false: TIME from_execute_time:%s\n",ADD_FILE[i].time);
                    }
                }
            }
        }
    }
    fclose(fi);
    fclose(fo);
    sprintf(command,"/bin/mv /var/run/duplicate_config /mnt/%s/.%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
    MSG("%s: Line%d - command = %s\n",__func__,__LINE__,command);
    my_system(out,command);
    my_system(out,"/bin/rm -f /var/run/duplicate_config");                                       
    fprintf(out,"<script language=\"JavaScript\">\n");
    fprintf(out,"location.replace('http://%s:%s/torrent_config.cgi');\n",CONFIG.IP,CONFIG.ADMIN_PORT);
    fprintf(out,"</script>\n");
}

//CGI to delete the xxx.torrent.status and queue 
void torrent_management(char *data, FILE *out){
	
	FILE *fi, *fo;
	char *ptr, *end;
	int i, count=0, record_no=1, to_delete=0, mark=0;
	char command[1024], LineBuf[1024], compare[1024], DataBuf[256];
	DELETE_DATA del_torrent[60];
	
	parse_del_torrent(&count,del_torrent,data);
	MSG("%s: Line%d - count = %d\n",__func__,__LINE__,count);
	// ==================== DELETE ====================
	//1. Erase the record in Torrent configuration file
	sprintf(command,"/mnt/%s/.%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
	if((fi = fopen(command,"r")) == NULL)
	    return;
	if((fo = fopen("/var/run/del_torrent","w+")) == NULL)
	    return;
	while(fgets(LineBuf,1023,fi)){
		to_delete = 0;
	    if(strstr(LineBuf,"TORRENT_RECORD")){
	    	ptr = strchr(LineBuf,'=');
	    	ptr++;
	    	for(i=0;i<count;i++){
	    		if(strstr(del_torrent[i].filename,".torrent.status")){
	    		    strcpy(compare,del_torrent[i].filename);
	    		    end = strrchr(compare,'.');
	    		    *end = '\0';
	    		    MSG("%s: Line %d - compare = %s\n",__func__,__LINE__,compare);
	    		}else{
	    		    strcpy(compare,del_torrent[i].filename);
	    		}
	    		if(strstr(ptr,compare)){    //To be deleted!!
	    			to_delete = 1;
	    			mark = i;
	    			break;
	    		}
		    }
		    if(to_delete == 0){
		        MSG("%s: Line %d - record_no = %d\n",__func__,__LINE__,record_no);
		        fprintf(fo,"TORRENT_RECORD%d=%s",record_no,ptr);
		        record_no++;
		    }else{
		        end = strchr(ptr,',');
		        *end = '\0';
		        end = strrchr(ptr,'/');
		        *end = '\0';
		        strcpy(del_torrent[mark].dirname,ptr);
		        MSG("%s: Line %d - del_torrent[%d].dirname = %s\n",__func__,__LINE__,mark,del_torrent[mark].dirname);
		        MSG("%s: Line %d - del_torrent[%d].filename = %s\n",__func__,__LINE__,mark,del_torrent[mark].filename);
		    }
		}
	}
	fclose(fi);
	fclose(fo);
	sprintf(command,"/bin/mv /var/run/del_torrent /mnt/%s/.%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
	system(command);
	system("/bin/rm -f /var/run/del_torrent");
	//2. Kill the download process and change the status
	for(i=0;i<count;i++){
		MSG("%s: Line%d - del_torrent[%d].filename\n",__func__,__LINE__,i);
		if(strstr(del_torrent[i].filename,".torrent.status")){
			strcpy(command,"/mnt/");
			strcat(command,CONFIG.TCONFIG_FOLDER);
			strcat(command,"/");
			strcat(command,del_torrent[i].filename);
			MSG("%s: Line%d - command = %s\n",__func__,__LINE__,command);
			if((fi = fopen(command,"r")) != NULL){
                MSG("%s: Line%d - command = %s\n",__func__,__LINE__,command);
				fo = fopen("/var/run/change_status","w+");
			    while(fgets(DataBuf,255,fi)){
			    	MSG("%s: Line%d - DataBuf = %s\n",__func__,__LINE__,DataBuf);
			    	if((ptr = strstr(DataBuf,"PID :")) != NULL){
				        ptr += 6;
				        end = strchr(ptr,'\n');
				        *end = '\0';
				        strcpy(del_torrent[i].pid,ptr);
				        MSG("%s: Line %d - del_torrent[%d].pid = %s\n",__func__,__LINE__,i,del_torrent[i].pid);
				        fputs(DataBuf,fo);
			        }else if((ptr = strstr(DataBuf,"Status     :")) != NULL){
			        	fprintf(fo,"Status     : done\n");
			        }else if((ptr = strstr(DataBuf,"Check existing pieces :")) != NULL){
			        	fprintf(fo,"Status     : done\n");
			        }else{
			            fputs(DataBuf,fo);
			        }
			    }
			    fclose(fi);
			    fclose(fo);
			    //sprintf(command,"/bin/mv /var/run/change_status /mnt/%s/%s",CONFIG.TCONFIG_FOLDER,del_torrent[i].filename);
			    //MSG("%s: Line%d - command = %s\n",__func__,__LINE__,command);
			    //system(command);
			}
            strcpy(command,"/mnt/");
		    strcat(command,CONFIG.TCONFIG_FOLDER);
		    strcat(command,"/");
		    strcat(command,del_torrent[i].filename);
		    MSG("%s: Line%d - command = %s\n",__func__,__LINE__,command);
            fo = fopen(command,"w+");
            fi = fopen("/var/run/change_status","r");
            if((fi != NULL) && (fo != NULL)){
            	while(fgets(DataBuf,255,fi))
            		fputs(DataBuf,fo);
            	fclose(fi);
            	fclose(fo);
            }
            system("/bin/rm -f /var/run/change_status");
		}else{
		    MSG("%s: Line %d\n",__func__,__LINE__);
		    strcpy(del_torrent[i].pid,"0");
		}
	}
	for(i=0;i<count;i++){
		if(strcmp(del_torrent[i].pid,"0")){
		    sprintf(command,"kill -9 %s",del_torrent[i].pid);
		    system(command);
		}
	}
	fprintf(out,"<script language=\"JavaScript\">\n");
    fprintf(out,"location.replace('http://%s:%s/torrent_config.cgi');\n",CONFIG.IP,CONFIG.ADMIN_PORT);
    fprintf(out,"</script>\n");
}

//To parser the delete string
void parse_del_torrent(int *count,DELETE_DATA *del_torrent,char *get_data){
	
	int i=0;
	DELETE_DATA *p;
	char *ptr, *end;
	
	p = del_torrent; 
	ptr = get_data;
	MSG("%s: Line%d - ptr = %s\n",__func__,__LINE__,ptr);
	
	while(ptr != NULL){
		if(i < 60){
		    end = strchr(ptr,'=');
		    if(end != NULL)
		        *end = '\0';
		      if(!strcmp(ptr,"save_torrent"))
		        break;
				      if(!strcmp(ptr,"del_t")){
				    	  ptr = end + 1;
				    	  end = strchr(ptr,'&');
				    	  if(end != NULL){
						    		*end = '\0';
						    		httpd_decode(ptr);
						    		MSG("%s: Line%d - ptr = %s\n",__func__,__LINE__,ptr);
						    		strcpy(&(p->filename[0]),ptr);
						    		*count+=1;
						    		i++;
						    		p++;
						    		ptr = end + 1;
				    		}
		    }
		}
	}
}

//To parser the download string
void parse_download_torrent(int *add_count,DOWNLOAD_DATA *ADD_FILE,char *get_data){
	
	int i=0;
	DOWNLOAD_DATA *p;
	char *ptr, *end;
	
	p = ADD_FILE; 
	ptr = get_data;
	MSG("%s: Line%d - ptr = %s\n",__func__,__LINE__,ptr);
	while(ptr != NULL){
		if(i < 60){
		    end = strchr(ptr,'=');
		    if(end != NULL)
		        *end = '\0';
		    if(!strcmp(ptr,"set_torrent"))
		        break;
		    if(!strcmp(ptr,"torrent_file")){
		    	ptr = end + 1;
		    	end = strchr(ptr,'&');
		    	if(end != NULL){
		    		*end = '\0';
		    		httpd_decode(ptr);
		    		MSG("%s: Line%d - ptr = %s\n",__func__,__LINE__,ptr);
		    		strcpy(&(p->filename[0]),ptr);
		    		p->time[0] = '\0';
		    		*add_count+=1;
		    		i++;
		    		p++;
		    		ptr = end + 1;
		    	}
		    }
		}
	}
}

//To kill the process
void kill_finished_process(char *dir_name,char *file_name, char *pid){
	
	FILE *fi, *fo;
	char *ptr;
	int no_count=1;
	char open_file[4096], LineBuf[1024], command[256], compare[256];
	
	MSG("%s: Line %d - dir_name = %s, file_name = %s, pid = %s\n",__func__,__LINE__,dir_name,file_name,pid);
	//1. Write "Status     : killed" in xxx.torrent.status 
	strcpy(open_file,dir_name);
	strcat(open_file,"/");
	strcat(open_file,file_name);
	if((fi = fopen(open_file,"r")) == NULL)
	    return;
	if((fo = fopen("/var/run/finish_status","w+")) == NULL)
	    return;
	while(fgets(LineBuf,1023,fi)){
		if((ptr = strstr(LineBuf,"Status     :")) != NULL){
			fprintf(fo,"Status     : done\n");
		}else{
		    fputs(LineBuf,fo);
		}
	}
	fclose(fi);
	fclose(fo);
	sprintf(command,"/bin/mv /var/run/finish_status %s",open_file);
	system(command);
	system("/bin/rm -f /var/run/finish_status");
	//2. Erase the torrent record in config
	strcpy(compare,file_name);
	ptr = strrchr(compare,'.');
	*ptr = '\0';
	sprintf(open_file,"/mnt/%s/.%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
    MSG("%s: Line %d -- open_file = %s, compare = %s\n",__func__,__LINE__,open_file,compare);
    if((fi = fopen(open_file,"r")) == NULL)
        return;
    if((fo = fopen("/var/run/dup_tconfig","w+")) == NULL)
        return;
    while((ptr = fgets(LineBuf,1023,fi)) != NULL){
    	if((ptr = strstr(LineBuf,"TORRENT_RECORD")) != NULL){
    		ptr = strchr(LineBuf,'=');
    		ptr++;
    		if(!strstr(ptr,compare)){
    			fprintf(fo,"TORRENT_RECORD%d=%s",no_count,ptr);
    			no_count++;
    		}
    	}
    }
    fclose(fi);
    fclose(fo);
    sprintf(command,"/bin/mv /var/run/dup_tconfig /mnt/%s/.%s",CONFIG.TCONFIG_FOLDER,CONFIG.TCONFIG_FILENAME);
    system(command);
    system("rm -f /var/run/dup_tconfig");
	//3. Kill the process
	sprintf(command,"kill -9 %s",pid);
	system(command);
}

void Set_webserver(char *data, FILE *out){
	
	FILE *fp;
	char command[100];
	char data_bk[128]; //data has to be backuped so that it can be passed into RestartSystem()
	int change_aport = 0, change_wport = 0, i;
	char new_enable[2], new_admin_port[6], new_web_port[6], LineBuf[256], dir[30];
	
	strncpy(data_bk,data,128);//data has to be backuped so that it can be passed into RestartSystem()
	ARGUMENT args[]={
		{"admin_port",new_admin_port,6},
        {"web_enable",new_enable,2},
        {"web_port",new_web_port,6},    
        {"mnt_dir",CONFIG.WEB_FOLDER,MAX_NAME},
        {NULL,NULL,0}
    };
    parseargs(data,args);
    MSG("%s: Line %d - new_enable = %s, CONFIG.WEB_ENABLE = %s\n",__func__,__LINE__,new_enable,CONFIG.WEB_ENABLE);
    MSG("%s: Line %d - web_port = %s, mnt_dir = %s\n",__func__,__LINE__,CONFIG.WEB_PORT,CONFIG.WEB_FOLDER);
    if(!strcmp(new_enable,"1") && !strcmp(CONFIG.WEB_ENABLE,"1")){          //Previously enable, currently enable
    	MSG("%s: Line %d\n",__func__,__LINE__);
    	//check port number if used by other application
    	if(strcmp(new_web_port,CONFIG.WEB_PORT)){
    		change_wport = 1;
    		sprintf(dir,"/mnt/%s",CONFIG.TCONFIG_FOLDER);
	        search_torrent_file(dir,0);
	        chdir("/htdocs");
	    	for(i=0;i<MAX_TORRENT;i++){
	    		if(strlen(status_record[i].filename) && !strcmp(new_web_port,status_record[i].listen_port)){
	    			if((fp=fopen("/htdocs/torrent_head.htm","r")) == NULL){
					    return;
					}else{
					    while(fgets(LineBuf,255,fp) != NULL)
				            fprintf(out,"%s",LineBuf);
				        fclose(fp);
				    }
				    fprintf(out,"<tr><td></td></tr><tr><td></td></tr>\n");
				    fprintf(out,"<tr><td><font color=\"#FFFFFF\">The port number assigned for WEB server port is being used by P2P. Please change it.</font></td></tr>\n");
				    fprintf(out,"<tr><td align=\"center\"><input type=\"button\" value=\"Back\" onclick=\"history.back()\"></td></tr>\n");
				    fprintf(out,"</table></body></html>\n");
				    return;
				}
			}
		}
		strcpy(CONFIG.WEB_PORT,new_web_port);
    	write_services(1);
    	my_system(out,"killall thttpd");
    	//sprintf(command,"/sbin/thttpd -p %s -d /mnt/%s -r &",CONFIG.WEB_PORT,CONFIG.WEB_FOLDER);
    	//my_system(out,command);
    	my_system(out,"killall inetd");
    	my_system(out,"inetd");
    }else if(!strcmp(new_enable,"1") && !strcmp(CONFIG.WEB_ENABLE,"0")){    //Previously disable, currently enable
    	MSG("%s: Line %d\n",__func__,__LINE__);
    	//check port number if used by other application
    	if(strcmp(new_web_port,CONFIG.WEB_PORT)){
    		change_wport = 1;
    		sprintf(dir,"/mnt/%s",CONFIG.TCONFIG_FOLDER);
	        search_torrent_file(dir,0);
	        chdir("/htdocs");
	    	for(i=0;i<MAX_TORRENT;i++){
	    		if(strlen(status_record[i].filename) && !strcmp(new_web_port,status_record[i].listen_port)){
	    			if((fp=fopen("/htdocs/torrent_head.htm","r")) == NULL){
					    return;
					}else{
					    while(fgets(LineBuf,255,fp) != NULL)
				            fprintf(out,"%s",LineBuf);
				        fclose(fp);
				    }
				    fprintf(out,"<tr><td></td></tr><tr><td></td></tr>\n");
				    fprintf(out,"<tr><td><font color=\"#FFFFFF\">The port number assigned for WEB server port is being used by P2P. Please change it.</font></td></tr>\n");
				    fprintf(out,"<tr><td align=\"center\"><input type=\"button\" value=\"Back\" onclick=\"history.back()\"></td></tr>\n");
				    fprintf(out,"</table></body></html>\n");
				    return;
				}
			}
		}
    	strcpy(CONFIG.WEB_ENABLE,new_enable);
    	strcpy(CONFIG.WEB_PORT,new_web_port);
    	write_services(2);
    	//sprintf(command,"/sbin/thttpd -p %s -d /mnt/%s -r &",CONFIG.WEB_PORT,CONFIG.WEB_FOLDER);
    	//my_system(out,command);
    	my_system(out,"killall inetd");
    	my_system(out,"inetd");
    }else if(!strcmp(new_enable,"0") && !strcmp(CONFIG.WEB_ENABLE,"1")){    //Previous enable, currently disable
    	MSG("%s: Line %d\n",__func__,__LINE__);
    	strcpy(CONFIG.WEB_ENABLE,new_enable);
    	//strcpy(CONFIG.WEB_PORT,"");
    	strcpy(CONFIG.WEB_FOLDER,"");
    	write_services(3);
    	my_system(out,"killall thttpd");
    	my_system(out,"killall inetd");
    	my_system(out,"inetd");
    }else if(!strcmp(new_enable,"0") && !strcmp(CONFIG.WEB_ENABLE,"0")){    //Previous disable, currently disable
    	MSG("%s: Line %d\n",__func__,__LINE__);
    	//strcpy(CONFIG.WEB_PORT,"");
    	strcpy(CONFIG.WEB_FOLDER,"");
    }
    if(strcmp(new_admin_port,CONFIG.ADMIN_PORT)){
    	//check port number if used by other application
    	if(change_wport == 0){
    		sprintf(dir,"/mnt/%s",CONFIG.TCONFIG_FOLDER);
	        search_torrent_file(dir,0);
	        chdir("/htdocs");
	    }
    	for(i=0;i<MAX_TORRENT;i++){
    		if(strlen(status_record[i].filename) && !strcmp(new_admin_port,status_record[i].listen_port)){
    			if((fp=fopen("/htdocs/torrent_head.htm","r")) == NULL){
				    return;
				}else{
				    while(fgets(LineBuf,255,fp) != NULL)
			            fprintf(out,"%s",LineBuf);
			        fclose(fp);
			    }
			    fprintf(out,"<tr><td></td></tr><tr><td></td></tr>\n");
			    fprintf(out,"<tr><td><font color=\"#FFFFFF\">The port number assigned for administration port is being used by P2P. Please change it.</font></td></tr>\n");
			    fprintf(out,"<tr><td align=\"center\"><input type=\"button\" value=\"Back\" onclick=\"history.back()\"></td></tr>\n");
			    fprintf(out,"</table></body></html>\n");
			    return;
			}
		}    
    	change_aport = 1;
    	strcpy(CONFIG.ADMIN_PORT,new_admin_port);
    }
    SaveConfiguration();
    if(change_aport == 0){
	    fprintf(out,"<script language=\"JavaScript\">\n");
	    fprintf(out,"location.replace('http://%s:%s/web-server.htm');\n",CONFIG.IP,CONFIG.ADMIN_PORT);
	    fprintf(out,"</script>\n");
	  }else if(change_aport == 1){\
	  	printf("****call Restart_System page=upload\n");
		  Restart_System(data_bk, out );
	}
}

void write_services(int num){
	
	FILE *fi, *fo;
	char *ptr;
	char LineBuf[256];
	
	if((num == 1) || (num == 2)){
		if((fi = fopen("/etc/services","r")) == NULL)                                                    																																																		
		    return;                                                                                      																																																		
		if((fo = fopen("/etc/services2","w+")) == NULL)                                                  																																																		
		    return;                                                                                      																																																		
		while(fgets(LineBuf,255,fi) != NULL){                                                            																																																		
		    if((ptr = strstr(LineBuf,"thttpd")) != NULL){                                                																																																		
		    	sprintf(LineBuf,"thttpd\t\t%s/tcp\n",CONFIG.WEB_PORT);
		        fprintf(fo,"%s",LineBuf);																																																		
		    }else{                                                                                       																																																		
		        fprintf(fo,"%s",LineBuf);                                                                																																																		
		        if(strstr(LineBuf,"# End of services file."))                                            																																																		
		            break;                                                                               																																																		
		    }                                                                                            																																																		
		}          
		system("/bin/mv /etc/services2 /etc/services > /dev/null 2>&1");                                                                                      																																																		
		fclose(fi);                                                                                      																																																		
		fclose(fo);                                                                                      																																																		
	}
	if(num == 2){
		if((fi = fopen("/etc/inetd.conf","r")) == NULL)                                                    																																																		
		    return;                                                                                      																																																		
		if((fo = fopen("/etc/inetd.conf2","w+")) == NULL)                                                  																																																		
		    return;                                                                                      																																																		
		while(fgets(LineBuf,255,fi) != NULL){                                                                                    																																																		
		    fprintf(fo,"%s",LineBuf);                                                                                            																																																		
		}
		fprintf(fo,"thttpd  stream  tcp   nowait  root  /sbin/thttpd -i\n");          
		system("/bin/mv /etc/inetd.conf2 /etc/inetd.conf > /dev/null 2>&1");                                                                                      																																																		
		fclose(fi);                                                                                      																																																		
		fclose(fo);
	}
	if(num == 3){
		if((fi = fopen("/etc/inetd.conf","r")) == NULL)                                                    																																																		
		    return;                                                                                      																																																		
		if((fo = fopen("/etc/inetd.conf2","w+")) == NULL)                                                  																																																		
		    return;                                                                                      																																																		
		while(fgets(LineBuf,255,fi) != NULL){                                                                                    																																																		
		    if(strstr(LineBuf,"thttpd") == NULL){
		    	fprintf(fo,"%s",LineBuf);
		    }                                                                                                 																																																		
		}
		system("/bin/mv /etc/inetd.conf2 /etc/inetd.conf > /dev/null 2>&1");                                                                                      																																																		
		fclose(fi);                                                                                      																																																		
		fclose(fo);
	}																																													
}